/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
'use strict';
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", 'fs', 'path', './git.lib', './rawGitService', '../../lib/temp', '../../lib/utils'], function (require, exports, fs, path, gitlib, service, temp, util) {
    var NativeRawGitService = (function (_super) {
        __extends(NativeRawGitService, _super);
        function NativeRawGitService(gitPath, basePath, defaultEncoding, exePath) {
            if (!gitPath) {
                _super.call(this, null);
                return;
            }
            var gitRootPath = path.resolve(path.join(__dirname, '..', '..', '..', 'git'));
            // TODO@Joao: ugly, this is the path in dev
            if (!fs.existsSync(gitRootPath)) {
                gitRootPath = path.resolve(path.join(__dirname, '..', '..', '..', 'tools', 'atom-shell', 'git'));
            }
            var env = util.mixin({}, process.env);
            env['GIT_ASKPASS'] = path.join(gitRootPath, 'askpass.sh');
            env['VSCODE_GIT_ASKPASS_NODE'] = exePath;
            env['VSCODE_GIT_ASKPASS_SCRIPT'] = path.join(gitRootPath, 'askpass.js');
            var git = new gitlib.Git({
                gitPath: gitPath,
                tmpPath: temp.getOSTempPathSync(),
                defaultEncoding: defaultEncoding,
                env: env
            });
            _super.call(this, git.open(path.normalize(basePath)));
        }
        return NativeRawGitService;
    })(service.RawGitService);
    exports.NativeRawGitService = NativeRawGitService;
});
