/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
'use strict';
define(["require", "exports", './git.config', './rawGitService', '../../lib/service', './nativeRawGitService.impl'], function (require, exports, config, service, servicelib, impl) {
    var remote = require('remote');
    function getNodePath() {
        if (process.platform === 'win32') {
            return require.toUrl('../../../tools/bin/win/node.exe').replace(/^file:\/\/\//, '').replace('/', '\\');
        }
        return remote.process.execPath;
    }
    function createNativeRawGitService(basePath, defaultEncoding) {
        return config.findGit().then(function (gitPath) {
            var connection = servicelib.createService(service.RawGitService, __dirname + '/gitApp.js', {
                timeout: 1000 * 60,
                args: [gitPath, basePath, defaultEncoding, getNodePath()]
            });
            return connection.service;
        }, function () { return new impl.NativeRawGitService(null, null, null, null); });
    }
    exports.createNativeRawGitService = createNativeRawGitService;
});
