/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/annotatedLanguage/csharpTokenization",["require","exports"],function(e,t){t.language2={displayName:"C#",name:"cs",mimeTypes:[],defaultToken:"",lineComment:"// ",blockCommentStart:"/*",blockCommentEnd:"*/",wordDefinition:/(-?\d*\.\d\w*)|([^\`\~\!\#\$\%\^\&\*\(\)\-\=\+\[\{\]\}\\\|\;\:\'\"\,\.\<\>\/\?\s]+)/g,autoClosingPairs:[['"','"'],["'","'"],["{","}"],["[","]"],["(",")"]],brackets:[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}],editorOptions:{tabSize:4,insertSpaces:!0},keywords:["extern","alias","using","bool","decimal","sbyte","byte","short","ushort","int","uint","long","ulong","char","float","double","object","dynamic","string","assembly","module","is","as","ref","out","this","base","new","typeof","void","checked","unchecked","default","delegate","var","const","if","else","switch","case","while","do","for","foreach","in","break","continue","goto","return","throw","try","catch","finally","lock","yield","from","let","where","join","on","equals","into","orderby","ascending","descending","select","group","by","namespace","partial","class","field","event","method","param","property","public","protected","internal","private","abstract","sealed","static","struct","readonly","volatile","virtual","override","params","get","set","add","remove","operator","true","false","implicit","explicit","interface","enum","null","async","await"],namespaceFollows:["namespace","using"],parenFollows:["if","for","while","switch","foreach","using","catch"],operators:["=","??","||","&&","|","^","&","==","!=","<=",">=","<<","+","-","*","/","%","!","~","++","--","+=","-=","*=","/=","%=","&=","|=","^=","<<=",">>=",">>","=>"],symbols:/[=><!~?:&|+\-*\/\^%]+/,escapes:/\\(?:[abfnrtv\\"']|x[0-9A-Fa-f]{1,4}|u[0-9A-Fa-f]{4}|U[0-9A-Fa-f]{8})/,tokenizer:{root:[[/[a-zA-Z_]\w*/,{cases:{"@namespaceFollows":{token:"keyword.$0",next:"@namespace"},"@keywords":{token:"keyword.$0",next:"@qualified"},"@default":{token:"identifier",next:"@qualified"}}}],{include:"@whitespace"},[/}/,{cases:{"$S2==interpolatedstring":{token:"string.quote",bracket:"@close",next:"@pop"},"@default":"@brackets"}}],[/[{}()\[\]]/,"@brackets"],[/[<>](?!@symbols)/,"@brackets"],[/@symbols/,{cases:{"@operators":"operator","@default":""}}],[/@"/,{token:"string.quote",bracket:"@open",next:"@litstring"}],[/\$"/,{token:"string.quote",bracket:"@open",next:"@interpolatedstring"}],[/\d*\.\d+([eE][\-+]?\d+)?[fFdD]?/,"number.float"],[/0[xX][0-9a-fA-F]+/,"number.hex"],[/\d+/,"number"],[/[;,.]/,"delimiter"],[/"([^"\\]|\\.)*$/,"string.invalid"],[/"/,{token:"string.quote",bracket:"@open",next:"@string"}],[/'[^\\']'/,"string"],[/(')(@escapes)(')/,["string","string.escape","string"]],[/'/,"string.invalid"]],qualified:[[/[a-zA-Z_][\w]*/,{cases:{"@keywords":"keyword.$0","@default":"identifier"}}],[/\./,"delimiter"],["","","@pop"]],namespace:[{include:"@whitespace"},[/[A-Z]\w*/,"namespace"],[/[\.=]/,"delimiter"],["","","@pop"]],comment:[[/[^\/*]+/,"comment"],["\\*/","comment","@pop"],[/[\/*]/,"comment"]],string:[[/[^\\"]+/,"string"],[/@escapes/,"string.escape"],[/\\./,"string.escape.invalid"],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],litstring:[[/[^"]+/,"string"],[/""/,"string.escape"],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],interpolatedstring:[[/[^\\"{]+/,"string"],[/@escapes/,"string.escape"],[/\\./,"string.escape.invalid"],[/{{/,"string.escape"],[/}}/,"string.escape"],[/{/,{token:"string.quote",bracket:"@open",next:"root.interpolatedstring"}],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],whitespace:[[/^[ \t\v\f]*#\w.*$/,"namespace.cpp"],[/[ \t\v\f\r\n]+/,""],[/\/\*/,"comment","@comment"],[/\/\/.*$/,"comment"]]}}}),define("vs/editor/core/position",["require","exports"],function(e,t){function r(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column}function n(e){return e?[0|e.lineNumber,0|e.column]:[-1,-1]}function i(e){return-1===e[0]&&-1===e[1]?null:new u(e[0],e[1])}function o(e){for(var t=[],r=0,n=e.length;n>r;r++){var i=e[r];i?(t[2*r+0]=0|i.lineNumber,t[2*r+1]=0|i.column):(t[2*r+0]=-1,t[2*r+1]=-1)}return t}function s(e){for(var t=[],r=0,n=Math.floor(e.length/2);n>r;r++)t[r]=-1===e[2*r+0]&&-1===e[2*r+1]?null:new u(e[2*r+0],e[2*r+1]);return t}t.isIPosition=r,t.serialize=n,t.deserialize=i,t.serializeMany=o,t.deserializeMany=s;var a;!function(e){function t(e){return{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column}}function r(e){return{lineNumber:e.startLineNumber,column:e.startColumn}}function n(e){return{lineNumber:e.endLineNumber,column:e.endColumn}}e.asEmptyRange=t,e.startPosition=r,e.endPosition=n}(a=t.PositionUtils||(t.PositionUtils={}));var u=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.equals=function(e){return!!e&&this.lineNumber===e.lineNumber&&this.column===e.column},e.prototype.isBefore=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<e.column},e.prototype.isBeforeOrEqual=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<=e.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e}();t.Position=u}),define("vs/editor/core/range",["require","exports","vs/editor/core/position"],function(e,t,r){function n(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn}function i(e){return e?[0|e.startLineNumber,0|e.startColumn,0|e.endLineNumber,0|e.endColumn]:[-1,-1,-1,-1]}function o(e){return-1===e[0]&&-1===e[1]&&-1===e[2]&&-1===e[3]?null:new S(e[0],e[1],e[2],e[3])}function s(e){for(var t=[],r=0,n=e.length;n>r;r++){var i=e[r];i?(t[4*r+0]=0|i.startLineNumber,t[4*r+1]=0|i.startColumn,t[4*r+2]=0|i.endLineNumber,t[4*r+3]=0|i.endColumn):(t[4*r+0]=-1,t[4*r+1]=-1,t[4*r+2]=-1,t[4*r+3]=-1)}return t}function a(e){for(var t=[],r=0,n=Math.floor(e.length/4);n>r;r++)t[r]=-1===e[4*r+0]&&-1===e[4*r+1]&&-1===e[4*r+2]&&-1===e[4*r+3]?null:new S(e[4*r+0],e[4*r+1],e[4*r+2],e[4*r+3]);return t}function u(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn}function c(e,t){return t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber?!1:t.lineNumber===e.startLineNumber&&t.column<e.startColumn?!1:t.lineNumber===e.endLineNumber&&t.column>e.endColumn?!1:!0}function l(e,t){return t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber?!1:t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber?!1:t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn?!1:t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn?!1:!0}function p(e,t){return e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn?!1:t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn?!1:!0}function d(e,t){var r=e.startLineNumber,n=e.startColumn,i=e.endLineNumber,o=e.endColumn,s=t.startLineNumber,a=t.startColumn,u=t.endLineNumber,c=t.endColumn;return s>r?(r=s,n=a):r===s&&(n=Math.max(n,a)),i>u?(i=u,o=c):i===u&&(o=Math.min(o,c)),r>i?null:r===i&&n>o?null:new S(r,n,i,o)}function h(e,t){var r,n,i,o;return t.startLineNumber<e.startLineNumber?(r=t.startLineNumber,n=t.startColumn):t.startLineNumber===e.startLineNumber?(r=t.startLineNumber,n=Math.min(t.startColumn,e.startColumn)):(r=e.startLineNumber,n=e.startColumn),t.endLineNumber>e.endLineNumber?(i=t.endLineNumber,o=t.endColumn):t.endLineNumber===e.endLineNumber?(i=t.endLineNumber,o=Math.max(t.endColumn,e.endColumn)):(i=e.endLineNumber,o=e.endColumn),new S(r,n,i,o)}function f(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn}function g(e,t){return e.startLineNumber===t.startLineNumber?e.startColumn===t.startColumn?e.endLineNumber===t.endLineNumber?e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber:e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber}function m(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber}function v(e){return e.endLineNumber>e.startLineNumber}function y(e){return 17*e.startLineNumber+23*e.startColumn+29*e.endLineNumber+37*e.endColumn}function _(e){return{startLineNumber:e.startLineNumber,startColumn:e.startColumn,endLineNumber:e.startLineNumber,endColumn:e.startColumn}}function b(e){return e?new S(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null}t.isIRange=n,t.serialize=i,t.deserialize=o,t.serializeMany=s,t.deserializeMany=a,t.isEmpty=u,t.containsPosition=c,t.containsRange=l,t.areIntersectingOrTouching=p,t.intersectRanges=d,t.plusRange=h,t.equalsRange=f,t.compareRangesUsingStarts=g,t.compareRangesUsingEnds=m,t.spansMultipleLines=v,t.hashCode=y,t.collapseToStart=_;var S=function(){function e(e,t,r,n){e>r||e===r&&t>n?(this.startLineNumber=r,this.startColumn=n,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=r,this.endColumn=n)}return e.prototype.isEmpty=function(){return u(this)},e.prototype.containsPosition=function(e){return c(this,e)},e.prototype.containsRange=function(e){return l(this,e)},e.prototype.plusRange=function(e){return h(this,e)},e.prototype.intersectRanges=function(e){return d(this,e)},e.prototype.equalsRange=function(e){return f(this,e)},e.prototype.getEndPosition=function(){return new r.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new r.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,r){return new e(this.startLineNumber,this.startColumn,t,r)},e.prototype.setStartPosition=function(t,r){return new e(t,r,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return new e(this.startLineNumber,this.startColumn,this.startLineNumber,this.startColumn)},e}();t.Range=S,t.create=b}),define("vs/languages/annotatedLanguage/references",["require","exports"],function(e,t){function r(e,t){var r=t.trange;return{resourceUrl:e.getResourceUrl(t.tref),range:r,preview:{text:t.preview,range:{startLineNumber:1,endLineNumber:1,startColumn:r.startColumn,endColumn:r.endColumn}}}}var n=function(){function e(e,t){this.entries=t,this.path=e}return e.prototype.getReferences=function(){return this.entries},e}();t.References=n,t.createReference=r}),define("vs/languages/annotatedLanguage/annotations",["require","exports","vs/editor/core/range","vs/base/lib/winjs.base","./references","vs/base/paths"],function(e,t,r,n,i,o){var s=function(){function e(e,t){this.codeLensSymbols={type:!0,method:!0,property:!0},this.entries=t,this.resourceURL=e;var r=e.getPath().split("/",2);this.assembly=r[0],this.sourceName=r[1]}return e.prototype.getEntryAtOffset=function(e){for(var t=0;t<this.entries.length;t++){var n=this.entries[t];if(r.containsPosition(n.range,e))return n}return null},e.prototype.findSymbolDecl=function(e){for(var t=0;t<this.entries.length;t++){var r=this.entries[t];if(r.symbolId===e&&"decl"===r.refType)return r}return null},e.prototype.findDeclaration=function(e,t){var r=this.getEntryAtOffset(t);if(!r)return null;if("decl"!==r.refType){if(r.declAssembly&&r.declAssembly!==this.assembly&&!r.declFile)return n.TPromise.as({resourceUrl:e.getResourceUrl(o.join(r.declAssembly,r.symbolId)),range:{startLineNumber:1,endLineNumber:1,startColumn:1,endColumn:1}});if(r.declAssembly&&r.declFile){var i=e.getResourceUrl(o.join(r.declAssembly,r.declFile));if(!i.equals(this.resourceURL))return e.getAnnotations(i,!0).then(function(e){return e.getDeclarationReference(r.symbolId)})}}return n.TPromise.as(this.getDeclarationReference(r.symbolId))},e.prototype.findOccurences=function(e,t){var r=this.getEntryAtOffset(t);return r?n.TPromise.as(this.entries.filter(function(e){return e.symbolId===r.symbolId}).map(function(e){return{kind:"write"===e.refType||"decl"===e.refType?"write":null,range:e.range}})):n.TPromise.as([])},e.prototype.findReferences=function(e,t,r){var o=this,s=this.getEntryAtOffset(r);return s?s.declAssembly?e.getReferences(s,!0).then(function(t){return t.getReferences().map(function(t){return i.createReference(e,t)})}):n.TPromise.as(this.entries.filter(function(e){return e.symbolId===s.symbolId}).map(function(e){var r=e.range,n={startLineNumber:r.startLineNumber,endLineNumber:r.endLineNumber,startColumn:1,endColumn:t.getLineMaxColumn(r.endLineNumber)};return{resourceUrl:o.resourceURL,range:r,preview:{text:t.getValueInRange(n),range:{startLineNumber:1,endLineNumber:1,startColumn:r.startColumn,endColumn:r.endColumn}}}})):null},e.prototype.getOutline=function(){var e=this;return this.entries.filter(function(e){return"decl"===e.refType&&"local"!==e.symbolType&&"param"!==e.symbolType}).map(function(t){return{label:t.label,type:e.getIconType(t),range:t.range}})},e.prototype.computeInfo=function(e){var t=this.getEntryAtOffset(e);if(t&&t.hover){var r=[];return r.push({className:"type",text:t.hover}),n.TPromise.as({range:t.range,htmlContent:r,className:"typeInfo al"})}},e.prototype.findCodeLensSymbols=function(){var e=this;return this.entries.filter(function(t){return"decl"===t.refType&&e.codeLensSymbols[t.symbolType]}).map(function(e){return{id:e.symbolId,range:e.range}})},e.prototype.getIconType=function(e){switch(e.symbolType){case"type":return"class";case"local":return"variable";case"param":return"variable";case"property":return"property";case"event":return"property";case"field":return"property";case"method":return"function"}return null},e.prototype.getDeclarationReference=function(e){var t=this.findSymbolDecl(e);if(t){var r=t.range;return{resourceUrl:this.resourceURL,range:r,preview:{text:t.preview,range:{startLineNumber:1,endLineNumber:1,startColumn:r.startColumn,endColumn:r.endColumn}}}}return null},e}();t.Annotations=s}),define("vs/languages/annotatedLanguage/annotatedResourceService",["require","exports","vs/base/network","vs/platform/services","vs/base/lib/winjs.base","./annotations","./references","vs/base/errors"],function(e,t,r,n,i,o,s,a){var u=function(){function e(e){this.contextServiceRoot="inmemory://model/",this.requestService=e.requestService,this.contextService=e.contextService,this.instantiationService=e.instantiationService,this.referencesStore={},this.annotationsStore={},this.annotationRequestServicePromise=null}return e.prototype.getAnnotationRequestService=function(){if(!this.annotationRequestServicePromise){var e=this.contextService.getOptions().annotationRequestService;if(e){var t=n.AsyncDescriptor.create(e.moduleName,e.ctorName);this.annotationRequestServicePromise=this.instantiationService.createInstance(t).then(function(e){return e},function(e){return i.TPromise.wrapError("Unable to instanciate "+t.moduleName+" / "+t.ctorName+": "+e)})}else this.annotationRequestServicePromise=i.TPromise.wrapError("annotationRequestService is not specified in the context options.")}return this.annotationRequestServicePromise},e.prototype.getAnnotations=function(e,t){var r=this.getPath(e),n=this.annotationsStore[r];return!n&&t&&(n=this.getAnnotationRequestService().then(function(t){return t.getAnnotations(r).then(function(t){var r=new o.Annotations(e,t);return r},function(t){return a.onUnexpectedError(t),new o.Annotations(e,[])})},function(t){return a.onUnexpectedError(t),new o.Annotations(e,[])}),this.annotationsStore[r]=n),n},e.prototype.getReferences=function(e,t){var r=e.symbolId,n=this.referencesStore[r];return!n&&t&&(n=this.getAnnotationRequestService().then(function(t){return t.getReferences(e.declAssembly,r).then(function(e){return new s.References(r,e)},function(e){return a.onUnexpectedError(e),new s.References(r,[])})},function(e){return a.onUnexpectedError(e),new s.References(r,[])}),this.referencesStore[r]=n),n},e.prototype.getResourceUrl=function(e){return new r.URL(this.contextServiceRoot+e)},e.prototype.getPath=function(e){return e.toString().substring(this.contextServiceRoot.length)},e}();t.AnnotatedResourceService=u});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/annotatedLanguage/annotatedLanguage",["require","exports","vs/base/lib/winjs.base","./csharpTokenization","vs/editor/modes/supports","./annotatedResourceService","vs/editor/modes/monarch/monarch","vs/editor/modes/monarch/monarchCompile"],function(e,t,r,n,i,o,s,a){function u(e){var t={};for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);return t}var c=u(n.language2),l=function(e){function t(t,r){var n=this;e.call(this,t,r,a.compile(c)),this.modelService=t.modelService,this.suggestSupport=null,this.inplaceReplaceSupport=null,this.extraInfoSupport=this,this.referenceSupport=new i.ReferenceSupport(this,{tokens:["identifier.cs"],findReferences:function(e,t){return n.findReferences(e,t)}}),this.outlineSupport=this,this.declarationSupport=new i.DeclarationSupport(this,{tokens:["identifier.cs"],findDeclaration:function(e,t){return n.findDeclaration(e,t)}}),this.codeLensSupport=this,this.annotatedResourceService=t.instantiationService.createInstance(o.AnnotatedResourceService)}return __extends(t,e),t.prototype.computeInfo=function(e,t){return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.computeInfo(t):null})},t.prototype.findOccurrences=function(e,t){var r=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.findOccurences(r.annotatedResourceService,t):null})},t.prototype.findReferences=function(e,t){var r=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(n){if(n){var i=r.modelService.getModel(e);return n.findReferences(r.annotatedResourceService,i,t)}return null})},t.prototype.findDeclaration=function(e,t){var r=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.findDeclaration(r.annotatedResourceService,t):null})},t.prototype.getOutline=function(e){return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.getOutline():null})},t.prototype.enableCodeLens=function(){return!0},t.prototype.findCodeLensSymbols=function(e){return this.annotatedResourceService.getAnnotations(e,!0).then(function(e){return e?e.findCodeLensSymbols():null})},t.prototype.findCodeLensReferences=function(e,t){var n=this;return this.annotatedResourceService.getAnnotations(e,!0).then(function(i){return i?r.Promise.join(t.map(function(t){var r=n.modelService.getModel(e);return i.findReferences(n.annotatedResourceService,r,t.position)})).then(function(e){return{references:e,languageModeStateId:1}}):null})},t}(s.MonarchMode);t.ALMode=l});