/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/css/services/cssLanguageService",["require","exports","vs/base/lib/winjs.base","vs/platform/services","vs/editor/core/model/mirrorModel"],function(e,t,r,n,i){var o=function(e){function t(){var t=this;e.call(this,function(e,r){t._valueCallback=e,t._errorCallback=r})}return __extends(t,e),t.prototype.resolve=function(e){return this._valueCallback(e),this},t.prototype.reject=function(e){return this._errorCallback(e),this},t}(r.TPromise),s=function(){function e(e,t,r){var n=this;this._cssModeId=r,this.resourceService=e,this.entries={},this.callOnDispose=[],this.createParser=t,this.updateResources(),this.callOnDispose.push(this.resourceService.addBulkListener(function(e){return n.onChange(e)}))}return e.prototype.dispose=function(){for(;this.callOnDispose.length>0;)this.callOnDispose.pop()();clearTimeout(this.onChangeHandle),this.onChangeHandle=null,this.entries=null},e.prototype.onChange=function(e){for(var t=this,r=0,i=e.length;i>r;r++){var s=e[r];if(s.getType()===n.ResourceEvents.REMOVED){var a=s.getData(),u=a.url.toString();this.entries.hasOwnProperty(u)&&delete this.entries[u]}}this.activeDelay||(this.activeDelay=new o),this.onChangeHandle&&clearTimeout(this.onChangeHandle),this.onChangeHandle=setTimeout(function(){t.updateResources(),t.activeDelay.resolve(null),t.activeDelay=null,t.onChangeHandle=null},50)},e.prototype.join=function(){return this.activeDelay||r.Promise.as(null)},e.prototype.updateResources=function(){var e=this,t=((new Date).getTime(),0);this.resourceService.all().filter(function(t){return t instanceof i.MirrorModel||t instanceof i.MirrorModelEmbedded?t.getModeId()===e._cssModeId:!1}).forEach(function(r){var n=r.getAssociatedResource().toString(),i=e.entries[n],o="undefined"!=typeof i;o&&i.version===r.getVersionId()||(o||(i={node:null,version:-1},e.entries[n]=i),i.node=e.createParser().parseStylesheet(r),i.node.setName(n),i.version=r.getVersionId(),t+=1)})},e.prototype.getStylesheet=function(e){return this.entries.hasOwnProperty(e.toString())?this.entries[e.toString()].node:null},e}();t.CSSLanguageService=s});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/css/parser/cssNodes",["require","exports","vs/base/types"],function(e,t,r){function n(e,t){var r=null;return!e||t<e.offset||t>e.offset+e.length?null:(e.accept(function(e){return-1===e.offset&&-1===e.length?!0:e.offset<=t&&e.offset+e.length>=t?(r?e.length<=r.length&&(r=e):r=e,!0):!1}),r)}function i(e,t){for(var r=n(e,t),i=[];r;)i.unshift(r),r=r.parent;return i}function o(e){var t=e.findParent(s.Declaration);return t&&t.getValue()&&t.getValue().encloses(e)?t:null}!function(e){e[e.Undefined=0]="Undefined",e[e.Identifier=1]="Identifier",e[e.Stylesheet=2]="Stylesheet",e[e.Ruleset=3]="Ruleset",e[e.Selector=4]="Selector",e[e.SimpleSelector=5]="SimpleSelector",e[e.SelectorInterpolation=6]="SelectorInterpolation",e[e.SelectorCombinator=7]="SelectorCombinator",e[e.SelectorCombinatorParent=8]="SelectorCombinatorParent",e[e.SelectorCombinatorSibling=9]="SelectorCombinatorSibling",e[e.SelectorCombinatorAllSiblings=10]="SelectorCombinatorAllSiblings",e[e.Page=11]="Page",e[e.PageBoxMarginBox=12]="PageBoxMarginBox",e[e.ClassSelector=13]="ClassSelector",e[e.IdentifierSelector=14]="IdentifierSelector",e[e.ElementNameSelector=15]="ElementNameSelector",e[e.PseudoSelector=16]="PseudoSelector",e[e.AttributeSelector=17]="AttributeSelector",e[e.Declaration=18]="Declaration",e[e.Declarations=19]="Declarations",e[e.Property=20]="Property",e[e.Expression=21]="Expression",e[e.BinaryExpression=22]="BinaryExpression",e[e.Term=23]="Term",e[e.Operator=24]="Operator",e[e.Value=25]="Value",e[e.StringLiteral=26]="StringLiteral",e[e.URILiteral=27]="URILiteral",e[e.EscapedValue=28]="EscapedValue",e[e.Function=29]="Function",e[e.NumericValue=30]="NumericValue",e[e.HexColorValue=31]="HexColorValue",e[e.MixinDeclaration=32]="MixinDeclaration",e[e.MixinReference=33]="MixinReference",e[e.VariableName=34]="VariableName",e[e.VariableDeclaration=35]="VariableDeclaration",e[e.Prio=36]="Prio",e[e.Interpolation=37]="Interpolation",e[e.NestedProperties=38]="NestedProperties",e[e.ExtendsReference=39]="ExtendsReference",e[e.SelectorPlaceholder=40]="SelectorPlaceholder",e[e.Debug=41]="Debug",e[e.If=42]="If",e[e.Else=43]="Else",e[e.For=44]="For",e[e.Each=45]="Each",e[e.While=46]="While",e[e.MixinContent=47]="MixinContent",e[e.Media=48]="Media",e[e.Keyframe=49]="Keyframe",e[e.FontFace=50]="FontFace",e[e.Import=51]="Import",e[e.Namespace=52]="Namespace",e[e.Invocation=53]="Invocation",e[e.FunctionDeclaration=54]="FunctionDeclaration",e[e.ReturnStatement=55]="ReturnStatement",e[e.MediaQuery=56]="MediaQuery",e[e.FunctionParameter=57]="FunctionParameter",e[e.FunctionArgument=58]="FunctionArgument",e[e.KeyframeSelector=59]="KeyframeSelector",e[e.MSViewPort=60]="MSViewPort",e[e.Document=61]="Document"}(t.NodeType||(t.NodeType={}));var s=t.NodeType;!function(e){e[e.Mixin=0]="Mixin",e[e.Rule=1]="Rule",e[e.Variable=2]="Variable",e[e.Function=3]="Function",e[e.Keyframe=4]="Keyframe",e[e.Unknown=5]="Unknown"}(t.ReferenceType||(t.ReferenceType={}));t.ReferenceType;t.getNodeAtOffset=n,t.getNodePath=i,t.getParentDeclaration=o;var a=function(){function e(e,t,r){void 0===e&&(e=-1),void 0===t&&(t=-1),this.parent=null,this.offset=e,this.length=t,r&&(this.nodeType=r)}return Object.defineProperty(e.prototype,"type",{get:function(){return this.nodeType||s.Undefined},set:function(e){this.nodeType=e},enumerable:!0,configurable:!0}),e.prototype.getTextProvider=function(){for(var e=this;e&&!e.textProvider;)e=e.parent;return e?e.textProvider:function(){return"unknown"}},e.prototype.getText=function(){return this.getTextProvider()(this.offset,this.length)},e.prototype.matches=function(e){return this.length===e.length&&this.getTextProvider()(this.offset,this.length)===e},e.prototype.startsWith=function(e){return this.length>=e.length&&this.getTextProvider()(this.offset,e.length)===e},e.prototype.endsWith=function(e){return this.length>=e.length&&this.getTextProvider()(this.offset+this.length-e.length,e.length)===e},e.prototype.accept=function(e){r.isFunction(e)||(e=e.visitNode.bind(e)),e(this)&&this.children&&this.children.forEach(function(t){t.accept(e)})},e.prototype.adoptChild=function(e,t){if(void 0===t&&(t=-1),e.parent&&e.parent.children){var r=e.parent.children.indexOf(e);r>=0&&e.parent.children.splice(r,1)}e.parent=this;var n=this.children;return n||(n=this.children=[]),-1!==t?n.splice(r,0,e):n.push(e),e},e.prototype.attachTo=function(e,t){return void 0===t&&(t=-1),e&&e.adoptChild(this,t),this},e.prototype.collectIssues=function(e){this.issues&&e.push.apply(e,this.issues)},e.prototype.addIssue=function(e){this.issues||(this.issues=[]),this.issues.push(e)},e.prototype.hasIssue=function(e){return this.issues&&this.issues.some(function(t){return t.getRule()===e})},e.prototype.isErroneous=function(){return this.issues&&this.issues.length>0},e.prototype.setNode=function(e,t,r){return void 0===r&&(r=-1),t?(t.attachTo(this,r),this[e]=t,!0):!1},e.prototype.addChild=function(e){return e?(this.children||(this.children=[]),e.attachTo(this),this.updateOffsetAndLength(e),!0):!1},e.prototype.updateOffsetAndLength=function(e){(e.offset<this.offset||-1===this.offset)&&(this.offset=e.offset),(e.offset+e.length>this.offset+this.length||-1===this.length)&&(this.length=e.offset+e.length-this.offset)},e.prototype.hasChildren=function(){return this.children&&this.children.length>0},e.prototype.getChildren=function(){return this.children?this.children.slice(0):[]},e.prototype.getChild=function(e){return this.children&&e<this.children.length?this.children[e]:null},e.prototype.addChildren=function(e){var t=this;e.forEach(function(e){return t.addChild(e)})},e.prototype.findFirstChildBeforeOffset=function(e){if(this.children)for(var t=null,r=this.children.length-1;r>=0;r--)if(t=this.children[r],t.offset<=e)return t;return null},e.prototype.findChildAtOffset=function(e,t){var r=this.findFirstChildBeforeOffset(e);return r&&r.offset+r.length>=e?t?r.findChildAtOffset(e,!0)||r:r:null},e.prototype.encloses=function(e){return this.offset<=e.offset&&this.offset+this.length>=e.offset+e.length},e.prototype.getParent=function(){for(var e=this.parent;e instanceof u;)e=e.parent;return e},e.prototype.findParent=function(e){for(var t=this;t&&t.type!==e;)t=t.parent;return t},e.prototype.setData=function(e,t){this.options||(this.options={}),this.options[e]=t},e.prototype.getData=function(e){return this.options&&this.options.hasOwnProperty(e)?this.options[e]:null},e}();t.Node=a;var u=function(e){function t(t,r){void 0===r&&(r=-1),e.call(this,-1,-1),this.attachTo(t,r),this.offset=-1,this.length=-1}return __extends(t,e),t}(a);t.Nodelist=u;var c=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Identifier},enumerable:!0,configurable:!0}),t.prototype.containsInterpolation=function(){return this.hasChildren()},t}(a);t.Identifier=c;var l=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Stylesheet},enumerable:!0,configurable:!0}),t.prototype.setName=function(e){this.name=e},t}(a);t.Stylesheet=l;var p=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Declarations},enumerable:!0,configurable:!0}),t}(a);t.Declarations=p;var h=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),t.prototype.getDeclarations=function(){return this.declarations},t.prototype.setDeclarations=function(e){return this.setNode("declarations",e)},t}(a);t.BodyDeclaration=h;var d=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Ruleset},enumerable:!0,configurable:!0}),t.prototype.getSelectors=function(){return this.selectors||(this.selectors=new u(this)),this.selectors},t.prototype.isNested=function(){return this.parent&&null!==this.parent.findParent(s.Ruleset)},t}(h);t.RuleSet=d;var f=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Selector},enumerable:!0,configurable:!0}),t}(a);t.Selector=f;var g=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.SimpleSelector},enumerable:!0,configurable:!0}),t}(a);t.SimpleSelector=g;var m=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Declaration},enumerable:!0,configurable:!0}),t.prototype.setProperty=function(e){return this.setNode("property",e)},t.prototype.getProperty=function(){return this.property},t.prototype.getFullPropertyName=function(){var e=this.property?this.property.getName():"unknown";if(this.parent instanceof p&&this.parent.getParent()instanceof M){var r=this.parent.getParent().getParent();if(r instanceof t)return r.getFullPropertyName()+e}return e},t.prototype.getNonPrefixedPropertyName=function(){var e=this.getFullPropertyName();if(e&&"-"===e.charAt(0)){var t=e.indexOf("-",1);if(-1!==t)return e.substring(t+1)}return e},t.prototype.setValue=function(e){return this.setNode("value",e)},t.prototype.getValue=function(){return this.value},t.prototype.setNestedProperties=function(e){return this.setNode("nestedProprties",e)},t.prototype.getNestedProperties=function(){return this.nestedProprties},t}(a);t.Declaration=m;var v=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Property},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.getText()},t}(a);t.Property=v;var y=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Invocation},enumerable:!0,configurable:!0}),t.prototype.getArguments=function(){return this.arguments||(this.arguments=new u(this)),this.arguments},t}(a);t.Invocation=y;var _=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Function},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t}(y);t.Function=_;var b=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FunctionParameter},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.setDefaultValue=function(e){return this.setNode("defaultValue",e,0)},t.prototype.getDefaultValue=function(){return this.defaultValue},t}(a);t.FunctionParameter=b;var S=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FunctionArgument},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.setValue=function(e){return this.setNode("value",e,0)},t.prototype.getValue=function(){return this.value},t}(a);t.FunctionArgument=S;var k=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.If},enumerable:!0,configurable:!0}),t.prototype.setExpression=function(e){return this.setNode("expression",e,0)},t.prototype.setElseClause=function(e){return this.setNode("elseClause",e)},t}(h);t.IfStatement=k;var C=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.For},enumerable:!0,configurable:!0}),t.prototype.setVariable=function(e){return this.setNode("variable",e,0)},t}(h);t.ForStatement=C;var T=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Each},enumerable:!0,configurable:!0}),t.prototype.setVariable=function(e){return this.setNode("variable",e,0)},t}(h);t.EachStatement=T;var E=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.While},enumerable:!0,configurable:!0}),t}(h);t.WhileStatement=E;var x=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Else},enumerable:!0,configurable:!0}),t}(h);t.ElseStatement=x;var w=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FunctionDeclaration},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.getParameters=function(){return this.parameters||(this.parameters=new u(this)),this.parameters},t}(h);t.FunctionDeclaration=w;var I=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MSViewPort},enumerable:!0,configurable:!0}),t}(h);t.MSViewPort=I;var L=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.FontFace},enumerable:!0,configurable:!0}),t}(h);t.FontFace=L;var M=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.NestedProperties},enumerable:!0,configurable:!0}),t}(h);t.NestedProperties=M;var N=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Keyframe},enumerable:!0,configurable:!0}),t.prototype.setKeyword=function(e){return this.setNode("keyword",e,0)},t.prototype.getKeyword=function(){return this.keyword},t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t}(h);t.Keyframe=N;var P=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.KeyframeSelector},enumerable:!0,configurable:!0}),t}(h);t.KeyframeSelector=P;var A=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Import},enumerable:!0,configurable:!0}),t.prototype.setMedialist=function(e){return e?(e.attachTo(this),this.medialist=e,!0):!1},t}(a);t.Import=A;var O=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Namespace},enumerable:!0,configurable:!0}),t}(a);t.Namespace=O;var R=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Media},enumerable:!0,configurable:!0}),t}(h);t.Media=R;var D=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Document},enumerable:!0,configurable:!0}),t}(h);t.Document=D;var F=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),t.prototype.getMediums=function(){return this.mediums||(this.mediums=new u(this)),this.mediums},t}(a);t.Medialist=F;var W=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MediaQuery},enumerable:!0,configurable:!0}),t}(a);t.MediaQuery=W;var B=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Page},enumerable:!0,configurable:!0}),t}(h);t.Page=B;var U=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.PageBoxMarginBox},enumerable:!0,configurable:!0}),t}(h);t.PageBoxMarginBox=U;var z=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Expression},enumerable:!0,configurable:!0}),t}(a);t.Expression=z;var j=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.BinaryExpression},enumerable:!0,configurable:!0}),t.prototype.setLeft=function(e){return this.setNode("left",e)},t.prototype.getLeft=function(){return this.left},t.prototype.setRight=function(e){return this.setNode("right",e)},t.prototype.getRight=function(){return this.right},t.prototype.setOperator=function(e){return this.setNode("operator",e)},t.prototype.getOperator=function(){return this.operator},t}(a);t.BinaryExpression=j;var V=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Term},enumerable:!0,configurable:!0}),t.prototype.setOperator=function(e){return this.setNode("operator",e)},t.prototype.getOperator=function(){return this.operator},t.prototype.setExpression=function(e){return this.setNode("expression",e)},t.prototype.getExpression=function(){return this.expression},t}(a);t.Term=V;var q=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Operator},enumerable:!0,configurable:!0}),t}(a);t.Operator=q;var H=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.HexColorValue},enumerable:!0,configurable:!0}),t}(a);t.HexColorValue=H;var K=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.NumericValue},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){for(var e,t=this.getText(),r=0,n=".".charCodeAt(0),i="0".charCodeAt(0),o="9".charCodeAt(0),s=0,a=t.length;a>s&&(e=t.charCodeAt(s),e>=i&&o>=e||e===n);s++)r+=1;return{value:t.substring(0,r),unit:a>r?t.substring(r):void 0}},t}(a);t.NumericValue=K;var G=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.VariableDeclaration},enumerable:!0,configurable:!0}),t.prototype.setVariable=function(e){return e?(e.attachTo(this),this.variable=e,!0):!1},t.prototype.getName=function(){return this.variable?this.variable.getName():""},t.prototype.setValue=function(e){return e?(e.attachTo(this),this.value=e,!0):!1},t}(a);t.VariableDeclaration=G;var $=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.Interpolation},enumerable:!0,configurable:!0}),t}(a);t.Interpolation=$;var X=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.VariableName},enumerable:!0,configurable:!0}),t.prototype.getName=function(){return this.getText()},t}(a);t.Variable=X;var Y=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.ExtendsReference},enumerable:!0,configurable:!0}),t.prototype.setSelector=function(e){return this.setNode("selector",e,0)},t.prototype.getSelector=function(){return this.selector},t.prototype.getName=function(){return this.selector?this.selector.getText():""},t}(a);t.ExtendsReference=Y;var J=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MixinReference},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.getArguments=function(){return this.arguments||(this.arguments=new u(this)),this.arguments},t.prototype.setContent=function(e){return this.setNode("content",e)},t.prototype.getContent=function(){return this.content},t}(a);t.MixinReference=J;var Q=function(e){function t(t,r){e.call(this,t,r)}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return s.MixinDeclaration},enumerable:!0,configurable:!0}),t.prototype.setIdentifier=function(e){return this.setNode("identifier",e,0)},t.prototype.getIdentifier=function(){return this.identifier},t.prototype.getName=function(){return this.identifier?this.identifier.getText():""},t.prototype.getParameters=function(){return this.parameters||(this.parameters=new u(this)),this.parameters},t.prototype.setGuard=function(e){return e&&(e.attachTo(this),this.guard=e),!1},t}(h);t.MixinDeclaration=Q;var Z=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.getConditions=function(){return this.conditions||(this.conditions=new u(this)),this.conditions},t}(a);t.LessGuard=Z;var et=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.setVariable=function(e){return this.setNode("variable",e)},t}(a);t.GuardCondition=et;var tt=function(){function e(e,t,r,n,i,o){void 0===i&&(i=e.offset),void 0===o&&(o=e.length),this.node=e,this.rule=t,this.level=r,this.message=n||t.message,this.offset=i,this.length=o}return e.prototype.getRule=function(){return this.rule},e.prototype.getLevel=function(){return this.level},e.prototype.getOffset=function(){return this.offset},e.prototype.getLength=function(){return this.length},e.prototype.getNode=function(){return this.node},e.prototype.getMessage=function(){return this.message},e}();t.Marker=tt;var rt=function(){function e(){this.entries=[]}return e.entries=function(t){var r=new e;return t.accept(r),r.entries},e.prototype.visitNode=function(e){return e.isErroneous()&&e.collectIssues(this.entries),!0},e}();t.ParseErrorCollector=rt}),define("vs/languages/css/services/languageFacts",["require","exports","vs/languages/css/parser/cssNodes","vs/languages/css/services/browsers","vs/base/strings"],function(e,t,r,n,i){function o(e){var t=e.getName();return t?i.equalsIgnoreCase(t,"rgb")||i.equalsIgnoreCase(t,"rgba")||i.equalsIgnoreCase(t,"hsl")||i.equalsIgnoreCase(t,"hsla"):!1}function s(e){if(e.type===r.NodeType.HexColorValue)return!0;if(e.type===r.NodeType.Function)return this.isColorConstructor(e);if(e.type===r.NodeType.Identifier){if(e.parent&&e.parent.type!==r.NodeType.Term)return!1;var n=e.getText().toLowerCase();if("none"===n)return!1;if(t.colors[n])return!0}return!1}function a(e){return e?(e=e.toLowerCase(),d().hasOwnProperty(e)):!1}function u(e){return e.browsers.count>1}function c(){return["@bottom-center","@bottom-left","@bottom-left-corner","@bottom-right","@bottom-right-corner","@left-bottom","@left-middle","@left-top","@right-bottom","@right-middle","@right-top","@top-center","@top-left","@top-left-corner","@top-right","@top-right-corner"]}function l(e){var t=e.description||"",r=this.getBrowserLabel(e.browsers);return r&&(t&&(t+="\n"),t=t+"("+r+")"),t}function p(e){var r="";if(!e||e.all||0===e.count)return null;for(var n in t.browserNames)if(e[n]){r.length>0&&(r+=", "),r+=t.browserNames[n];var i=e[n];i.length>0&&(r=r+" "+i)}return r}function h(e){var r={all:!1,FF:"",S:"",C:"",IE:"",O:"",count:0},n=0;return e?e.split(",").forEach(function(e){if(e=e.trim(),"all"===e)r.all=!0,n=Number.MAX_VALUE;else if("none"!==e)for(var i in t.browserNames)0===e.indexOf(i)&&(r[i]=e.substring(i.length).trim(),n++)}):(r.all=!0,n=Number.MAX_VALUE),r.count=n,r}function d(){if(!v){v={};for(var e=0,t=b.length;t>e;e++){var r=b[e];v[r.name]=new _(r)}}return v}function f(){if(!S){S=[];for(var e=0,t=k.length;t>e;e++){var r=k[e];S.push(new _(r))}}return S}function g(){if(!C){C=[];for(var e=0,t=T.length;t>e;e++){var r=T[e];E.push(new _(r))}}return C}function m(){if(!E){E=[];for(var e=0,t=x.length;t>e;e++){var r=x[e];E.push(new _(r))}}return E}t.colors={aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgrey:"#a9a9a9",darkgreen:"#006400",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",grey:"#808080",green:"#008000",greenyellow:"#adff2f",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgrey:"#d3d3d3",lightgreen:"#90ee90",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370d8",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#d87093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",red:"#ff0000",rebeccapurple:"#663399",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"},t.colorKeywords={ActiveBorder:"Active window border.",ActiveCaption:"Active window caption.",AppWorkspace:"Background color of multiple document interface.",Background:"Desktop background.",ButtonFace:"The face background color for 3-D elements that appear 3-D due to one layer of surrounding border.",ButtonHighlight:"The color of the border facing the light source for 3-D elements that appear 3-D due to one layer of surrounding border.",ButtonShadow:"The color of the border away from the light source for 3-D elements that appear 3-D due to one layer of surrounding border.",ButtonText:"Text on push buttons.",CaptionText:"Text in caption, size box, and scrollbar arrow box.",currentColor:"The value of the 'color' property. The computed value of the 'currentColor' keyword is the computed value of the 'color' property. If the 'currentColor' keyword is set on the 'color' property itself, it is treated as 'color:inherit' at parse time.",GrayText:"Grayed (disabled) text. This color is set to #000 if the current display driver does not support a solid gray color.",Highlight:"Item(s) selected in a control.",HighlightText:"Text of item(s) selected in a control.",InactiveBorder:"Inactive window border.",InactiveCaption:"Inactive window caption.",InactiveCaptionText:"Color of text in an inactive caption.",InfoBackground:"Background color for tooltip controls.",InfoText:"Text color for tooltip controls.",Menu:"Menu background.",MenuText:"Text in menus.",Scrollbar:"Scroll bar gray area.",ThreeDDarkShadow:"The color of the darker (generally outer) of the two borders away from the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDFace:"The face background color for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDHighlight:"The color of the lighter (generally outer) of the two borders facing the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDLightShadow:"The color of the darker (generally inner) of the two borders facing the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",ThreeDShadow:"The color of the lighter (generally inner) of the two borders away from the light source for 3-D elements that appear 3-D due to two concentric layers of surrounding border.",transparent:"Fully transparent. This keyword can be considered a shorthand for rgba(0,0,0,0) which is its computed value.",Window:"Window background.",WindowFrame:"Window frame.",WindowText:"Text in windows.",none:""},t.units={length:["em","rem","ex","px","cm","mm","in","pt","pc","cc"],angle:["deg","rad","grad"],time:["ms","s"],frequency:["hz","khz"],resolution:["dpi","dpcm"],percentage:["%"]},t.html5Tags=["a","abbr","address","area","article","aside","audio","b","base","bdi","bdo","blockquote","body","br","button","canvas","caption","cite","code","col","colgroup","data","datalist","dd","del","details","dfn","dialog","div","dl","dt","em","embed","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","iframe","img","input","ins","kbd","keygen","label","legend","li","link","main","map","mark","menu","menuitem","meta","meter","nav","noscript","object","ol","optgroup","option","output","p","param","pre","progress","q","rb","rp","rt","rtc","ruby","s","samp","script","section","select","small","source","span","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","title","tr","track","u","ul","var","video","wbr"],t.isColorConstructor=o,t.isColorValue=s,t.isKnownProperty=a,t.isCommonValue=u,t.getPageBoxDirectives=c,t.getEntryDescription=l,t.getBrowserLabel=p;
var v,y=function(){function e(e){this.data=e}return Object.defineProperty(e.prototype,"name",{get:function(){return this.data.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"description",{get:function(){return this.data.desc||n.descriptions[this.data.name]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"browsers",{get:function(){return this.browserEntry||(this.browserEntry=h(this.data.browsers)),this.browserEntry},enumerable:!0,configurable:!0}),e}(),_=function(){function e(e){this.data=e}return Object.defineProperty(e.prototype,"name",{get:function(){return this.data.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"description",{get:function(){return this.data.desc||n.descriptions[this.data.name]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"browsers",{get:function(){return this.browserEntry||(this.browserEntry=h(this.data.browsers)),this.browserEntry},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"restrictions",{get:function(){return this.data.restriction?this.data.restriction.split(",").map(function(e){return e.trim()}):[]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"values",{get:function(){return this.data.values?Array.isArray(this.data.values)?this.data.values.map(function(e){return new y(e)}):[new y(this.data.values.value)]:[]},enumerable:!0,configurable:!0}),e}(),b=n.data.css.properties;t.getProperties=d;var S,k=n.data.css.atdirectives;t.getAtDirectives=f;var C,T=n.data.css.pseudoelements;t.getPseudoElements=g;var E,x=n.data.css.pseudoclasses;t.getPseudoClasses=m,t.browserNames={FF:"Firefox",S:"Safari",C:"Chrome",IE:"IE",O:"Opera"}});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/css/parser/cssSymbols",["require","exports","./cssNodes","vs/base/arrays"],function(e,t,r,n){var i=function(){function e(e,t){this.offset=e,this.length=t,this.symbols=[],this.parent=null,this.children=[]}return e.prototype.addChild=function(e){this.children.push(e),e.setParent(this)},e.prototype.setParent=function(e){this.parent=e},e.prototype.findScope=function(e,t){return void 0===t&&(t=0),this.offset<=e&&this.offset+this.length>e+t||this.offset===e&&this.length===t?this.findInScope(e,t):null},e.prototype.findInScope=function(e,t){void 0===t&&(t=0);var r=e+t,i=n.findFirst(this.children,function(e){return e.offset>r});if(0===i)return this;var o=this.children[i-1];return o.offset<=e&&o.offset+o.length>=e+t?o.findInScope(e,t):this},e.prototype.addSymbol=function(e){this.symbols.push(e)},e.prototype.getSymbol=function(e,t){for(var r=0;r<this.symbols.length;r++){var n=this.symbols[r];if(n.name===e&&n.type===t)return n}return null},e.prototype.getSymbols=function(){return this.symbols},e}();t.Scope=i;var o=function(e){function t(){e.call(this,0,Number.MAX_VALUE)}return __extends(t,e),t}(i);t.GlobalScope=o;var s=function(){function e(e,t,r){this.name=e,this.node=t,this.type=r}return e}();t.Symbol=s;var a=function(){function e(e){this.scope=e}return e.prototype.addSymbol=function(e,t,r){if(-1!==e.offset){var n=this.scope.findScope(e.offset,e.length);n.addSymbol(new s(t,e,r))}},e.prototype.addScope=function(e){if(-1!==e.offset){var t=this.scope.findScope(e.offset,e.length);if(t.offset!==e.offset||t.length!==e.length){var r=new i(e.offset,e.length);return t.addChild(r),r}return t}return null},e.prototype.addSymbolToChildScope=function(e,t,r,n){if(e&&-1!==e.offset){var i=this.addScope(e);i.addSymbol(new s(r,t,n))}},e.prototype.visitNode=function(e){switch(e.type){case r.NodeType.Keyframe:return this.addSymbol(e,e.getName(),r.ReferenceType.Keyframe),!0;case r.NodeType.VariableDeclaration:return this.addSymbol(e,e.getName(),r.ReferenceType.Variable),!0;case r.NodeType.Ruleset:return this.visitRuleSet(e);case r.NodeType.MixinDeclaration:return this.addSymbol(e,e.getName(),r.ReferenceType.Mixin),!0;case r.NodeType.FunctionDeclaration:return this.addSymbol(e,e.getName(),r.ReferenceType.Function),!0;case r.NodeType.FunctionParameter:var t=e.getParent().getDeclarations();return t&&this.addSymbolToChildScope(t,e,e.getName(),r.ReferenceType.Variable),!0;case r.NodeType.Declarations:return this.addScope(e),!0;case r.NodeType.For:case r.NodeType.Each:var n=e,t=n.getDeclarations();return t&&this.addSymbolToChildScope(t,n.variable,n.variable.getName(),r.ReferenceType.Variable),!0}return!0},e.prototype.visitRuleSet=function(e){var t=this.scope.findScope(e.offset,e.length);return e.getSelectors().getChildren().forEach(function(e){e instanceof r.Selector&&1===e.getChildren().length&&t.addSymbol(new s(e.getChild(0).getText(),e,r.ReferenceType.Rule))}),!0},e}();t.ScopeBuilder=a;var u=function(){function e(e){this.global=new o,e.accept(new a(this.global))}return e.prototype.findSymbolsAtOffset=function(e,t){for(var r=this.global.findScope(e,0),n=[],i={};r;){for(var o=r.getSymbols(),s=0;s<o.length;s++){var a=o[s];a.node.offset<=e&&a.type===t&&!i[a.name]&&(n.push(a),i[a.name]=!0)}r=r.parent}return n},e.prototype.internalFindSymbol=function(e,t){var n=e;if(e.parent instanceof r.FunctionParameter&&e.parent.getParent()instanceof r.BodyDeclaration&&(n=e.parent.getParent().getDeclarations()),e.parent instanceof r.FunctionArgument&&e.parent.getParent()instanceof r.Function){var i=e.parent.getParent().getIdentifier();if(i){var o=this.internalFindSymbol(i,[r.ReferenceType.Function]);o&&(n=o.node.getDeclarations())}}if(!n)return null;for(var s=e.getText(),a=this.global.findScope(n.offset,n.length);a;){for(var u=0;u<t.length;u++){var c=t[u],l=a.getSymbol(s,c);if(l)return l}a=a.parent}return null},e.prototype.evaluateReferenceTypes=function(e){if(e instanceof r.Identifier){var t=e.referenceTypes;if(t)return t;var n=r.getParentDeclaration(e);if(n){var i=n.getNonPrefixedPropertyName();if(("animation"===i||"animation-name"===i)&&n.getValue()&&n.getValue().offset===e.offset)return[r.ReferenceType.Keyframe]}}else if(e instanceof r.Variable)return[r.ReferenceType.Variable];var o=e.findParent(r.NodeType.Selector);if(o)return[r.ReferenceType.Rule];var s=e.findParent(r.NodeType.ExtendsReference);return s?[r.ReferenceType.Rule]:null},e.prototype.findSymbolFromNode=function(e){if(!e)return null;for(;e.type===r.NodeType.Interpolation;)e=e.getParent();var t=this.evaluateReferenceTypes(e);return t?this.internalFindSymbol(e,t):null},e.prototype.matchesSymbol=function(e,t){if(!e)return null;for(;e.type===r.NodeType.Interpolation;)e=e.getParent();if(t.name.length!==e.length||t.name!==e.getText())return!1;var n=this.evaluateReferenceTypes(e);if(!n||-1===n.indexOf(t.type))return!1;var i=this.internalFindSymbol(e,n);return i===t},e.prototype.findSymbol=function(e,t,r){for(var n=this.global.findScope(r);n;){var i=n.getSymbol(e,t);if(i)return i;n=n.parent}return null},e}();t.Symbols=u}),define("vs/languages/css/services/occurrences",["require","exports","vs/languages/css/parser/cssNodes","vs/languages/css/parser/cssSymbols"],function(e,t,r,n){function i(e,t){var i=new n.Symbols(e),o=r.getNodeAtOffset(e,t);if(!o)return null;var s=i.findSymbolFromNode(o);return s?s.node:null}function o(e,t){var i=[],o=r.getNodeAtOffset(e,t);if(!o||o.type===r.NodeType.Stylesheet)return i;var a=new n.Symbols(e),u=a.findSymbolFromNode(o),c=o.getText();return e.accept(function(e){if(u){if(a.matchesSymbol(e,u))return i.push({kind:s(e),type:u.type,node:e}),!1}else o.type===e.type&&o.length===e.length&&c===e.getText()&&i.push({kind:s(e),node:e,type:r.ReferenceType.Unknown});return!0}),i}function s(e){if(e.type===r.NodeType.Selector)return"write";if(e.parent)switch(e.parent.type){case r.NodeType.FunctionDeclaration:case r.NodeType.MixinDeclaration:case r.NodeType.Keyframe:case r.NodeType.VariableDeclaration:case r.NodeType.FunctionParameter:return"write"}return null}t.findDeclaration=i,t.findOccurrences=o}),define("vs/languages/css/services/intelliSense",["require","exports","vs/languages/css/parser/cssNodes","vs/languages/css/parser/cssSymbols","vs/languages/css/services/languageFacts","vs/nls!vs/languages/css/cssWorker"],function(e,t,r,n,i,o){function s(e){return"undefined"!=typeof e}var a=function(){function e(e){void 0===e&&(e=null),this.variablePrefix=e}return e.prototype.getSymbolContext=function(){return this.symbolContext||(this.symbolContext=new n.Symbols(this.styleSheet)),this.symbolContext},e.prototype.getCompletionsAtPosition=function(e,t,n,i){this.offset=t.getOffsetFromPosition(i),this.position=i,this.currentWord=t.getWordUntilPosition(i,!0,!0).word,this.model=t,this.styleSheet=e.getStylesheet(n);var o=[],s=r.getNodePath(this.styleSheet,this.offset);this.isIncomplete=!1;for(var a=s.length-1;a>=0;a--){var u=s[a];if(u instanceof r.Property)this.getCompletionsForDeclarationProperty(o);else if(u instanceof r.Expression)this.getCompletionsForExpression(u,o);else if(u instanceof r.SimpleSelector){var c=u.findParent(r.NodeType.Ruleset);this.getCompletionsForSelector(c,o)}else u instanceof r.Declarations?this.getCompletionsForDeclarations(u,o):u instanceof r.VariableDeclaration?this.getCompletionsForVariableDeclaration(u,o):u instanceof r.RuleSet?this.getCompletionsForRuleSet(u,o):u instanceof r.Interpolation?this.getCompletionsForInterpolation(u,o):u instanceof r.FunctionArgument?this.getCompletionsForFunctionArguments(u,o):u instanceof r.FunctionDeclaration&&this.getCompletionsForFunctionDeclaration(u,o);if(o.length>0)return{currentWord:this.currentWord,suggestions:o,incomplete:this.isIncomplete}}if(this.getCompletionsForStylesheet(o),o.length>0)return{currentWord:this.currentWord,suggestions:o};if(this.variablePrefix&&0===this.currentWord.indexOf(this.variablePrefix)){if(this.getVariableProposals(o),o.length>0)return{currentWord:this.currentWord,suggestions:o};t.getAllUniqueWords(this.currentWord).forEach(function(e){o.push({type:"text",label:e,codeSnippet:e})})}return{currentWord:this.currentWord,suggestions:o}},e.prototype.getCompletionsForDeclarationProperty=function(e){var t=i.getProperties();for(var r in t)if(t.hasOwnProperty(r)){var n=t[r];n.browsers.count>1&&e.push({label:n.name,documentationLabel:i.getEntryDescription(n),codeSnippet:n.name+": ",type:"property"})}return e},e.prototype.getCompletionsForDeclarationValue=function(e,t){var r=e.getFullPropertyName(),n=i.getProperties()[r];if(n)this.getColorProposals(n,t),this.getValueEnumProposals(n,t),this.getUnitProposals(n,t);else{var o=new u;this.styleSheet.accept(new l(r,o)),o.getEntries().forEach(function(e){t.push({label:e,codeSnippet:e,type:"value"})})}return this.getVariableProposals(t),this.getTermProposals(t),t},e.prototype.getValueEnumProposals=function(e,t){if(e.values){var r="value";e.values.forEach(function(e){i.isCommonValue(e)&&t.push({label:e.name,documentationLabel:i.getEntryDescription(e),codeSnippet:e.name,type:r})})}return t},e.prototype.getCompletionsForInterpolation=function(e,t){return this.offset>=e.offset+2&&this.getVariableProposals(t),t},e.prototype.getVariableProposals=function(e){var t=this.getSymbolContext().findSymbolsAtOffset(this.offset,r.ReferenceType.Variable);return t.forEach(function(t){e.push({label:t.name,codeSnippet:t.name,type:"variable"})}),e},e.prototype.getUnitProposals=function(e,t){var r=isNaN(parseFloat(this.currentWord))?"0":this.currentWord;return e.restrictions.forEach(function(e){var n=i.units[e];n&&n.forEach(function(e){t.push({label:r+e,codeSnippet:r+e,type:"unit"})})}),this.isIncomplete=!0,t},e.prototype.getColorProposals=function(t,r){if(-1!==t.restrictions.indexOf("color")){for(var n in i.colors)r.push({label:n,documentationLabel:i.colors[n],codeSnippet:n,type:"#"+i.colors[n]});for(var n in i.colorKeywords)r.push({label:n,documentationLabel:i.colorKeywords[n],codeSnippet:n,type:"function"});var o=new u;this.styleSheet.accept(new p(o)),o.getEntries().forEach(function(e){r.push({label:e,codeSnippet:e,type:"#"+e})}),e.colorFunctions.forEach(function(e){r.push({label:e.func.substr(0,e.func.indexOf("(")),typeLabel:e.func,documentationLabel:e.desc,codeSnippet:e.func.replace(/\[?\$(\w+)\]?/g,"{{$1}}"),type:"function"})})}return r},e.prototype.getCompletionsForStylesheet=function(e){var t=this.styleSheet.findFirstChildBeforeOffset(this.offset);return t?t instanceof r.RuleSet?this.getCompletionsForRuleSet(t,e):e:this.getCompletionForTopLevel(e)},e.prototype.getCompletionForTopLevel=function(e){return i.getAtDirectives().forEach(function(t){t.browsers.count>0&&e.push({label:t.name,codeSnippet:t.name,documentationLabel:i.getEntryDescription(t),type:"keyword"})}),this.getCompletionsForSelector(null,e),e},e.prototype.getCompletionsForRuleSet=function(e,t){var n=e.getDeclarations(),i=n&&n.endsWith("}")&&this.offset>=n.offset+n.length;if(i)return this.getCompletionForTopLevel(t);var o=!n||this.offset<=n.offset;return o?this.getCompletionsForSelector(e,t):(e.findParent(r.NodeType.Ruleset),this.getCompletionsForDeclarations(e.getDeclarations(),t))},e.prototype.getCompletionsForSelector=function(e,t){i.getPseudoClasses().forEach(function(e){e.browsers.count>1&&t.push({label:e.name,codeSnippet:e.name,documentationLabel:i.getEntryDescription(e),type:"function"})}),i.getPseudoElements().forEach(function(e){e.browsers.count>1&&t.push({label:e.name,codeSnippet:e.name,documentationLabel:i.getEntryDescription(e),type:"function"})}),i.html5Tags.forEach(function(e){t.push({label:e,codeSnippet:e,type:"keyword"})});var n={};n[this.currentWord]=!0;var o=this.styleSheet.getTextProvider();if(this.styleSheet.accept(function(e){if(e.type===r.NodeType.SimpleSelector&&e.length>0){var i=o(e.offset,e.length);return"."!==i.charAt(0)||n[i]||(n[i]=!0,t.push({label:i,codeSnippet:i,type:"keyword"})),!1}return!0}),e&&e.isNested()){var s=e.getSelectors().findFirstChildBeforeOffset(this.offset);s&&0===e.getSelectors().getChildren().indexOf(s)&&this.getCompletionsForDeclarationProperty(t)}return t},e.prototype.getCompletionsForDeclarations=function(e,t){if(!e)return t;var n=e.findFirstChildBeforeOffset(this.offset);if(!n)return this.getCompletionsForDeclarationProperty(t);if(n instanceof r.Declaration){var i=n;return!s(i.colonPosition)||this.offset<=i.colonPosition||s(i.semicolonPosition)&&i.semicolonPosition<this.offset?this.offset===i.semicolonPosition+1?t:this.getCompletionsForDeclarationProperty(t):this.getCompletionsForDeclarationValue(i,t)}return t},e.prototype.getCompletionsForVariableDeclaration=function(e,t){return this.offset>e.colonPosition&&this.getVariableProposals(t),t},e.prototype.getCompletionsForExpression=function(e,t){var n=e.findParent(r.NodeType.Declaration);if(!n)return this.getTermProposals(t),t;var i=e.findChildAtOffset(this.offset,!0);return i?i instanceof r.NumericValue||i instanceof r.Identifier?this.getCompletionsForDeclarationValue(n,t):t:this.getCompletionsForDeclarationValue(n,t)},e.prototype.getCompletionsForFunctionArguments=function(e,t){return t},e.prototype.getCompletionsForFunctionDeclaration=function(e,t){var r=e.getDeclarations();return r&&this.offset>r.offset&&this.offset<r.offset+r.length&&this.getTermProposals(t),t},e.prototype.getTermProposals=function(e){var t=this.getSymbolContext().findSymbolsAtOffset(this.offset,r.ReferenceType.Function);return t.forEach(function(t){if(t.node instanceof r.FunctionDeclaration){var n=t.node,i=n.getParameters().getChildren().map(function(e){return e instanceof r.FunctionParameter?e.getName():e.getText()});e.push({label:t.name,typeLabel:t.name+"("+i.join(", ")+")",codeSnippet:t.name+"("+i.map(function(e){return"{{"+e+"}}"}).join(", ")+")",type:"function"})}}),e},e.colorFunctions=[{func:"rgb($red, $green, $blue)",desc:o.localize("vs_languages_css_services_intelliSense",0)},{func:"rgba($red, $green, $blue, $alpha)",desc:o.localize("vs_languages_css_services_intelliSense",1)},{func:"hsl($hue, $saturation, $lightness)",desc:o.localize("vs_languages_css_services_intelliSense",2)},{func:"hsla($hue, $saturation, $lightness, $alpha)",desc:o.localize("vs_languages_css_services_intelliSense",3)}],e}();t.CSSIntellisense=a;var u=function(){function e(){this.entries={}}return e.prototype.add=function(e){this.entries[e]=!0},e.prototype.getEntries=function(){return Object.keys(this.entries)},e}(),c=function(){function e(e){this.entries=e}return e.prototype.visitNode=function(e){return(e instanceof r.Identifier||e instanceof r.NumericValue||e instanceof r.HexColorValue)&&this.entries.add(e.getText()),!0},e}(),l=function(){function e(e,t){this.propertyName=e,this.entries=t}return e.prototype.matchesProperty=function(e){var t=e.getFullPropertyName();return this.propertyName===t},e.prototype.visitNode=function(e){if(e instanceof r.Declaration&&this.matchesProperty(e)){var t=e.getValue();t&&t.accept(new c(this.entries))}return!0},e}(),p=function(){function e(e){this.entries=e}return e.prototype.visitNode=function(e){return(e instanceof r.HexColorValue||e instanceof r.Function&&i.isColorConstructor(e))&&this.entries.add(e.getText()),!0},e}()}),define("vs/languages/css/level",["require","exports"],function(e,t){function r(e){switch(e){case"ignore":return n.Ignore;case"warning":return n.Warning;case"error":return n.Error}return null}!function(e){e[e.Ignore=1]="Ignore",e[e.Warning=2]="Warning",e[e.Error=4]="Error"}(t.Level||(t.Level={}));var n=t.Level;t.toLevel=r}),define("vs/languages/css/parser/cssScanner",["require","exports"],function(e,t){!function(e){e[e.Ident=0]="Ident",e[e.AtKeyword=1]="AtKeyword",e[e.String=2]="String",e[e.BadString=3]="BadString",e[e.BadUri=4]="BadUri",e[e.Hash=5]="Hash",e[e.Num=6]="Num",e[e.Percentage=7]="Percentage",e[e.Dimension=8]="Dimension",e[e.URI=9]="URI",e[e.UnicodeRange=10]="UnicodeRange",e[e.CDO=11]="CDO",e[e.CDC=12]="CDC",e[e.Colon=13]="Colon",e[e.SemiColon=14]="SemiColon",e[e.CurlyL=15]="CurlyL",e[e.CurlyR=16]="CurlyR",e[e.ParenthesisL=17]="ParenthesisL",e[e.ParenthesisR=18]="ParenthesisR",e[e.BracketL=19]="BracketL",e[e.BracketR=20]="BracketR",e[e.Whitespace=21]="Whitespace",e[e.Includes=22]="Includes",e[e.Dashmatch=23]="Dashmatch",e[e.SubstringOperator=24]="SubstringOperator",e[e.PrefixOperator=25]="PrefixOperator",e[e.SuffixOperator=26]="SuffixOperator",e[e.Delim=27]="Delim",e[e.EMS=28]="EMS",e[e.EXS=29]="EXS",e[e.Length=30]="Length",e[e.Angle=31]="Angle",e[e.Time=32]="Time",e[e.Freq=33]="Freq",e[e.Exclamation=34]="Exclamation",e[e.Resolution=35]="Resolution",e[e.Comma=36]="Comma",e[e.Charset=37]="Charset",e[e.EscapedJavaScript=38]="EscapedJavaScript",e[e.BadEscapedJavaScript=39]="BadEscapedJavaScript",e[e.SingleLineComment=40]="SingleLineComment",e[e.EOF=41]="EOF",e[e.CustomToken=42]="CustomToken"}(t.TokenType||(t.TokenType={}));var r=t.TokenType,n=function(){function e(e){this.source=e,this.len=e.length,this.position=0}return e.prototype.substring=function(e,t){return void 0===t&&(t=this.position),this.source.substring(e,t)},e.prototype.eos=function(){return this.len<=this.position},e.prototype.pos=function(){return this.position},e.prototype.goBackTo=function(e){this.position=e},e.prototype.goBack=function(e){this.position-=e},e.prototype.advance=function(e){this.position+=e},e.prototype.nextChar=function(){return this.source.charCodeAt(this.position++)||0},e.prototype.peekChar=function(e){return void 0===e&&(e=0),this.source.charCodeAt(this.position+e)||0},e.prototype.lookbackChar=function(e){return void 0===e&&(e=0),this.source.charCodeAt(this.position-e)||0},e.prototype.advanceIfChar=function(e){return e===this.source.charCodeAt(this.position)?(this.position++,!0):!1},e.prototype.advanceIfChars=function(e){var t;if(this.position+e.length>this.source.length)return!1;for(t=0;t<e.length;t++)if(this.source.charCodeAt(this.position+t)!==e[t])return!1;return this.advance(t),!0},e.prototype.advanceWhileChar=function(e){for(var t=this.position;this.position<this.len&&e(this.source.charCodeAt(this.position));)this.position++;return this.position-t},e}();t.MultiLineStream=n;var i="a".charCodeAt(0),o="c".charCodeAt(0),s="e".charCodeAt(0),a="f".charCodeAt(0),u="h".charCodeAt(0),c="i".charCodeAt(0),l="l".charCodeAt(0),p="p".charCodeAt(0),h="r".charCodeAt(0),d="s".charCodeAt(0),f="t".charCodeAt(0),g="u".charCodeAt(0),m="x".charCodeAt(0),v="z".charCodeAt(0),y="A".charCodeAt(0),_="E".charCodeAt(0),b="F".charCodeAt(0),S="I".charCodeAt(0),k="L".charCodeAt(0),C="P".charCodeAt(0),T="R".charCodeAt(0),E="U".charCodeAt(0),x="X".charCodeAt(0),w="Z".charCodeAt(0),I="0".charCodeAt(0),L="9".charCodeAt(0),M="~".charCodeAt(0),N="^".charCodeAt(0),P="=".charCodeAt(0),A="|".charCodeAt(0),O="-".charCodeAt(0),R="_".charCodeAt(0),D="%".charCodeAt(0),F="*".charCodeAt(0),W="(".charCodeAt(0),B=")".charCodeAt(0),U="<".charCodeAt(0),z=">".charCodeAt(0),j="@".charCodeAt(0),V="#".charCodeAt(0),q="$".charCodeAt(0),H="\\".charCodeAt(0),K="/".charCodeAt(0),G="\n".charCodeAt(0),$="\r".charCodeAt(0),X="\f".charCodeAt(0),Y='"'.charCodeAt(0),J="'".charCodeAt(0),Q=" ".charCodeAt(0),Z="	".charCodeAt(0),et=";".charCodeAt(0),tt=":".charCodeAt(0),rt="{".charCodeAt(0),nt="}".charCodeAt(0),it="[".charCodeAt(0),ot="]".charCodeAt(0),st=",".charCodeAt(0),at=".".charCodeAt(0),ut="!".charCodeAt(0),ct=[g,E,h,T,l,k,W,W],lt=[g,E,h,T,l,k,O,O,p,C,h,T,s,_,a,b,c,S,m,x,W,W],pt={};pt[et]=r.SemiColon,pt[tt]=r.Colon,pt[rt]=r.CurlyL,pt[nt]=r.CurlyR,pt[ot]=r.BracketR,pt[it]=r.BracketL,pt[W]=r.ParenthesisL,pt[B]=r.ParenthesisR,pt[st]=r.Comma;var ht={};ht.em=r.EMS,ht.ex=r.EXS,ht.px=r.Length,ht.cm=r.Length,ht.mm=r.Length,ht["in"]=r.Length,ht.pt=r.Length,ht.pc=r.Length,ht.deg=r.Angle,ht.rad=r.Angle,ht.grad=r.Angle,ht.ms=r.Time,ht.s=r.Time,ht.hz=r.Freq,ht.khz=r.Freq,ht["%"]=r.Percentage,ht.dpi=r.Resolution,ht.dpcm=r.Resolution;var dt=function(){function e(){this.ignoreComment=!0}return e.prototype.setSource=function(e){this.stream=new n(e)},e.prototype.finishToken=function(e,t){return e.len=this.stream.pos()-e.offset,e.type=t,e.text=this.stream.substring(e.offset),e},e.prototype.substring=function(e,t){return this.stream.substring(e,e+t)},e.prototype.pos=function(){return this.stream.pos()},e.prototype.goBackTo=function(e){this.stream.goBackTo(e)},e.prototype.scan=function(e){void 0===e&&(e=!0);var t={type:void 0,text:void 0,offset:this.stream.pos(),len:0};if(this.whitespace())return e?this.scan(e):this.finishToken(t,r.Whitespace);if(this.comment())return this.ignoreComment?this.scan(e):this.finishToken(t,n);if(this.stream.eos())return this.finishToken(t,r.EOF);var n=this.url();if(null!==n)return this.finishToken(t,n);if(this.ident())return this.finishToken(t,r.Ident);if(this.stream.advanceIfChar(j))return this.stream.advanceIfChars([o,u,i,h,d,s,f])?this.finishToken(t,r.Charset):this.ident()?this.finishToken(t,r.AtKeyword):this.finishToken(t,r.Delim);if(this.stream.advanceIfChar(V))return this.name()?this.finishToken(t,r.Hash):this.finishToken(t,r.Delim);if(this.stream.advanceIfChar(ut))return this.finishToken(t,r.Exclamation);if(this._number()){var a=this.stream.pos();if(this.stream.advanceIfChar(D))return this.finishToken(t,r.Percentage);if(this.dimension()){var c=this.stream.substring(a).toLowerCase(),n=ht[c];return"undefined"!=typeof n?this.finishToken(t,n):this.finishToken(t,r.Dimension)}return this.finishToken(t,r.Num)}var n=this._string();if(null!==n)return this.finishToken(t,n);if(this.stream.advanceIfChars([U,ut,O,O]))return this.finishToken(t,r.CDO);if(this.stream.advanceIfChars([O,O,z]))return this.finishToken(t,r.CDC);var n=pt[this.stream.peekChar()];return"undefined"!=typeof n?(this.stream.advance(1),this.finishToken(t,n)):this.stream.peekChar(0)===M&&this.stream.peekChar(1)===P?(this.stream.advance(2),this.finishToken(t,r.Includes)):this.stream.peekChar(0)===A&&this.stream.peekChar(1)===P?(this.stream.advance(2),this.finishToken(t,r.Dashmatch)):this.stream.peekChar(0)===F&&this.stream.peekChar(1)===P?(this.stream.advance(2),this.finishToken(t,r.SubstringOperator)):this.stream.peekChar(0)===N&&this.stream.peekChar(1)===P?(this.stream.advance(2),this.finishToken(t,r.PrefixOperator)):this.stream.peekChar(0)===q&&this.stream.peekChar(1)===P?(this.stream.advance(2),this.finishToken(t,r.SuffixOperator)):(this.stream.nextChar(),this.finishToken(t,r.Delim))},e.prototype.matchWordAnyCase=function(e){var t=0;return this.stream.advanceWhileChar(function(r){var n=e[t]===r||e[t+1]===r;return n&&(t+=2),n}),t===e.length?!0:(this.stream.goBack(t/2),!1)},e.prototype.comment=function(){if(this.stream.advanceIfChars([K,F])){var e=!1,t=!1;return this.stream.advanceWhileChar(function(r){return t&&r===K?(e=!0,!1):(t=r===F,!0)}),e&&this.stream.advance(1),!0}return!1},e.prototype._number=function(){var e,t=0;return this.stream.peekChar()===at&&(t=1),e=this.stream.peekChar(t),e>=I&&L>=e?(this.stream.advance(t+1),this.stream.advanceWhileChar(function(e){return e>=I&&L>=e||0===t&&e===at}),!0):!1},e.prototype._string=function(){if(this.stream.peekChar()===J||this.stream.peekChar()===Y){var e=this.stream.nextChar(),t=!1,n=-1;return this.stream.advanceWhileChar(function(r){switch(n=r,r){case H:return t=!0,!0;case X:case G:case $:case e:var i=t;return t=!1,i;default:return t=!1,!0}}),n===e?(this.stream.nextChar(),r.String):r.BadString}return null},e.prototype.url=function(){if(this.matchWordAnyCase(ct)||this.matchWordAnyCase(lt)){this.whitespace();var e=r.URI,t=this._string();return t===r.BadString?e=r.BadUri:null===t&&(this.stream.advanceWhileChar(function(e){return e!==B}),e=r.URI),this.whitespace(),this.stream.advanceIfChar(B)?e:r.BadUri}return null},e.prototype.whitespace=function(){var e=this.stream.advanceWhileChar(function(e){return e===Q||e===Z||e===G||e===X||e===$});return e>0},e.prototype.name=function(){var e=this.stream.peekChar();return this.nmchar(e)?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),!0):!1},e.prototype.ident=function(){var e=this.stream.peekChar();return this.nmstart(e)||e===O&&this.nmstart(this.stream.peekChar(1))?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),!0):!1},e.prototype.dimension=function(){var e=this.stream.peekChar();return this.nmstart(e)?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),!0):!1},e.prototype.nmstart=function(e){return e===R||e>=i&&v>=e||e>=y&&w>=e||e>=128&&65535>=e?!0:!1},e.prototype.nmchar=function(e){return this.nmstart(e)||e===O||e>=I&&L>=e?!0:!1},e}();t.Scanner=dt}),define("vs/languages/css/parser/cssErrors",["require","exports","vs/nls!vs/languages/css/cssWorker"],function(e,t,r){var n=function(){function e(e,t){this.id=e,this.message=t}return e}();t.CSSIssueType=n,t.ParseError={NumberExpected:new n("css-numberexpected",r.localize("vs_languages_css_parser_cssErrors",0)),ConditionExpected:new n("css-conditionexpected",r.localize("vs_languages_css_parser_cssErrors",1)),RuleOrSelectorExpected:new n("css-ruleorselectorexpected",r.localize("vs_languages_css_parser_cssErrors",2)),DotExpected:new n("css-dotexpected",r.localize("vs_languages_css_parser_cssErrors",3)),ColonExpected:new n("css-colonexpected",r.localize("vs_languages_css_parser_cssErrors",4)),SemiColonExpected:new n("css-semicolonexpected",r.localize("vs_languages_css_parser_cssErrors",5)),TermExpected:new n("css-termexpected",r.localize("vs_languages_css_parser_cssErrors",6)),ExpressionExpected:new n("css-expressionexpected",r.localize("vs_languages_css_parser_cssErrors",7)),OperatorExpected:new n("css-operatorexpected",r.localize("vs_languages_css_parser_cssErrors",8)),IdentifierExpected:new n("css-identifierexpected",r.localize("vs_languages_css_parser_cssErrors",9)),PercentageExpected:new n("css-percentageexpected",r.localize("vs_languages_css_parser_cssErrors",10)),URIOrStringExpected:new n("css-uriorstringexpected",r.localize("vs_languages_css_parser_cssErrors",11)),URIExpected:new n("css-uriexpected",r.localize("vs_languages_css_parser_cssErrors",12)),VariableNameExpected:new n("css-varnameexpected",r.localize("vs_languages_css_parser_cssErrors",13)),VariableValueExpected:new n("css-varvalueexpected",r.localize("vs_languages_css_parser_cssErrors",14)),PropertyValueExpected:new n("css-propertyvalueexpected",r.localize("vs_languages_css_parser_cssErrors",15)),LeftCurlyExpected:new n("css-lcurlyexpected",r.localize("vs_languages_css_parser_cssErrors",16)),RightCurlyExpected:new n("css-rcurlyexpected",r.localize("vs_languages_css_parser_cssErrors",17)),LeftSquareBracketExpected:new n("css-rbracketexpected",r.localize("vs_languages_css_parser_cssErrors",18)),RightSquareBracketExpected:new n("css-lbracketexpected",r.localize("vs_languages_css_parser_cssErrors",19)),LeftParenthesisExpected:new n("css-lparentexpected",r.localize("vs_languages_css_parser_cssErrors",20)),RightParenthesisExpected:new n("css-rparentexpected",r.localize("vs_languages_css_parser_cssErrors",21)),CommaExpected:new n("css-commaexpected",r.localize("vs_languages_css_parser_cssErrors",22)),PageDirectiveOrDeclarationExpected:new n("css-pagedirordeclexpected",r.localize("vs_languages_css_parser_cssErrors",23)),UnknownAtRule:new n("css-unknownatrule",r.localize("vs_languages_css_parser_cssErrors",24)),UnknownKeyword:new n("css-unknownkeyword",r.localize("vs_languages_css_parser_cssErrors",25)),SelectorExpected:new n("css-selectorexpected",r.localize("vs_languages_css_parser_cssErrors",26)),StringLiteralExpected:new n("css-stringliteralexpected",r.localize("vs_languages_css_parser_cssErrors",27))}}),define("vs/languages/css/parser/cssParser",["require","exports","vs/base/types","./cssScanner","./cssNodes","vs/languages/css/level","./cssErrors","vs/languages/css/services/languageFacts"],function(e,t,r,n,i,o,s,a){var u=function(){function e(e){void 0===e&&(e=new n.Scanner),this.scanner=e,this.token=null,this.prevToken=null}return e.prototype.peek=function(e,t,r){return void 0===r&&(r=!0),e!==this.token.type?!1:"undefined"!=typeof t?r?t.toLowerCase()===this.token.text.toLowerCase():t===this.token.text:!0},e.prototype.hasWhitespace=function(){return this.prevToken&&this.prevToken.offset+this.prevToken.len!==this.token.offset},e.prototype.consumeToken=function(){this.prevToken=this.token,this.token=this.scanner.scan()},e.prototype.mark=function(){return{prev:this.prevToken,curr:this.token,pos:this.scanner.pos()}},e.prototype.restoreAtMark=function(e){this.prevToken=e.prev,this.token=e.curr,this.scanner.goBackTo(e.pos)},e.prototype.acceptOne=function(e,t,r){void 0===r&&(r=!0);for(var n=0;n<t.length;n++)if(this.peek(e,t[n],r))return this.consumeToken(),!0;return!1},e.prototype.accept=function(e,t,r){return void 0===r&&(r=!0),this.peek(e,t,r)?(this.consumeToken(),!0):!1},e.prototype.resync=function(e,t){for(;;){if(e&&-1!==e.indexOf(this.token.type))return this.consumeToken(),!0;if(t&&-1!==t.indexOf(this.token.type))return!0;if(this.token.type===n.TokenType.EOF)return!1;this.token=this.scanner.scan()}return!1},e.prototype.createNode=function(e){return new i.Node(this.token.offset,this.token.len,e)},e.prototype.create=function(e){return r.create(e,this.token.offset,this.token.len)},e.prototype.finish=function(e,t,r,n){if(!(e instanceof i.Nodelist)&&(t&&this.markError(e,t,r,n),null!==this.prevToken)){var o=this.prevToken.offset+this.prevToken.len;e.length=o>e.offset?o-e.offset:0}return e},e.prototype.markError=function(e,t,r,n){this.token!==this.lastErrorToken&&(e.addIssue(new i.Marker(e,t,o.Level.Error,null,this.token.offset,this.token.len)),this.lastErrorToken=this.token),(r||n)&&this.resync(r,n)},e.prototype.parseStylesheet=function(e){var t=e.getVersionId(),r=function(r,n){if(e.getVersionId()!==t)throw new Error("Underlying model has changed, AST is no longer valid");var i=e.getRangeFromOffsetAndLength(r,n);return e.getValueInRange(i)};return this.internalParse(e.getValue(),this._parseStylesheet,r)},e.prototype.internalParse=function(e,t,r){this.scanner.setSource(e),this.token=this.scanner.scan();var n=t.bind(this)();return n&&(n.textProvider=r?r:function(t,r){return e.substr(t,r)}),n},e.prototype._parseStylesheet=function(){var e=this.create(i.Stylesheet);e.addChild(this._parseCharset());var t=!1;do{var r=!1;do{r=!1;var o=this._parseStylesheetStatement();for(o&&(e.addChild(o),r=!0,t=!1,this.peek(n.TokenType.EOF)||!this._needsSemicolonAfter(o)||this.accept(n.TokenType.SemiColon)||this.markError(e,s.ParseError.SemiColonExpected));this.accept(n.TokenType.SemiColon)||this.accept(n.TokenType.CDO)||this.accept(n.TokenType.CDC);)r=!0,t=!1
}while(r);if(this.peek(n.TokenType.EOF))break;t||(this.peek(n.TokenType.AtKeyword)?this.markError(e,s.ParseError.UnknownAtRule):this.markError(e,s.ParseError.RuleOrSelectorExpected),t=!0),this.consumeToken()}while(!this.peek(n.TokenType.EOF));return this.finish(e)},e.prototype._parseStylesheetStatement=function(){return this._parseRuleset(!1)||this._parseImport()||this._parseMedia()||this._parsePage()||this._parseFontFace()||this._parseKeyframe()||this._parseMSViewPort()||this._parseNamespace()||this._parseDocument()},e.prototype._tryParseRuleset=function(e){var t=this.mark();if(this._parseSelector(e)){for(;this.accept(n.TokenType.Comma)&&this._parseSelector(e););if(this.accept(n.TokenType.CurlyL))return this.restoreAtMark(t),this._parseRuleset(e)}return this.restoreAtMark(t),null},e.prototype._parseRuleset=function(e){void 0===e&&(e=!1);var t=this.create(i.RuleSet);if(!t.getSelectors().addChild(this._parseSelector(e)))return null;for(;this.accept(n.TokenType.Comma)&&t.getSelectors().addChild(this._parseSelector(e)););return this._parseBody(t,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseRuleSetDeclaration=function(){return this._parseDeclaration()},e.prototype._needsSemicolonAfter=function(e){switch(e.type){case i.NodeType.Keyframe:case i.NodeType.MSViewPort:case i.NodeType.Media:case i.NodeType.Ruleset:case i.NodeType.Media:case i.NodeType.Namespace:case i.NodeType.If:case i.NodeType.For:case i.NodeType.Each:case i.NodeType.While:case i.NodeType.MixinDeclaration:case i.NodeType.FunctionDeclaration:return!1;case i.NodeType.VariableDeclaration:case i.NodeType.ExtendsReference:case i.NodeType.MixinContent:case i.NodeType.ReturnStatement:case i.NodeType.MediaQuery:case i.NodeType.Debug:case i.NodeType.Import:return!0;case i.NodeType.MixinReference:return!e.getContent();case i.NodeType.Declaration:return!e.getNestedProperties()}return!1},e.prototype._parseDeclarations=function(e){var t=this.create(i.Declarations);if(!this.accept(n.TokenType.CurlyL))return null;for(var r=e();t.addChild(r)&&!this.peek(n.TokenType.CurlyR);){if(this._needsSemicolonAfter(r)&&!this.accept(n.TokenType.SemiColon))return this.finish(t,s.ParseError.SemiColonExpected,[n.TokenType.SemiColon,n.TokenType.CurlyR]);for(;this.accept(n.TokenType.SemiColon););r=e()}return this.accept(n.TokenType.CurlyR)?this.finish(t):this.finish(t,s.ParseError.RightCurlyExpected,[n.TokenType.CurlyR,n.TokenType.SemiColon])},e.prototype._parseBody=function(e,t){return e.setDeclarations(this._parseDeclarations(t))?this.finish(e):this.finish(e,s.ParseError.LeftCurlyExpected,[n.TokenType.CurlyR,n.TokenType.SemiColon])},e.prototype._parseSelector=function(e){var t=this.create(i.Selector),r=!1;for(e&&(r=t.addChild(this._parseCombinator()));t.addChild(this._parseSimpleSelector());)r=!0,t.addChild(this._parseCombinator());return r?this.finish(t):null},e.prototype._parseDeclaration=function(e){var t=this.create(i.Declaration);return t.setProperty(this._parseProperty())?this.accept(n.TokenType.Colon)?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?(t.addChild(this._parsePrio()),this.peek(n.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)):this.finish(t,s.ParseError.PropertyValueExpected)):this.finish(t,s.ParseError.ColonExpected,[n.TokenType.Colon],e):null},e.prototype._tryToParseDeclaration=function(){var e=this.mark();return this._parseProperty()&&this.accept(n.TokenType.Colon)?(this.restoreAtMark(e),this._parseDeclaration()):(this.restoreAtMark(e),null)},e.prototype._parseProperty=function(){var e=this.create(i.Property),t=this.mark();return(this.accept(n.TokenType.Delim,"*")||this.accept(n.TokenType.Delim,"_"))&&this.hasWhitespace()?(this.restoreAtMark(t),null):e.setIdentifier(this._parseIdent())?this.finish(e):null},e.prototype._parseCharset=function(){var e=this.create(i.Node);return this.accept(n.TokenType.Charset)?this.accept(n.TokenType.String)?this.accept(n.TokenType.SemiColon)?this.finish(e):this.finish(e,s.ParseError.SemiColonExpected):this.finish(e,s.ParseError.IdentifierExpected):null},e.prototype._parseImport=function(){var e=this.create(i.Import);return this.accept(n.TokenType.AtKeyword,"@import")?this.accept(n.TokenType.URI)||this.accept(n.TokenType.String)?(e.setMedialist(this._parseMediaList()),this.finish(e)):this.finish(e,s.ParseError.URIOrStringExpected):null},e.prototype._parseNamespace=function(){var e=this.create(i.Namespace);return this.accept(n.TokenType.AtKeyword,"@namespace")?(e.addChild(this._parseIdent()),this.accept(n.TokenType.URI)||this.accept(n.TokenType.String)?this.accept(n.TokenType.SemiColon)?this.finish(e):this.finish(e,s.ParseError.SemiColonExpected):this.finish(e,s.ParseError.URIExpected,[n.TokenType.SemiColon])):null},e.prototype._parseFontFace=function(){if(!this.peek(n.TokenType.AtKeyword,"@font-face"))return null;var e=this.create(i.FontFace);return this.consumeToken(),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseMSViewPort=function(){if(!this.peek(n.TokenType.AtKeyword,"@-ms-viewport"))return null;var e=this.create(i.MSViewPort);return this.consumeToken(),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseKeyframe=function(){var e=this.create(i.Keyframe),t=this.create(i.Node);return this.accept(n.TokenType.AtKeyword,"@keyframes")||this.accept(n.TokenType.AtKeyword,"@-webkit-keyframes")||this.accept(n.TokenType.AtKeyword,"@-ms-keyframes")||this.accept(n.TokenType.AtKeyword,"@-moz-keyframes")||this.accept(n.TokenType.AtKeyword,"@-o-keyframes")?(e.setKeyword(this.finish(t)),"@-ms-keyframes"===t.getText()&&this.markError(t,s.ParseError.UnknownKeyword),e.setIdentifier(this._parseIdent([i.ReferenceType.Keyframe]))?this._parseBody(e,this._parseKeyframeSelector.bind(this)):this.finish(e,s.ParseError.IdentifierExpected,[n.TokenType.CurlyR])):null},e.prototype._parseKeyframeSelector=function(){var e=this.create(i.KeyframeSelector);if(!e.addChild(this._parseIdent())&&!this.accept(n.TokenType.Percentage))return null;for(;this.accept(n.TokenType.Comma);)if(!e.addChild(this._parseIdent())&&!this.accept(n.TokenType.Percentage))return this.finish(e,s.ParseError.PercentageExpected);return this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},e.prototype._parseMediaDeclaration=function(){return this._tryParseRuleset(!1)||this._tryToParseDeclaration()||this._parseStylesheetStatement()},e.prototype._parseMedia=function(){var e=this.create(i.Media);if(!this.accept(n.TokenType.AtKeyword,"@media"))return null;if(!e.addChild(this._parseMediaQuery([n.TokenType.CurlyL])))return this.finish(e,s.ParseError.IdentifierExpected);for(;this.accept(n.TokenType.Comma);)if(!e.addChild(this._parseMediaQuery([n.TokenType.CurlyL])))return this.finish(e,s.ParseError.IdentifierExpected);return this._parseBody(e,this._parseMediaDeclaration.bind(this))},e.prototype._parseMediaQuery=function(e){var t=this.create(i.MediaQuery),r=!0,o=!1;if(!this.peek(n.TokenType.ParenthesisL)){if(this.accept(n.TokenType.Ident,"only",!0)||this.accept(n.TokenType.Ident,"not",!0),!t.addChild(this._parseIdent()))return null;o=!0,r=this.accept(n.TokenType.Ident,"and",!0)}for(;r;){if(!this.accept(n.TokenType.ParenthesisL))return o?this.finish(t,s.ParseError.LeftParenthesisExpected,[],e):null;if(!t.addChild(this._parseMediaFeatureName()))return this.finish(t,s.ParseError.IdentifierExpected,[],e);if(this.accept(n.TokenType.Colon)&&!t.addChild(this._parseExpr()))return this.finish(t,s.ParseError.TermExpected,[],e);if(!this.accept(n.TokenType.ParenthesisR))return this.finish(t,s.ParseError.RightParenthesisExpected,[],e);r=this.accept(n.TokenType.Ident,"and",!0)}return t},e.prototype._parseMediaFeatureName=function(){return this._parseIdent()},e.prototype._parseMediaList=function(){var e=this.create(i.Medialist);if(e.getMediums().addChild(this._parseMedium())){for(;this.accept(n.TokenType.Comma);)if(!e.getMediums().addChild(this._parseMedium()))return this.finish(e,s.ParseError.IdentifierExpected);return this.finish(e)}return null},e.prototype._parseMedium=function(){var e=this.create(i.Node);return e.addChild(this._parseIdent())?this.finish(e):null},e.prototype._parsePageDeclaration=function(){return this._parsePageMarginBox()||this._parseRuleSetDeclaration()},e.prototype._parsePage=function(){var e=this.create(i.Page);if(!this.accept(n.TokenType.AtKeyword,"@Page"))return null;if(e.addChild(this._parsePageSelector()))for(;this.accept(n.TokenType.Comma);)if(!e.addChild(this._parsePageSelector()))return this.finish(e,s.ParseError.IdentifierExpected);return this._parseBody(e,this._parsePageDeclaration.bind(this))},e.prototype._parsePageMarginBox=function(){var e=this.create(i.PageBoxMarginBox);return this.peek(n.TokenType.AtKeyword)?(this.acceptOne(n.TokenType.AtKeyword,a.getPageBoxDirectives())||this.markError(e,s.ParseError.UnknownAtRule,[],[n.TokenType.CurlyL]),this._parseBody(e,this._parseRuleSetDeclaration.bind(this))):null},e.prototype._parsePageSelector=function(){var e=this.create(i.Node);return this.peek(n.TokenType.Ident)||this.peek(n.TokenType.Colon)?(e.addChild(this._parseIdent()),this.accept(n.TokenType.Colon)&&!e.addChild(this._parseIdent())?this.finish(e,s.ParseError.IdentifierExpected):this.finish(e)):null},e.prototype._parseDocument=function(){var e=this.create(i.Document);return this.accept(n.TokenType.AtKeyword,"@-moz-document")?(this.resync([],[n.TokenType.CurlyL]),this._parseBody(e,this._parseStylesheetStatement.bind(this))):null},e.prototype._parseOperator=function(){var e=this.createNode(i.NodeType.Operator);return this.accept(n.TokenType.Delim,"/")||this.accept(n.TokenType.Delim,"*")||this.accept(n.TokenType.Delim,"+")||this.accept(n.TokenType.Delim,"-")||this.accept(n.TokenType.Dashmatch)||this.accept(n.TokenType.Includes)||this.accept(n.TokenType.SubstringOperator)||this.accept(n.TokenType.PrefixOperator)||this.accept(n.TokenType.SuffixOperator)||this.accept(n.TokenType.Delim,"=")?this.finish(e):null},e.prototype._parseUnaryOperator=function(){var e=this.create(i.Node);return this.accept(n.TokenType.Delim,"+")||this.accept(n.TokenType.Delim,"-")?this.finish(e):null},e.prototype._parseCombinator=function(){var e=this.create(i.Node);return this.accept(n.TokenType.Delim,">")?(e.type=i.NodeType.SelectorCombinatorParent,this.finish(e)):this.accept(n.TokenType.Delim,"+")?(e.type=i.NodeType.SelectorCombinatorSibling,this.finish(e)):this.accept(n.TokenType.Delim,"~")?(e.type=i.NodeType.SelectorCombinatorAllSiblings,this.finish(e)):null},e.prototype._parseSimpleSelector=function(){var e=this.create(i.SimpleSelector),t=0;for(e.addChild(this._parseElementName())&&t++;(0===t||!this.hasWhitespace())&&e.addChild(this._parseSimpleSelectorBody());)t++;return t>0?this.finish(e):null},e.prototype._parseSimpleSelectorBody=function(){return this._parsePseudo()||this._parseHash()||this._parseClass()||this._parseAttrib()},e.prototype._parseSelectorIdent=function(){return this._parseIdent()},e.prototype._parseHash=function(){if(!this.peek(n.TokenType.Hash)&&!this.peek(n.TokenType.Delim,"#"))return null;var e=this.createNode(i.NodeType.IdentifierSelector);if(this.accept(n.TokenType.Delim,"#")){if(this.hasWhitespace()||!e.addChild(this._parseSelectorIdent()))return this.finish(e,s.ParseError.IdentifierExpected)}else this.consumeToken();return this.finish(e)},e.prototype._parseClass=function(){if(!this.peek(n.TokenType.Delim,"."))return null;var e=this.createNode(i.NodeType.ClassSelector);return this.consumeToken(),this.hasWhitespace()||!e.addChild(this._parseSelectorIdent())?this.finish(e,s.ParseError.IdentifierExpected):this.finish(e)},e.prototype._parseElementName=function(){var e=this.createNode(i.NodeType.ElementNameSelector);return e.addChild(this._parseSelectorIdent())||this.accept(n.TokenType.Delim,"*")?this.finish(e):null},e.prototype._parseAttrib=function(){if(!this.peek(n.TokenType.BracketL))return null;var e=this.createNode(i.NodeType.AttributeSelector);return this.consumeToken(),!e.addChild(this._parseBinaryExpr()),this.accept(n.TokenType.BracketR)?this.finish(e):this.finish(e,s.ParseError.RightSquareBracketExpected)},e.prototype._parsePseudo=function(){if(!this.peek(n.TokenType.Colon))return null;var e=this.mark(),t=this.createNode(i.NodeType.PseudoSelector);return this.consumeToken(),!this.hasWhitespace()&&this.accept(n.TokenType.Colon),this.hasWhitespace()?(this.restoreAtMark(e),null):t.addChild(this._parseIdent())?this.hasWhitespace()||!this.accept(n.TokenType.ParenthesisL)||(t.addChild(this._parseBinaryExpr()||this._parseSimpleSelector()),this.accept(n.TokenType.ParenthesisR))?this.finish(t):this.finish(t,s.ParseError.RightParenthesisExpected):this.finish(t,s.ParseError.IdentifierExpected)},e.prototype._parsePrio=function(){if(!this.peek(n.TokenType.Exclamation))return null;var e=this.createNode(i.NodeType.Prio);return this.accept(n.TokenType.Exclamation)&&this.accept(n.TokenType.Ident,"important",!0)?this.finish(e):null},e.prototype._parseExpr=function(e){void 0===e&&(e=!1);var t=this.create(i.Expression);if(!t.addChild(this._parseBinaryExpr()))return null;for(;;){if(this.peek(n.TokenType.Comma)){if(e)return this.finish(t);this.consumeToken()}if(!t.addChild(this._parseBinaryExpr()))break}return this.finish(t)},e.prototype._parseBinaryExpr=function(e,t){var r=this.create(i.BinaryExpression);if(!r.setLeft(e||this._parseTerm()))return null;if(!r.setOperator(t||this._parseOperator()))return this.finish(r);if(!r.setRight(this._parseTerm()))return this.finish(r,s.ParseError.TermExpected);r=this.finish(r);var n=this._parseOperator();return n&&(r=this._parseBinaryExpr(r,n)),this.finish(r)},e.prototype._parseTerm=function(){var e=this.create(i.Term);return e.setOperator(this._parseUnaryOperator()),e.setExpression(this._parseFunction())||e.setExpression(this._parseIdent())||e.setExpression(this._parseURILiteral())||e.setExpression(this._parseStringLiteral())||e.setExpression(this._parseNumeric())||e.setExpression(this._parseHexColor())?this.finish(e):null},e.prototype._parseNumeric=function(){var e=this.create(i.NumericValue);return this.accept(n.TokenType.Num)||this.accept(n.TokenType.Percentage)||this.accept(n.TokenType.Resolution)||this.accept(n.TokenType.Length)||this.accept(n.TokenType.EMS)||this.accept(n.TokenType.EXS)||this.accept(n.TokenType.Angle)||this.accept(n.TokenType.Time)||this.accept(n.TokenType.Dimension)||this.accept(n.TokenType.Freq)?this.finish(e):null},e.prototype._parseStringLiteral=function(){var e=this.createNode(i.NodeType.StringLiteral);return this.accept(n.TokenType.String)||this.accept(n.TokenType.BadString)?this.finish(e):null},e.prototype._parseURILiteral=function(){var e=this.createNode(i.NodeType.URILiteral);return this.accept(n.TokenType.URI)||this.accept(n.TokenType.BadUri)?this.finish(e):null},e.prototype._parseIdent=function(e){var t=this.create(i.Identifier);return e&&(t.referenceTypes=e),this.accept(n.TokenType.Ident)?this.finish(t):null},e.prototype._parseFunction=function(){var e=this.mark(),t=this.create(i.Function);if(!t.setIdentifier(this._parseFunctionIdentifier()))return null;if(this.hasWhitespace()||!this.accept(n.TokenType.ParenthesisL))return this.restoreAtMark(e),null;if(t.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(n.TokenType.Comma);)if(!t.getArguments().addChild(this._parseFunctionArgument()))return this.finish(t,s.ParseError.ExpressionExpected);return this.accept(n.TokenType.ParenthesisR)?this.finish(t):this.finish(t,s.ParseError.RightParenthesisExpected)},e.prototype._parseFunctionIdentifier=function(){var e=this.create(i.Identifier);if(e.referenceTypes=[i.ReferenceType.Function],this.accept(n.TokenType.Ident,"progid")){if(this.accept(n.TokenType.Colon))for(;this.accept(n.TokenType.Ident)&&this.accept(n.TokenType.Delim,"."););return this.finish(e)}return this.accept(n.TokenType.Ident)?this.finish(e):null},e.prototype._parseFunctionArgument=function(){var e=this.create(i.FunctionArgument);return e.setValue(this._parseExpr(!0))?this.finish(e):null},e.prototype._parseHexColor=function(){var e=this.create(i.HexColorValue);return this.accept(n.TokenType.Hash)?this.finish(e):null},e}();t.Parser=u});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/css/services/selectorPrinting",["require","exports","vs/languages/css/parser/cssNodes","vs/base/strings"],function(e,t,r,n){function i(e,t){var i=new c;return e.getChildren().forEach(function(e){switch(e.type){case r.NodeType.SelectorCombinator:if(t){var o=e.getText().split("&");if(1===o.length){i.name=o[0];break}if(i=t.cloneWithParent(),o[0]){var s=i.findRoot();s.name=o[0]+s.name}for(var a=1;a<o.length;a++){if(a>1){var u=t.cloneWithParent();i.addChild(u.findRoot()),i=u}i.name+=o[a]}}break;case r.NodeType.SelectorPlaceholder:case r.NodeType.ElementNameSelector:var c=e.getText();i.name="*"===c?"element":c;break;case r.NodeType.ClassSelector:i.addAttr("class",e.getText().substring(1));break;case r.NodeType.IdentifierSelector:i.addAttr("id",e.getText().substring(1));break;case r.NodeType.MixinDeclaration:i.addAttr("class",e.getName());break;case r.NodeType.PseudoSelector:i.addAttr(e.getText(),n.empty);break;case r.NodeType.AttributeSelector:var l=e.getChildren()[0];if(l&&l.getRight()){var p;switch(l.getOperator().getText()){case"|=":p=n.format("{0}-…",h.remove(l.getRight().getText()));break;case"^=":p=n.format("{0}…",h.remove(l.getRight().getText()));break;case"$=":p=n.format("…{0}",h.remove(l.getRight().getText()));break;case"~=":p=n.format(" … {0} … ",h.remove(l.getRight().getText()));break;case"*=":p=n.format("…{0}…",h.remove(l.getRight().getText()));break;default:p=h.remove(l.getRight().getText())}}i.addAttr(l.getLeft().getText(),p)}}),i}function o(e){var t=i(e),r=new d('"').print(t);return{tagName:"span",className:"selector",children:r}}function s(e){switch(e.type){case r.NodeType.MixinDeclaration:case r.NodeType.Stylesheet:return!0}return!1}function a(e){var t=new l,n=[];if(e.getParent()instanceof r.RuleSet)for(var i=e.getParent().getParent();i&&!s(i);)i instanceof r.RuleSet&&n.push(i),i=i.getParent();for(var o=new f(t),a=n.length-1;a>=0;a--){var u=n[a].getSelectors().getChild(0);u&&o.processSelector(u)}return o.processSelector(e),t}function u(e){var t=a(e),r=new d('"').print(t);return{tagName:"span",className:"selector",children:r}}var c=function(){function e(){}return e.prototype.addChild=function(t){t instanceof e&&(t.parent=this),this.children||(this.children=[]),this.children.push(t)},e.prototype.findRoot=function(){for(var e=this;e.parent&&!(e.parent instanceof l);)e=e.parent;return e},e.prototype.removeChild=function(e){if(this.children){var t=this.children.indexOf(e);if(-1!==t)return this.children.splice(t,1),!0}return!1},e.prototype.addAttr=function(e,t){this.attributes||(this.attributes={}),this.attributes.hasOwnProperty(e)?this.attributes[e]+=" "+t:this.attributes[e]=t},e.prototype.clone=function(t){void 0===t&&(t=!0);var r=new e;if(r.name=this.name,this.attributes){r.attributes={};for(var n in this.attributes)r.addAttr(n,this.attributes[n])}if(t&&this.children){r.children=[];for(var i=0;i<this.children.length;i++)r.addChild(this.children[i].clone())}return r},e.prototype.cloneWithParent=function(){var e=this.clone(!1);if(this.parent&&!(this.parent instanceof l)){var t=this.parent.cloneWithParent();t.addChild(e)}return e},e}();t.Element=c;var l=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t}(c);t.RootElement=l;var p=function(e){function t(t){e.call(this),this.name=t}return __extends(t,e),t}(c);t.LabelElement=p;var h,d=function(){function e(e){this.quote=e}return e.prototype.print=function(e){return e instanceof l?this.doPrint(e.children):this.doPrint([e])},e.prototype.doPrint=function(e){for(var t={children:[]},r=t;e.length>0;){var n=e.shift(),i=this.doPrintElement(n);r.children.push(i),n.children&&(e.push.apply(e,n.children),r=i)}return t.children},e.prototype.doPrintElement=function(e){var t=this;if(e instanceof p)return{tagName:"ul",children:[{tagName:"li",children:[{tagName:"span",className:"label",text:e.name}]}]};var r=[{isText:!0,text:"<"}];return e.name?r.push({tagName:"span",className:"name",text:e.name}):r.push({tagName:"span",text:"element"}),e.attributes&&Object.keys(e.attributes).forEach(function(n){r.push({isText:!0,text:" "}),r.push({tagName:"span",className:"key",text:n});var i=e.attributes[n];i&&(r.push({isText:!0,text:"="}),r.push({tagName:"span",className:"value",text:h.ensure(i,t.quote)}))}),r.push({isText:!0,text:">"}),{tagName:"ul",children:[{tagName:"li",children:r}]}},e}();!function(e){function t(e,t){return t+r(e)+t}function r(e){return e=n.trim(e,"'"),e=n.trim(e,'"')}e.ensure=t,e.remove=r}(h||(h={})),t.toElement=i,t.simpleSelectorToHtml=o;var f=function(){function e(e){this.prev=null,this.element=e}return e.prototype.processSelector=function(e){var t=this,n=null;if(!(this.element instanceof l)&&e.getChildren().some(function(e){return e.hasChildren()&&e.getChild(0).type===r.NodeType.SelectorCombinator})){var o=this.element.findRoot();o.parent instanceof l&&(n=this.element,this.element=o.parent,this.element.removeChild(o),this.prev=null)}e.getChildren().forEach(function(e){if(e instanceof r.SimpleSelector){if(t.prev instanceof r.SimpleSelector){var o=new p("…");t.element.addChild(o),t.element=o}else t.prev&&(t.prev.matches("+")||t.prev.matches("~"))&&(t.element=t.element.parent);t.prev&&t.prev.matches("~")&&(t.element.addChild(i(e)),t.element.addChild(new p("⋮")));var s=i(e,n),a=s.findRoot();t.element.addChild(a),t.element=s}(e instanceof r.SimpleSelector||e.type===r.NodeType.SelectorCombinatorParent||e.type===r.NodeType.SelectorCombinatorSibling||e.type===r.NodeType.SelectorCombinatorAllSiblings)&&(t.prev=e)})},e}();t.selectorToElement=a,t.selectorToHtml=u}),define("vs/languages/css/services/lintRules",["require","exports","vs/nls!vs/languages/css/cssWorker","vs/languages/css/level"],function(e,t,r,n){function i(e){var r={};for(var n in t.Rules){var i=t.Rules[n];r[e+"."+i.id]=i.getConfiguration()}return r}function o(e){var r={};for(var i in t.Rules){var o=t.Rules[i],s=n.toLevel(e[o.id]);s&&(r[o.id]=s)}return r}var s="warning",a="error",u="ignore",c=function(){function e(e,t,r){this.id=e,this.message=t,this.defaultValue=r}return e.prototype.getConfiguration=function(){return{type:"string",enum:[u,s,a],default:this.defaultValue,description:this.message}},e}();t.Rule=c,t.Rules={AllVendorPrefixes:new c("compatibleVendorPrefixes",r.localize("vs_languages_css_services_lintRules",0),u),IncludeStandardPropertyWhenUsingVendorPrefix:new c("vendorPrefix",r.localize("vs_languages_css_services_lintRules",1),s),DuplicateDeclarations:new c("duplicateProperties",r.localize("vs_languages_css_services_lintRules",2),u),EmptyRuleSet:new c("emptyRules",r.localize("vs_languages_css_services_lintRules",3),s),ImportStatemement:new c("importStatement",r.localize("vs_languages_css_services_lintRules",4),u),NoWidthOrHeightWhenPaddingOrBorder:new c("boxModel",r.localize("vs_languages_css_services_lintRules",5),u),UniversalSelector:new c("universalSelector",r.localize("vs_languages_css_services_lintRules",6),u),ZeroWithUnit:new c("zeroUnits",r.localize("vs_languages_css_services_lintRules",7),u),RequiredPropertiesForFontFace:new c("fontFaceProperties",r.localize("vs_languages_css_services_lintRules",8),s),HexColorLength:new c("hexColorLength",r.localize("vs_languages_css_services_lintRules",9),a),ArgsInColorFunction:new c("argumentsInColorFunction",r.localize("vs_languages_css_services_lintRules",10),a),UnknownProperty:new c("unknownProperties",r.localize("vs_languages_css_services_lintRules",11),s),IEStarHack:new c("ieHack",r.localize("vs_languages_css_services_lintRules",12),u),UnknownVendorSpecificProperty:new c("unknownVendorSpecificProperties",r.localize("vs_languages_css_services_lintRules",13),u),PropertyIgnoredDueToDisplay:new c("propertyIgnoredDueToDisplay",r.localize("vs_languages_css_services_lintRules",14),s),AvoidImportant:new c("important",r.localize("vs_languages_css_services_lintRules",15),u),AvoidFloat:new c("float",r.localize("vs_languages_css_services_lintRules",16),u),AvoidIdSelector:new c("idSelector",r.localize("vs_languages_css_services_lintRules",17),u)},t.getConfigurationProperties=i,t.sanitize=o}),define("vs/languages/css/services/lint",["require","exports","vs/languages/css/services/languageFacts","vs/languages/css/services/lintRules","vs/languages/css/parser/cssNodes","vs/nls!vs/languages/css/cssWorker","vs/languages/css/level"],function(e,t,r,n,i,o,s){var a=function(){function e(e,t){this.name=e,this.node=t}return e}(),u=function(){function e(){this.data={}}return e.prototype.add=function(e,t,r){var n=this.data[e];n||(n={nodes:[],names:[]},this.data[e]=n),n.names.push(t),r&&n.nodes.push(r)},e}(),c=function(){function e(e){void 0===e&&(e={}),this.warnings=[],this.configuration={};for(var t in n.Rules){var r=n.Rules[t],i=e[r.id]||s.toLevel(r.defaultValue);this.configuration[r.id]=i}}return e.entries=function(t,r){var n=new e(r);return t.accept(n),n.getEntries()},e.prototype.fetch=function(e,t){for(var r=[],n=0;n<e.length;n++)e[n].name.toLowerCase()===t&&r.push(e[n]);return r},e.prototype.fetchWithValue=function(e,t,r){for(var n=[],i=0;i<e.length;i++)if(e[i].name.toLowerCase()===t){var o=e[i].node.getValue();o&&this.findValueInExpression(o,r)&&n.push(e[i])}return n},e.prototype.findValueInExpression=function(e,t){var r=!1;return e.accept(function(e){return e.type===i.NodeType.Identifier&&e.getText()===t&&(r=!0),!r}),r},e.prototype.fetchWithin=function(e,t){for(var r=[],n=0;n<e.length;n++)e[n].name.toLowerCase().indexOf(t)>=0&&r.push(e[n]);return r},e.prototype.getEntries=function(e){return void 0===e&&(e=s.Level.Warning|s.Level.Error),this.warnings.filter(function(t){return 0!==(t.getLevel()&e)})},e.prototype.addEntry=function(e,t,r){var n=new i.Marker(e,t,this.configuration[t.id],r);this.warnings.push(n)},e.prototype.getMissingNames=function(e,t){e=e.slice(0);for(var r=0;r<t.length;r++){var n=e.indexOf(t[r]);-1!==n&&(e[n]=null)}for(var i=null,r=0;r<e.length;r++){var s=e[r];s&&(i=null===i?o.localize("vs_languages_css_services_lint",0,s):o.localize("vs_languages_css_services_lint",1,i,s))}return i},e.prototype.visitNode=function(e){switch(e.type){case i.NodeType.Stylesheet:return this.visitStylesheet(e);case i.NodeType.FontFace:return this.visitFontFace(e);case i.NodeType.Ruleset:return this.visitRuleSet(e);case i.NodeType.SimpleSelector:return this.visitSimpleSelector(e);case i.NodeType.Function:return this.visitFunction(e);case i.NodeType.NumericValue:return this.visitNumericValue(e);case i.NodeType.Import:return this.visitImport(e)}return this.visitUnknownNode(e)},e.prototype.visitStylesheet=function(e){var t=this,r=new u;e.accept(function(e){if(e instanceof i.Keyframe){var t=e.getKeyword(),n=t.getText();r.add(e.getName(),n,"@keyframes"!==n?t:null)}return!0});var s=["@-webkit-keyframes","@-moz-keyframes","@-o-keyframes"],a=function(e){if(p){var r=o.localize("vs_languages_css_services_lint",2);t.addEntry(e,n.Rules.IncludeStandardPropertyWhenUsingVendorPrefix,r)}if(h){var r=o.localize("vs_languages_css_services_lint",3,h);t.addEntry(e,n.Rules.AllVendorPrefixes,r)}};for(var c in r.data){var l=r.data[c].names,p=-1===l.indexOf("@keyframes");if(p||1!==l.length){var h=this.getMissingNames(s,l);(h||p)&&r.data[c].nodes.forEach(a)}}return!0},e.prototype.visitSimpleSelector=function(e){var t=e.getText();return"*"===t&&this.addEntry(e,n.Rules.UniversalSelector),0===t.indexOf("#")&&this.addEntry(e,n.Rules.AvoidIdSelector),!0},e.prototype.visitImport=function(e){return this.addEntry(e,n.Rules.ImportStatemement),!0},e.prototype.visitRuleSet=function(t){var s=this,c=t.getDeclarations();if(!c)return!1;c.hasChildren()||this.addEntry(t.getSelectors(),n.Rules.EmptyRuleSet);var l=this,p=[];if(c.getChildren().forEach(function(e){if(e instanceof i.Declaration){var t=e;p.push(new a(t.getFullPropertyName(),t))}},this),(this.fetch(p,"width").length>0||this.fetch(p,"height").length>0)&&(this.fetchWithin(p,"padding").length>0||this.fetchWithin(p,"border").length>0)){for(var h=this.fetch(p,"width"),d=0;d<h.length;d++)this.addEntry(h[d].node,n.Rules.NoWidthOrHeightWhenPaddingOrBorder);h=this.fetch(p,"height");for(var d=0;d<h.length;d++)this.addEntry(h[d].node,n.Rules.NoWidthOrHeightWhenPaddingOrBorder);h=this.fetchWithin(p,"padding");for(var d=0;d<h.length;d++)this.addEntry(h[d].node,n.Rules.NoWidthOrHeightWhenPaddingOrBorder);h=this.fetchWithin(p,"border");for(var d=0;d<h.length;d++)this.addEntry(h[d].node,n.Rules.NoWidthOrHeightWhenPaddingOrBorder)}var f=this.fetchWithValue(p,"display","inline");f.length>0&&["width","height","margin-top","margin-bottom","float"].forEach(function(e){for(var t=l.fetch(p,e),r=0;r<t.length;r++)l.addEntry(t[r].node,n.Rules.PropertyIgnoredDueToDisplay)});var f=this.fetchWithValue(p,"display","inline-block");if(f.length>0)for(var g=this.fetch(p,"float"),d=0;d<g.length;d++)this.addEntry(g[d].node,n.Rules.PropertyIgnoredDueToDisplay);var f=this.fetchWithValue(p,"display","block");if(f.length>0)for(var g=this.fetch(p,"vertical-align"),d=0;d<g.length;d++)this.addEntry(g[d].node,n.Rules.PropertyIgnoredDueToDisplay);t.accept(function(e){return e.type===i.NodeType.Prio&&l.addEntry(e,n.Rules.AvoidImportant),!0});for(var h=this.fetch(p,"float"),d=0;d<h.length;d++)this.addEntry(h[d].node,n.Rules.AvoidFloat);for(var m=0;m<p.length;m++){var v=p[m];if("background"!==v.name.toLowerCase()){var y=v.node.getValue();if(y&&"-"!==y.getText()[0]){var h=this.fetch(p,v.name);if(h.length>1)for(var _=0;_<h.length;_++){var y=h[_].node.getValue();y&&"-"!==y.getText()[0]&&h[_]!==v&&this.addEntry(v.node,n.Rules.DuplicateDeclarations)}}}}var b=new u,S=!1;if(c.getChildren().forEach(function(e){if(s.isCSSDeclaration(e)){var t=e,i=t.getFullPropertyName(),o=i.charAt(0);if("-"===o){r.isKnownProperty(i)||s.addEntry(t.getProperty(),n.Rules.UnknownVendorSpecificProperty);var a=t.getNonPrefixedPropertyName();b.add(a,i,t.getProperty())}else("*"===o||"_"===o)&&(s.addEntry(t.getProperty(),n.Rules.IEStarHack),i=i.substr(1)),r.isKnownProperty(i)||s.addEntry(t.getProperty(),n.Rules.UnknownProperty),b.add(i,i,null)}else S=!0}),!S){var k=function(e){if(x){var t=o.localize("vs_languages_css_services_lint",4,C);s.addEntry(e,n.Rules.IncludeStandardPropertyWhenUsingVendorPrefix,t)}if(M){var t=o.localize("vs_languages_css_services_lint",5,M);s.addEntry(e,n.Rules.AllVendorPrefixes,t)}};for(var C in b.data){var T=b.data[C],E=T.names,x=r.isKnownProperty(C)&&-1===E.indexOf(C);if(x||1!==E.length){for(var w=[],m=0,I=e.prefixes.length;I>m;m++){var L=e.prefixes[m];r.isKnownProperty(L+C)&&w.push(L+C)}var M=this.getMissingNames(w,E);(M||x)&&T.nodes.forEach(k)}}}return!0},e.prototype.visitNumericValue=function(e){var t=e.getValue();return"%"===t.unit?!0:(0===parseFloat(t.value)&&t.unit&&this.addEntry(e,n.Rules.ZeroWithUnit),!0)},e.prototype.visitFontFace=function(e){var t=this,r=e.getDeclarations();if(r){var i=!1,o=!1,s=!1;return r.getChildren().forEach(function(e){if(t.isCSSDeclaration(e)){var r=e.getProperty().getName().toLocaleLowerCase();"src"===r&&(i=!0),"font-family"===r&&(o=!0)}else s=!0}),s||i&&o||this.addEntry(e,n.Rules.RequiredPropertiesForFontFace),!0}},e.prototype.isCSSDeclaration=function(e){if(e instanceof i.Declaration){if(!e.getValue())return!1;var t=e.getProperty();return!t||t.getIdentifier().containsInterpolation()?!1:!0}return!1},e.prototype.visitUnknownNode=function(e){if(e.type===i.NodeType.HexColorValue){var t=e.getText();7!==t.length&&4!==t.length&&this.addEntry(e,n.Rules.HexColorLength)}return!0},e.prototype.visitFunction=function(e){var t=e.getName().toLowerCase(),r=-1,o=0;switch(t){case"rgb(":case"hsl(":r=3;break;case"rgba(":case"hsla(":r=4}return-1!==r&&(e.getArguments().accept(function(e){return e instanceof i.BinaryExpression?(o+=1,!1):!0}),o!==r&&this.addEntry(e,n.Rules.ArgsInColorFunction)),!0},e.prefixes=["-ms-","-moz-","-o-","-webkit-"],e}();t.LintVisitor=c
});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/css/cssWorker",["require","exports","vs/nls!vs/languages/css/cssWorker","vs/base/severity","vs/base/strings","vs/base/lib/winjs.base","vs/editor/worker/modesWorker","vs/languages/css/services/cssLanguageService","vs/languages/css/services/languageFacts","./services/occurrences","vs/languages/css/services/intelliSense","vs/languages/css/parser/cssNodes","vs/languages/css/level","vs/languages/css/parser/cssParser","vs/languages/css/services/selectorPrinting","vs/languages/css/services/lint","vs/languages/css/services/lintRules","vs/editor/modes/supports"],function(e,t,r,n,i,o,s,a,u,c,l,p,h,d,f,g,m,v){var y=function(e){function t(t,r,n){e.call(this,t,r,n),this.languageService=this.createLanguageService(t,r.getId()),this.lintSettings={}}return __extends(t,e),t.prototype._createInPlaceReplaceSupport=function(){return new v.InplaceReplaceSupport(this.resourceService,this)},t.prototype.createLanguageService=function(e,t){return new a.CSSLanguageService(e.resourceService,this.createParser.bind(this),t)},t.prototype.createParser=function(){return new d.Parser},t.prototype._doConfigure=function(e){return e?(this.lintSettings=e.lint?m.sanitize(e.lint):{},o.TPromise.as(!0)):o.TPromise.as(!1)},t.prototype.doValidate=function(e){var t=this;this.languageService.join().then(function(){var r=t.resourceService.get(e),n=t.languageService.getStylesheet(e),i=[];i.push.apply(i,p.ParseErrorCollector.entries(n)),i.push.apply(i,t.collectLintEntries(n));var o=i.filter(function(e){return e.getLevel()!==h.Level.Ignore}).map(function(e){return t._createMarkerData(r,e)});t.markerService.changeOne(t._getMode().getId(),e,o)})},t.prototype._createMarkerData=function(e,t){var r=e.getRangeFromOffsetAndLength(t.getOffset(),t.getLength());return{code:t.getRule().id,message:t.getMessage(),severity:t.getLevel()===h.Level.Warning?n.Warning:n.Error,startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn}},t.prototype.collectLintEntries=function(e){return g.LintVisitor.entries(e,this.lintSettings)},t.prototype.createIntellisense=function(){return new l.CSSIntellisense},t.prototype.doSuggest=function(e,t){var r=this;return this.languageService.join().then(function(){var n=r.resourceService.get(e),i=r.createIntellisense().getCompletionsAtPosition(r.languageService,n,e,t);return i})},t.prototype.getRangesToPosition=function(e,t){var r=this;return this.languageService.join().then(function(){for(var n=r.resourceService.get(e),i=n.getOffsetFromPosition(t),o=r.languageService.getStylesheet(e),s=p.getNodePath(o,i),a=[],u=0;u<s.length;u++){var c=s[u];-1!==c.offset&&-1!==c.length&&(c.parent&&c.parent.offset===c.offset&&c.parent.length===c.length||a.push({type:"node",range:r._range(c,n)}))}return a})},t.prototype.getOutline=function(e){var t=this;return this.languageService.join().then(function(){var n=t.resourceService.get(e),i=t.languageService.getStylesheet(e),o=[];return i.accept(function(e){var i={label:null,type:"rule",range:null,children:[]};return e instanceof p.Selector?i.label=e.getText():e instanceof p.VariableDeclaration?(i.label=e.getName(),i.type="variable"):e instanceof p.MixinDeclaration?(i.label=e.getName(),i.type="method"):e instanceof p.FunctionDeclaration?(i.label=e.getName(),i.type="function"):e instanceof p.Keyframe?i.label=r.localize("vs_languages_css_cssWorker",0,e.getName()):e instanceof p.FontFace&&(i.label=r.localize("vs_languages_css_cssWorker",1)),i.label&&(i.range=t._range(e,n,!0),o.push(i)),!0}),o})},t.prototype.computeInfo=function(e,t){var r=this;return this.languageService.join().then(function(){for(var n=r.resourceService.get(e),i=n.getOffsetFromPosition(t),o=r.languageService.getStylesheet(e),s=p.getNodePath(o,i),a=0;a<s.length;a++){var u=s[a];if(u instanceof p.Selector)return{htmlContent:[f.selectorToHtml(u)],range:r._range(u,n)};if(u instanceof p.SimpleSelector)return{htmlContent:[f.simpleSelectorToHtml(u)],range:r._range(u,n)}}return null})},t.prototype.findDeclaration=function(e,t){var r=this;return this.languageService.join().then(function(){var n=r.resourceService.get(e),i=n.getOffsetFromPosition(t),o=c.findDeclaration(r.languageService.getStylesheet(e),i);return o?{resourceUrl:e,range:r._range(o,n,!0)}:null})},t.prototype.findOccurrences=function(e,t){var r=this;return this.languageService.join().then(function(){var n=r.resourceService.get(e),i=n.getOffsetFromPosition(t),o=c.findOccurrences(r.languageService.getStylesheet(e),i);return o.map(function(e){return{range:r._range(e.node,n),kind:e.kind}})})},t.prototype.findReferences=function(e,t){var r=this;return this.languageService.join().then(function(){var n=r.resourceService.get(e),i=n.getOffsetFromPosition(t),o=c.findOccurrences(r.languageService.getStylesheet(e),i);return o.map(function(e){return{resourceUrl:n.getAssociatedResource(),range:r._range(e.node,n)}})})},t.prototype.navigateValueSetFallback=function(e,t,r){var n=this;return this.languageService.join().then(function(){var o=n.resourceService.get(e),s=o.getOffsetFromPosition({lineNumber:t.startLineNumber,column:t.startColumn}),a=n.languageService.getStylesheet(e),c=p.getNodeAtOffset(a,s);if(c){var l=p.getParentDeclaration(c);if(l){var h=u.getProperties()[l.getFullPropertyName()];if(h&&h.values){var d=h.values.filter(function(e){return u.isCommonValue(e)}).map(function(e){return e.name}),f=h.restrictions.indexOf("color")>=0;f&&(d=d.concat(Object.getOwnPropertyNames(u.colors),Object.getOwnPropertyNames(u.colorKeywords)));for(var g=c.getText(),m=0,v=d.length;v>m;m++)if(i.equalsIgnoreCase(d[m],g)){var y=m;r?y=(m+1)%v:(y=m-1,0>y&&(y=v-1));var _={value:d[y],range:n._range(c,o)};return _}if(d.length>0){var _={value:d[0],range:n._range(c,o)};return _}return null}}}})},t.prototype.findColorDeclarations=function(e){var t=this;return this.languageService.join().then(function(){var r=t.resourceService.get(e),n=t.languageService.getStylesheet(e),i=[];return n.accept(function(e){return u.isColorValue(e)&&i.push({range:t._range(e,r),value:e.getText()}),!0}),i})},t.prototype._range=function(e,t,r){if(void 0===r&&(r=!1),r){var n=t.getPositionFromOffset(e.offset);return{startLineNumber:n.lineNumber,startColumn:n.column,endLineNumber:n.lineNumber,endColumn:n.column}}return t.getRangeFromOffsetAndLength(e.offset,e.length)},t.prototype.getFixesForUnknownProperty=function(e){var t=e.getName(),n=[];for(var o in u.getProperties()){var s=i.difference(t,o);s>=t.length/2&&n.push({label:r.localize("vs_languages_css_cssWorker",2,o),id:JSON.stringify({type:"rename",name:o}),score:s})}return n.sort(function(e,t){return t.score-e.score}),n.slice(0,3)},t.prototype.getQuickFixes=function(e,t){var r=this;return t.code!==m.Rules.UnknownProperty.id?o.TPromise.as([]):this.languageService.join().then(function(){for(var n=r.resourceService.get(e),i=n.getOffsetFromPosition({column:t.startColumn,lineNumber:t.startLineNumber}),o=r.languageService.getStylesheet(e),s=p.getNodePath(o,i),a=s.length-1;a>=0;a--){var u=s[a];if(u instanceof p.Declaration){var c=u.getProperty();if(c&&c.offset===i&&c.length===t.endColumn-t.startColumn)return r.getFixesForUnknownProperty(c)}}return[]})},t.prototype.runQuickFixAction=function(e,t,r){var n=JSON.parse(r);switch(n.type){case"rename":return o.TPromise.as({editOperations:[{range:t,text:n.name}]})}return null},t}(s.AbstractWorkerMode);t.CSSWorker=y});