/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/html/html",["require","exports","vs/editor/modes/modes","vs/editor/modes/modesExtensions","vs/editor/modes/supports","vs/base/arrays","vs/platform/platform","vs/platform/services","vs/base/lib/winjs.base","vs/platform/thread/attribute"],function(e,t,n,r,i,o,s,a,c,l){!function(e){e[e.Content=0]="Content",e[e.OpeningStartTag=1]="OpeningStartTag",e[e.OpeningEndTag=2]="OpeningEndTag",e[e.WithinDoctype=3]="WithinDoctype",e[e.WithinTag=4]="WithinTag",e[e.WithinComment=5]="WithinComment",e[e.WithinEmbeddedContent=6]="WithinEmbeddedContent",e[e.AttributeName=7]="AttributeName",e[e.AttributeValue=8]="AttributeValue"}(t.States||(t.States={}));var u=t.States,d=["script","style"],h=function(e){function t(t,n,r,i,o,s,a){e.call(this,t),this.kind=n,this.lastTagName=r,this.lastAttributeName=i,this.embeddedContentType=o,this.attributeValueQuote=s,this.attributeValue=a}return __extends(t,e),t.escapeTagName=function(e){return"tag.html.tag-"+e.replace(/[:_]/g,"-")},t.prototype.makeClone=function(){return new t(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},t.prototype.equals=function(n){return n instanceof t?e.prototype.equals.call(this,n)&&this.kind===n.kind&&this.lastTagName===n.lastTagName&&this.lastAttributeName===n.lastAttributeName&&this.embeddedContentType===n.embeddedContentType&&this.attributeValueQuote===n.attributeValueQuote&&this.attributeValue===n.attributeValue:!1},t.prototype.nextName=function(e){return e.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/).toLowerCase()},t.prototype.tokenize=function(e){switch(this.kind){case u.WithinComment:if(e.advanceUntilString2("-->",!1))return{type:"comment.html.content"};if(e.advanceIfString2("-->"))return this.kind=u.Content,{type:"comment.html",bracket:n.Bracket.Close};break;case u.WithinDoctype:if(e.advanceUntilString2(">",!1))return{type:"metatag.content.html"};if(e.advanceIfString2(">"))return this.kind=u.Content,{type:"metatag.html",bracket:n.Bracket.Close};break;case u.Content:if(e.advanceIfCharCode2("<".charCodeAt(0))){if(!e.eos()&&"!"===e.peek()){if(e.advanceIfString2("!--"))return this.kind=u.WithinComment,{type:"comment.html",bracket:n.Bracket.Open};if(e.advanceIfStringCaseInsensitive2("!DOCTYPE"))return this.kind=u.WithinDoctype,{type:"metatag.html",bracket:n.Bracket.Open}}return e.advanceIfCharCode2("/".charCodeAt(0))?(this.kind=u.OpeningEndTag,{type:"delimiter.end.html",bracket:n.Bracket.Open}):(this.kind=u.OpeningStartTag,{type:"delimiter.start.html",bracket:n.Bracket.Open})}break;case u.OpeningEndTag:var r=this.nextName(e);return r.length>0?{type:t.escapeTagName(r)}:e.advanceIfString2(">")?(this.kind=u.Content,{type:"delimiter.end.html",bracket:n.Bracket.Close}):(e.advanceUntilString2(">",!1),{type:""});case u.OpeningStartTag:if(this.lastTagName=this.nextName(e),this.lastTagName.length>0)return this.lastAttributeName=null,("script"===this.lastTagName||"style"===this.lastTagName)&&(this.lastAttributeName=null,this.embeddedContentType=null),this.kind=u.WithinTag,{type:t.escapeTagName(this.lastTagName)};break;case u.WithinTag:if(e.skipWhitespace2()||e.eos())return{type:""};var i=this.nextName(e);return i.length>0?(this.lastAttributeName=i,this.kind=u.AttributeName,{type:"attribute.name.html"}):e.advanceIfString2("/>")?(this.kind=u.Content,{type:"delimiter.start.html",bracket:n.Bracket.Close}):e.advanceIfCharCode2(">".charCodeAt(0))?-1!==d.indexOf(this.lastTagName)?(this.kind=u.WithinEmbeddedContent,{type:"delimiter.start.html",bracket:n.Bracket.Close}):(this.kind=u.Content,{type:"delimiter.start.html",bracket:n.Bracket.Close}):(e.next2(),{type:""});case u.AttributeName:return e.skipWhitespace2()||e.eos()?{type:""}:e.advanceIfCharCode2("=".charCodeAt(0))?(this.kind=u.AttributeValue,{type:"delimiter.assign.html"}):(this.kind=u.WithinTag,this.tokenize(e));case u.AttributeValue:if(e.eos())return{type:""};if(e.skipWhitespace2())return'"'===this.attributeValueQuote||"'"===this.attributeValueQuote?{type:"attribute.value.html"}:{type:""};if('"'!==this.attributeValueQuote&&"'"!==this.attributeValueQuote){var o=e.peek();return"'"===o||'"'===o?(this.attributeValueQuote=o,this.attributeValue=o,e.next2(),{type:"attribute.value.html"}):(this.kind=u.WithinTag,this.tokenize(e))}if(this.attributeValue!==this.attributeValueQuote||"script"!==this.lastTagName&&"style"!==this.lastTagName||"type"!==this.lastAttributeName){if(e.advanceIfCharCode2(this.attributeValueQuote.charCodeAt(0)))this.kind=u.WithinTag,this.attributeValue="",this.attributeValueQuote="";else{var s=e.next();this.attributeValue+=s}return{type:"attribute.value.html"}}if(this.attributeValue=e.advanceUntilString(this.attributeValueQuote,!0),this.attributeValue.length>0)return this.embeddedContentType=this.unquote(this.attributeValue),this.kind=u.WithinTag,this.attributeValue="",this.attributeValueQuote="",{type:"attribute.value.html"}}return e.next2(),this.kind=u.Content,{type:""}},t.prototype.unquote=function(e){var t=0,n=e.length;return'"'===e[0]&&t++,'"'===e[n-1]&&n--,e.substring(t,n)},t}(r.AbstractState);t.State=h;var p=function(e){function t(t,n,r){var o=this;void 0===r&&(r=a.AsyncDescriptor.create("vs/languages/html/htmlWorker","HTMLWorker")),e.call(this,t,n,r),this.tokenizationSupport=new i.TokenizationSupport(this,!0),this.electricCharacterSupport=new i.BracketElectricCharacterSupport(this,{brackets:[],regexBrackets:[{tokenType:"tag.html.tag-$1",open:/<(?!(?:area|base|basefont|br|col|command|embed|frame|hr|img|input|link|meta|param|source|track|wbr))(\w[\w\d]*)([^\/>]*(?!\/)>)[^<]*$/i,closeComplete:"</$1>",close:/<\/(\w[\w\d]*)\s*>$/i}],caseInsensitive:!0,embeddedElectricCharacters:["*","}","]",")"]}),this.formattingSupport=this,this.extraInfoSupport=this,this.referenceSupport=new i.ReferenceSupport(this,{tokens:["invalid"],findReferences:function(e,t,n){return o.findReferences(e,t,n)}}),this.logicalSelectionSupport=this,this.parameterHintsSupport=new i.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["*"],getParameterHints:function(e,t){return o.getParameterHints(e,t)}}),this.suggestSupport=new i.SuggestSupport(this,{triggerCharacters:[".",":","<",'"',"=","/"],excludeTokens:["comment"],suggest:function(e,t){return o.suggest(e,t)}})}return __extends(t,e),t.prototype.asyncCtor=function(){var e=this;return c.Promise.join([f.getOrCreateMode("text/javascript"),f.getOrCreateMode("text/css")]).then(function(t){var n=e._getAutoClosingPairs(t);e.characterPairSupport=new i.CharacterPairSupport(e,{autoClosingPairs:n.slice(0),surroundingPairs:[{open:'"',close:'"'},{open:"'",close:"'"}]})})},t.prototype.getNonWordTokenTypes=function(){return["delimiter.html"]},t.prototype._getAutoClosingPairs=function(e){var t=this,n={'"':'"',"'":"'"};e.forEach(function(e){return t._collectAutoClosingPairs(n,e)});var r,i=[];for(r in n)i.push({open:r,close:n[r]});return i},t.prototype._collectAutoClosingPairs=function(e,t){if(t&&t.characterPairSupport){var n=t.characterPairSupport.getAutoClosingPairs();if(null!==n)for(var r=0;r<n.length;r++)e[n[r].open]=n[r].close}},t.prototype.getInitialState=function(){return new h(this,u.Content,"","","","","")},t.prototype.enterNestedMode=function(e){return e instanceof h&&e.kind===u.WithinEmbeddedContent},t.prototype.getNestedMode=function(e){var t=null,n=e,r=null;if(null!==n.embeddedContentType)f.isRegisteredMode(n.embeddedContentType)&&(t=f.getMode(n.embeddedContentType),t||(r=f.getOrCreateMode(n.embeddedContentType)));else{var i=null;i="script"===n.lastTagName?"text/javascript":"style"===n.lastTagName?"text/css":"text/plain",t=f.getMode(i)}return null===t&&(t=f.getMode("text/plain")),{mode:t,missingModePromise:r}},t.prototype.getLeavingNestedModeData=function(e,t){var n=t.lastTagName,r=new RegExp("<\\/"+n+"\\s*>","i"),i=r.exec(e);return null!==i?{nestedModeBuffer:e.substring(0,i.index),bufferAfterNestedMode:e.substring(i.index),stateAfterNestedMode:new h(this,u.Content,"","","","","")}:null},t.prototype.getWordDefinition=function(){return t.WORD_DEFINITION},t.prototype.getCommentsConfiguration=function(){return{blockCommentStartToken:"<!--",blockCommentEndToken:"-->"}},t.prototype._worker=function(t){return e.prototype._worker.call(this,t)},t.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.format(e,null,t)})},t.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.format(e,t,n)})},t.prototype.computeInfo=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().extraInfoSupport?n.getMode().extraInfoSupport.computeInfo(n.getAssociatedResource(),t):void 0})},t.prototype.findReferences=function(e,t,n){return this._delegateToModeAtPosition(e,t,function(e,r){return e&&r.getMode().referenceSupport?r.getMode().referenceSupport.findReferences(r.getAssociatedResource(),t,n):void 0})},t.prototype.getRangesToPosition=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().logicalSelectionSupport?n.getMode().logicalSelectionSupport.getRangesToPosition(n.getAssociatedResource(),t):void 0})},t.prototype.findDeclaration=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().declarationSupport?n.getMode().declarationSupport.findDeclaration(n.getAssociatedResource(),t):void 0})},t.prototype.findOccurrences=function(e,t,n){var r=this;return void 0===n&&(n=!1),this._delegateToModeAtPosition(e,t,function(i,o){return i&&o.getMode().occurrencesSupport?o.getMode().occurrencesSupport.findOccurrences(o.getAssociatedResource(),t,n):r._worker(function(r){return r.findOccurrences(e,t,n)})})},t.prototype.suggest=function(e,t){var n=this;return this._delegateToModeAtPosition(e,t,function(r,i){return r&&i.getMode().suggestSupport?i.getMode().suggestSupport.suggest(i.getAssociatedResource(),t):n._worker(function(n){return n.suggest(e,t)})})},t.prototype.findColorDeclarations=function(e){return this._delegateToAllModes(e,function(e){var t=[];return t=e.filter(function(e){return"function"==typeof e.getMode().findColorDeclarations}).map(function(e){return e.getMode().findColorDeclarations(e.getAssociatedResource())}),c.TPromise.join(t).then(function(e){var t=[];return e.forEach(function(e){return t=t.concat(e)}),t})})},t.prototype.getParameterHints=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().parameterHintsSupport?n.getMode().parameterHintsSupport.getParameterHints(n.getAssociatedResource(),t):void 0})},t.WORD_DEFINITION=r.createWordRegExp("#-?%"),t.$formatDocument=l.OneWorker(t,t.prototype.formatDocument),t.$formatRange=l.OneWorker(t,t.prototype.formatRange),t.$computeInfo=l.OneWorker(t,t.prototype.computeInfo),t.$findReferences=l.OneWorker(t,t.prototype.findReferences),t.$getRangesToPosition=l.OneWorker(t,t.prototype.getRangesToPosition),t.$findDeclaration=l.OneWorker(t,t.prototype.findDeclaration),t.$findOccurrences=l.OneWorker(t,t.prototype.findOccurrences),t.$suggest=l.OneWorker(t,t.prototype.suggest),t.$findColorDeclarations=l.OneWorker(t,t.prototype.findColorDeclarations),t.$getParameterHints=l.OneWorker(t,t.prototype.getParameterHints),t}(r.AbstractMode);t.HTMLMode=p;var f=s.Registry.as(r.Extensions.EditorModes)});