/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/html/htmlTags",["require","exports","vs/base/strings","vs/base/arrays"],function(e,t,n,r){function i(e){return-1!==r.binarySearch(a,e,function(e,t){return e.localeCompare(t)})}function o(){var e=[],t={html:["manifest"],head:e,title:e,noscript:e,section:e,nav:e,article:e,aside:e,h1:e,h2:e,h3:e,h4:e,h5:e,h6:e,hgroup:e,header:e,footer:e,address:e,p:e,hr:e,pre:e,blockquote:["cite"],ol:["reversed:v","start"],ul:e,li:["value"],dl:e,dt:e,dd:e,figure:e,figcaption:e,div:e,a:["href","target","ping","rel","media","hreflang","type"],em:e,strong:e,small:e,s:e,cite:e,q:["cite"],dfn:e,abbr:e,data:["value"],time:["datetime","pubdate"],code:e,var:e,samp:e,kbd:e,sub:e,sup:e,i:e,b:e,u:e,mark:e,ruby:e,rt:e,rp:e,bdi:e,bdo:e,span:e,br:e,wbr:e,ins:["cite","datetime"],del:["cite","datetime"],img:["alt","src","srcset","crossorigin:xo","usemap","ismap:v","width","height"],iframe:["src","srcdoc","name","sandbox","seamless","width","height"],embed:["src","type","width","height"],object:["data","type","typemustmatch:v","name","usemap","form","width","height"],param:["name","value"],video:["src","crossorigin:xo","poster","preload","autoplay:v","mediagroup","loop:v","muted:v","controls:v","width","height"],audio:["src","crossorigin:xo","preload","autoplay:v","mediagroup","loop:v","muted:v","controls:v"],source:["src","type","media"],track:["default:v","kind","label","src","srclang"],canvas:["width","height"],map:["name"],area:["alt","coords","shape","href","target","ping","rel","media","hreflang","type"],base:["href","target"],link:["href","rel","media","hreflang","type","sizes"],meta:["name","http-equiv","content","charset"],style:["media","type","scoped:v"],script:["src","async:v","defer:v","type","charset"],body:["onafterprint","onbeforeprint","onbeforeunload","onblur","onerror","onfocus","onhashchange","onload","onmessage","onoffline","ononline","onpagehide","onpageshow","onpopstate","onresize","onscroll","onstorage","onunload"],table:e,caption:e,colgroup:["span"],col:["span"],tbody:e,thead:e,tfoot:e,tr:e,td:["colspan","rowspan","headers"],th:["colspan","rowspan","headers","scope","abbr"],form:["accept-charset","action","autocomplete:o","enctype","method:m","name","novalidate:v","target"],fieldset:["disabled:v","form","name"],legend:e,label:["form","for"],input:["accept","alt","autocomplete:o","autofocus:v","checked:v","dirname","disabled:v","form","formaction","formenctype","formmethod:m","formnovalidate:v","formtarget","height","inputmode","list","max","maxlength","min","multiple:v","name","pattern","placeholder","readonly:v","required","size","src","step","type:t","value","width"],button:["autofocus:v","disabled:v","form","formaction","formenctype","formmethod:m","formnovalidate:v","formtarget","name","type:bt","value"],select:["autofocus:v","disabled:v","form","multiple:v","name","required:v","size"],datalist:["option"],optgroup:["disabled:v","label"],option:["disabled:v","label","selected:v","value"],textarea:["autocomplete:o","autofocus:v","cols","dirname","disabled:v","form","inputmode","maxlength","name","placeholder","readonly:v","required:v","rows","wrap"],keygen:["autofocus:v","challenge","disabled:v","form","keytype","name"],output:["for","form","name"],progress:["value","max"],meter:["value","min","max","low","high","optimum"],details:["open:v"],summary:e,command:["type","label","icon","disabled:v","checked:v","radiogroup","command"],menu:["type","label"],dialog:["open:v"]},r=["accesskey","class","contenteditable:b","contextmenu","dir:d","draggable:a","dropzone","hidden:v","id","inert:v","itemid","itemprop","itemref","itemscope:v","itemtype","lang","role","spellcheck:b","style","tabindex","title","translate"],i=["onabort","onblur","oncanplay","oncanplaythrough","onchange","onclick","oncontextmenu","ondblclick","ondrag","ondragend","ondragenter","ondragleave","ondragover","ondragstart","ondrop","ondurationchange","onemptied","onended","onerror","onfocus","onformchange","onforminput","oninput","oninvalid","onkeydown","onkeypress","onkeyup","onload","onloadeddata","onloadedmetadata","onloadstart","onmousedown","onmousemove","onmouseout","onmouseover","onmouseup","onmousewheel","onpause","onplay","onplaying","onprogress","onratechange","onreset","onreadystatechange","onseeked","onseeking","onselect","onshow","onstalled","onsubmit","onsuspend","ontimeupdate","onvolumechange","onwaiting"],o={b:["true","false"],a:["true","false","auto"],d:["ltr","rtl"],m:["get","post"],o:["on","off"],t:["hidden","text","search","tel","url","email","password","datetime","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"],bt:["button","submit","reset"],xo:["anonymous","use-credentials"]};return{collectTags:function(e){for(var n in t)e(n)},collectAttributes:function(e,n){if(r.forEach(function(e){var t=e.split(":");n(t[0],t[1])}),i.forEach(function(e){n(e,"event")}),e){var o=t[e];o&&o.forEach(function(e){var t=e.split(":");n(t[0],t[1])})}},collectValues:function(e,i,s){var a=i+":",c=function(e){e.forEach(function(e){if(e.length>a.length&&n.startsWith(e,a)){var t=e.substr(a.length);if("v"===t)s(i);else{var r=o[t];r&&r.forEach(s)}}})},l=t[e];l&&c(l),c(r)}}}function s(){var e={input:["ng-model","ng-required","ng-minlength","ng-maxlength","ng-pattern","ng-trim"],select:["ng-model"],textarea:["ng-model","ng-required","ng-minlength","ng-maxlength","ng-pattern","ng-trim"]},t=["ng-app","ng-bind","ng-bindhtml","ng-bindtemplate","ng-blur","ng-change","ng-checked","ng-class","ng-classeven","ng-classodd","ng-click","ng-cloak","ng-controller","ng-copy","ng-csp","ng-cut","ng-dblclick","ng-disabled","ng-focus","ng-form","ng-hide","ng-href","ng-if","ng-include","ng-init","ng-jq","ng-keydown","ng-keypress","ng-keyup","ng-list","ng-modelOptions","ng-mousedown","ng-mouseenter","ng-mouseleave","ng-mousemove","ng-mouseover","ng-mouseup","ng-nonbindable","ng-open","ng-options","ng-paste","ng-pluralize","ng-readonly","ng-repeat","ng-selected","ng-show","ng-src","ng-srcset","ng-style","ng-submit","ng-switch","ng-transclude","ng-value"];return{collectTags:function(){},collectAttributes:function(n,r){if(n){var i=e[n];i&&i.forEach(function(e){r(e,null),r("data-"+e,null)})}t.forEach(function(e){r(e,null),r("data-"+e,null)})},collectValues:function(){}}}var a=["area","base","basefont","br","col","command","embed","frame","hr","img","input","isindex","keygen","link","meta","param","source","track","wbr"];t.isEmptyElement=i,t.getHTML5TagProvider=o,t.getAngularTagProvider=s});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/html/htmlWorker",["require","exports","vs/base/lib/winjs.base","vs/editor/worker/modesWorker","vs/languages/lib/htmlLib","./htmlTags","vs/base/network","vs/editor/core/range","vs/base/strings"],function(e,t,n,r,i,o,s,a,c){function l(e,t){var n=t.column-1,r=t.lineNumber,i=e.getLineTokens(r),o=e.getLineContent(r),s=i.findIndexOfOffset(n),a=i.getTokenCount(),l=i.getTokenType(s),u=i.getTokenStartIndex(s),d=i.getTokenEndIndex(s,o.length);return""!==l&&!c.startsWith(l,"delimiter")||u!==n||(s--,s>=0?(l=i.getTokenType(s),u=i.getTokenStartIndex(s),d=i.getTokenEndIndex(s,o.length)):(l="",u=d=0)),{getTokenType:function(){return l},isTagToken:function(){return c.startsWith(l,h)},isAtTokenEnd:function(){return n===d},isAtTokenStart:function(){return n===u},getTokenContent:function(){return o.substring(u,d)},isOpenBrace:function(){return d>u&&"<"===o.charAt(u)},getTokenPosition:function(){return{lineNumber:r,column:u+1}},getTokenRange:function(){return{startLineNumber:r,startColumn:u+1,endLineNumber:r,endColumn:d+1}},getModel:function(){return e},scanBack:function(){if(0>=r)return!1;s--;do{for(;s>=0;){if(l=i.getTokenType(s),u=i.getTokenStartIndex(s),d=i.getTokenEndIndex(s,o.length),c.startsWith(l,"delimiter")||c.startsWith(l,"tag")||c.startsWith(l,"attribute"))return!0;s--}r--,r>0&&(i=e.getLineTokens(r),o=e.getLineContent(r),a=i.getTokenCount(),s=a-1)}while(r>0);return i=null,l=o="",u=d=a=0,!1},scanForward:function(){if(r>e.getLineCount())return!1;s++;do{for(;a>s;){if(l=i.getTokenType(s),u=i.getTokenStartIndex(s),d=i.getTokenEndIndex(s,o.length),c.startsWith(l,"delimiter")||c.startsWith(l,"tag")||c.startsWith(l,"attribute"))return!0;s++}r++,s=0,r<=e.getLineCount()&&(i=e.getLineTokens(r),o=e.getLineContent(r),a=i.getTokenCount())}while(r<=e.getLineCount());return l=o="",u=d=a=0,!1}}}function u(e){return/^\s*$/.test(e)}var d;!function(e){e[e.LOOKING_FOR_HREF_OR_SRC=1]="LOOKING_FOR_HREF_OR_SRC",e[e.AFTER_HREF_OR_SRC=2]="AFTER_HREF_OR_SRC"}(d||(d={}));var h="tag.html.tag-",p=function(e){function t(t,n,r){e.call(this,t,n,r),this._requestService=t.requestService,this._tagProviders=[],this._tagProviders.push(o.getHTML5TagProvider()),this.addCustomTagProviders(this._tagProviders)}return __extends(t,e),t.prototype.addCustomTagProviders=function(e){e.push(o.getAngularTagProvider())},t.prototype.format=function(e,t,r){var o=this.resourceService.get(e),s=t?o.getValueInRange(t):o.getValue(),a=i.style_html(s,{indent_size:r.insertSpaces?r.tabSize:1,indent_char:r.insertSpaces?" ":"	",max_char:120});return n.TPromise.as([{range:t,text:a}])},t.prototype.findMatchingOpenTag=function(e){for(var t={},n=!1;e.scanBack();)if(e.isTagToken()&&!n){var r=e.getTokenContent();if(e.scanBack(),"delimiter.end.html"===e.getTokenType())t[r]=(t[r]||0)+1;else if(!o.isEmptyElement(r)){if(!t[r])return r;t[r]--}}else"delimiter.start.html"===e.getTokenType()&&(n="/>"===e.getTokenContent());return null},t.prototype.collectTagSuggestions=function(e,t,n){var r=this,i=e.getModel(),o=i.getLineContent(t.lineNumber).substr(t.column-1),s=u(o)||c.startsWith(o,"<")?">":"",a=function(o){var a=e.getTokenPosition(),c=r.findMatchingOpenTag(e);if(c){var l={label:"/"+c,codeSnippet:"/"+c+s,type:"property"};if(n.suggestions.push(l),o){var d=e.getTokenPosition();if(a.lineNumber!==d.lineNumber){var h=i.getLineContent(d.lineNumber).substring(0,d.column-1),p=i.getLineContent(a.lineNumber).substring(0,a.column-1);u(h)&&u(p)&&(n.overwriteBefore=t.column-1,l.codeSnippet=h+"</"+c+s)}}return!0}return!1};if("delimiter.end.html"===e.getTokenType()){n.overwriteBefore=n.currentWord.length+1;var l=a(!0);l||(n.overwriteBefore=n.currentWord.length+1,this._tagProviders.forEach(function(e){e.collectTags(function(e){n.suggestions.push({label:"/"+e,codeSnippet:"/"+e+s,type:"property"})})}))}else a(!1),this._tagProviders.forEach(function(e){e.collectTags(function(e){n.suggestions.push({label:e,codeSnippet:e,type:"property"})})})},t.prototype.collectContentSuggestions=function(){},t.prototype.collectAttributeSuggestions=function(e,t){var n=null;do{if(e.isTagToken()){n=e.getTokenContent();break}if("delimiter.start.html"===e.getTokenType())break}while(e.scanBack());this._tagProviders.forEach(function(e){e.collectAttributes(n,function(e,n){var r=e;"v"!==n&&(r+='="{{}}"'),t.suggestions.push({label:e,codeSnippet:r,type:"handler"===n?"function":"value"})})})},t.prototype.collectAttributeValueSuggestions=function(e,t){for(var n="delimiter.assign.html"===e.getTokenType(),r=null,i=null;e.scanBack();)if("attribute.name.html"===e.getTokenType()){r=e.getTokenContent();break}for(;e.scanBack();){if(e.isTagToken()){i=e.getTokenContent();break}if("delimiter.start.html"===e.getTokenType())return}this._tagProviders.forEach(function(e){e.collectValues(i,r,function(e){t.suggestions.push({label:e,codeSnippet:n?'"'+e+'"':e,type:"unit"})})})},t.prototype.doSuggest=function(e,t){var r=this.resourceService.get(e),i=r.getWordUntilPosition(t,!0,!0).word,o={currentWord:i,suggestions:[]},s=l(r,t);switch(s.getTokenType()){case"delimiter.start.html":case"delimiter.end.html":s.isOpenBrace()?this.collectTagSuggestions(s,t,o):this.collectContentSuggestions(o);break;case"attribute.name.html":this.collectAttributeSuggestions(s,o);break;case"attribute.value.html":this.collectAttributeValueSuggestions(s,o);break;case"delimiter.assign.html":s.isAtTokenEnd()&&this.collectAttributeValueSuggestions(s,o);break;case"":if(u(s.getTokenContent())&&s.scanBack())switch(s.getTokenType()){case"attribute.value.html":case"attribute.name.html":this.collectAttributeSuggestions(s,o);break;case"delimiter.assign.html":this.collectAttributeValueSuggestions(s,o);break;case"delimiter.start.html":case"delimiter.end.html":s.isOpenBrace()?this.collectTagSuggestions(s,t,o):this.collectContentSuggestions(o);break;default:s.isTagToken()&&this.collectAttributeSuggestions(s,o)}else this.collectContentSuggestions(o);break;default:s.isTagToken()&&(s.scanBack(),this.collectTagSuggestions(s,t,o))}return n.Promise.as(o)},t.prototype.findMatchingBracket=function(e,t){if(o.isEmptyElement(e))return null;var n=0;if(t.scanBack(),"delimiter.end.html"===t.getTokenType())for(var r=!1;t.scanBack();)if(t.isTagToken()&&t.getTokenContent()===e&&!r){var i=t.getTokenRange();if(t.scanBack(),"delimiter.start.html"===t.getTokenType()){if(0===n)return i;n--}else n++}else"delimiter.start.html"===t.getTokenType()&&(r="/>"===t.getTokenContent());else for(var s=!1;t.scanForward();)if(t.isTagToken()&&t.getTokenContent()===e)if(s){if(n--,0>=n)return t.getTokenRange()}else if(t.scanForward(),"delimiter.start.html"===t.getTokenType()&&"/>"===t.getTokenContent()){if(0>=n)return null}else n++;else"delimiter.start.html"===t.getTokenType()?s=!1:"delimiter.end.html"===t.getTokenType()&&(s=!0);return null},t.prototype.findOccurrences=function(e,t){var r=this.resourceService.get(e),i=r.getWordAtPosition(t,!0,!0),o=i?i.word:"",s=[],a=l(r,t);if(a.isTagToken()){var c=a.getTokenContent();s.push({range:a.getTokenRange()});var u=this.findMatchingBracket(c,a);u&&s.push({range:u})}else for(var d=r.getAllWordsWithRange(),h=Math.min(1e3,d.length),p=0;h>p;p++)d[p].text===o&&s.push({range:d[p].range});return n.TPromise.as(s)},t._stripQuotes=function(e){return e.replace(/^'([^']+)'$/,function(e,t){return t}).replace(/^"([^"]+)"$/,function(e,t){return t})},t.prototype._getWorkspaceUrl=function(e,n,r){if(r=t._stripQuotes(r),/^\s*javascript\:/i.test(r)||/^\s*\#/i.test(r))return null;if(/^\s*https?:\/\//i.test(r))return r.replace(/^\s*/g,"");if(/^\s*\/\//i.test(r)){var i=e.getScheme(),o="http";return i===s.schemas.https&&(o=s.schemas.https),o+":"+r.replace(/^\s*/g,"")}var a=e.combine(r).toString();if(n&&e.startsWith(n)){var l=n.toString(),u=c.commonPrefixLength(l,a);return l+a.substr(u)}return a},t.prototype.createLink=function(e,t,n,r,i,o){var s=this._getWorkspaceUrl(e,t,n);return s?{range:{startLineNumber:r,startColumn:i,endLineNumber:r,endColumn:o},url:s}:null},t.prototype._computeHTMLLinks=function(e){var t,n,r,i,o,a,c,l,u,h,p=e.getLineCount(),f=[],m=d.LOOKING_FOR_HREF_OR_SRC,g=e.getAssociatedResource(),b=this._requestService.getRequestUrl("root","",!0),v=b?new s.URL(b):null;for(t=1;p>=t;t++)for(n=e.getLineContent(t),r=n.length,i=e.getLineTokens(t),c=0,a=i.getTokenCount();a>c;c++)switch(o=i.getTokenType(c)){case"delimiter.assign.html":case"":break;case"attribute.name.html":m===d.LOOKING_FOR_HREF_OR_SRC&&(l=i.getTokenEndIndex(c,r),u=n.substring(i.getTokenStartIndex(c),l).toLowerCase(),("src"===u||"href"===u)&&(m=d.AFTER_HREF_OR_SRC));break;case"attribute.value.html":m===d.AFTER_HREF_OR_SRC&&(l=i.getTokenEndIndex(c,r),u=n.substring(i.getTokenStartIndex(c),l),h=this.createLink(g,v,u,t,i.getTokenStartIndex(c)+2,l),h&&f.push(h),m=d.LOOKING_FOR_HREF_OR_SRC);default:0===o.indexOf("tag.html")?m=d.LOOKING_FOR_HREF_OR_SRC:m===d.AFTER_HREF_OR_SRC&&(m=d.LOOKING_FOR_HREF_OR_SRC)}return f},t.prototype.computeLinks=function(t){var n=this;return e.prototype.computeLinks.call(this,t).then(function(e){var r,i,o,s,c,l,u,d=n.resourceService.get(t),h=n._computeHTMLLinks(d),p=[];for(r=0,o=0,i=e.length,s=h.length;i>r&&s>o;)c=e[r],l=h[o],a.areIntersectingOrTouching(c.range,l.range)?r++:(u=a.compareRangesUsingStarts(c.range,l.range),0>u?(p.push(c),r++):(p.push(l),o++));for(;i>r;r++)p.push(e[r]);for(;s>o;o++)p.push(h[o]);return p})},t}(r.AbstractWorkerMode);t.HTMLWorker=p});