/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/debug/debugViewer",["require","exports","vs/base/lib/winjs.base","vs/base/env","vs/base/lifecycle","vs/base/errors","vs/base/paths","vs/base/async","vs/base/strings","vs/base/dom/dom","vs/base/ui/labels","vs/base/ui/events","vs/base/ui/widgets/actionbar","vs/base/ui/widgets/inputBox","vs/base/ui/widgets/tree/treeDefaults","vs/base/ui/widgets/tree/actionsRenderer","vs/workbench/contrib/debug/debug","vs/workbench/contrib/debug/debugModel","vs/workbench/contrib/debug/debugViewModel","vs/workbench/contrib/debug/debugActions"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f,m,g,v,y,_){function b(e,t,n){var r=e.getElementsByClassName(n);if(r.length>0)return r.item(0);var i=document.createElement(t);return n&&u.addClass(i,n),e.appendChild(i),i}t.getOrCreateChild=b;var E=function(e){function t(t,n,r){e.call(this,{actionProvider:n,actionRunner:r}),this.contextService=t}return __extends(t,e),t.prototype.getHeight=function(){return t.ELEMENT_HEIGHT},t.ELEMENT_HEIGHT=24,t}(m.ActionsRenderer);t.AbstractRenderer=E;var S=function(){function e(){}return e.prototype.hasActions=function(){return!1},e.prototype.getActions=function(){var e=[];return n.Promise.as(e)},e.prototype.hasSecondaryActions=function(){return!1},e.prototype.getSecondaryActions=function(){var e=[];return n.Promise.as(e)},e.prototype.getActionItem=function(){return null},e}();t.SimpleActionProvider=S;var T=function(e){function t(t,n,i){e.call(this),this.debugService=t,this.contextMenuService=n,this.actionProvider=i,r.isMacintosh?this.downKeyBindings["Meta-Backspace"]=this.onDelete.bind(this):(this.downKeyBindings.Delete=this.onDelete.bind(this),this.downKeyBindings["Shift-Delete"]=this.onDelete.bind(this))}return __extends(t,e),t.prototype.onContextMenu=function(e,t,n){var r=this;if(n.target&&n.target.tagName&&"input"===n.target.tagName.toLowerCase())return!1;if(n.preventDefault(),n.stopPropagation(),e.setFocus(t),this.actionProvider.hasSecondaryActions(e,t)){var i={x:n.posx+1,y:n.posy};return this.contextMenuService.showContextMenu({getAnchor:function(){return i},getActions:function(){return r.actionProvider.getSecondaryActions(e,t)},onHide:function(t){t&&e.DOMFocus()}}),!0}return!1},t.prototype.onDelete=function(){return!1},t}(f.DefaultController);t.BaseDebugController=T;var k=function(){function e(){}return e.prototype.getId=function(e,t){return t.getId()},e.prototype.hasChildren=function(e,t){return t instanceof v.Model||t instanceof v.Thread},e.prototype.getChildren=function(e,t){if(t instanceof v.Thread)return n.Promise.as(t.callStack);var r=t.getThreads(),i=[];for(var o in r)r.hasOwnProperty(o)&&i.push(r[o]);return 1===i.length?n.Promise.as(i[0].callStack):n.Promise.as(i)},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.CallStackDataSource=k;var C=function(e){function t(t,n,r){e.call(this,t,n,r)}return __extends(t,e),t.prototype.renderContents=function(e,t,n){if(t instanceof v.Thread){var r=t,i=b(n,"div","thread");i.textContent=r.name}else{var o=b(n,"div","stack-frame"),a=b(o,"span","label"),c=b(o,"div","file"),u=b(c,"span","file-name"),d=b(c,"span","line-number"),p=t;c.title=p.source.uri.fsPath,a.textContent=p.name,u.textContent=p.source.inMemory?p.source.name:l.getPathLabel(s.basename(p.source.uri.fsPath),this.contextService),d.textContent=""+p.lineNumber}return null},t}(E);t.CallStackRenderer=C;var w=function(e){function t(t){e.call(this),this.instantiationService=t}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof v.WatchExpression&&t.name!==v.WatchExpression.UNNAMED},t.prototype.hasSecondaryActions=function(e,t){return t instanceof v.WatchExpression},t.prototype.getActions=function(e,t){return n.Promise.as([this.instantiationService.createInstance(_.RemoveWatchExpressionAction,t)])},t.prototype.getSecondaryActions=function(e,t){var r=[this.instantiationService.createInstance(_.AddWatchExpressionAction,t)];return r.push(new p.Separator),r.push(this.instantiationService.createInstance(_.RemoveWatchExpressionAction,t)),r.push(this.instantiationService.createInstance(_.RemoveAllWatchExpressionsAction)),n.Promise.as(r)},t}(S);t.ExpressionsActionProvider=w;var x=function(){function e(e){this.debugService=e}return e.prototype.getId=function(e,t){return t.getId()},e.prototype.hasChildren=function(e,t){if(t instanceof y.ViewModel||t instanceof v.Scope||t instanceof v.Model)return!0;var n=t;return 0!==n.reference&&!c.equalsIgnoreCase(n.value,"null")},e.prototype.getChildren=function(e,t){if(t instanceof y.ViewModel){var r=t.getFocusedStackFrame();return r?n.Promise.as(r.scopes):n.Promise.as([])}if(t instanceof v.Model)return n.Promise.as(t.getWatchExpressions());var i=t;return i.getChildren(this.debugService)},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.ExpressionsDataSource=x;var A=function(e){function t(t,n,r,i,o,s){e.call(this,r,i,o),this.debugService=t,this.contextViewService=n,this.selectableWatches=s}return __extends(t,e),t.prototype.renderContents=function(e,t,n){return t instanceof v.Scope?this.renderScope(t,n):this.renderExpression(e,t,n)},t.prototype.renderScope=function(e,t){var n=b(t,"div","scope");return n.textContent=e.name,null},t.prototype.renderExpression=function(e,n,r){var i=b(r,"div","expression");if(this.selectableWatches[n.getId()]||n.name===v.WatchExpression.UNNAMED){var o=n instanceof v.WatchExpression;return this.createExpressionInputBox(e,i,o,n)}var s=b(i,"span","name"),a=b(i,"span","value");return n.value&&(n instanceof v.WatchExpression&&!n.available?(u.addClass(a,"unavailable"),this.debugService.getState()!==g.State.Inactive?u.addClass(a,"error"):u.removeClass(a,"error")):isNaN(+n.value)?t.BOOLEAN_REGEX.test(n.value)?u.addClass(a,"boolean"):t.STRING_REGEX.test(n.value)&&u.addClass(a,"string"):u.addClass(a,"number")),s.textContent=n.name,a.textContent=n.value,a.title=n.value,null},t.prototype.createExpressionInputBox=function(e,t,n,r){var o=this,s=new h.InputBox(t,this.contextViewService,{validationOptions:{validation:null,showMessage:!1}});n||(s.inputElement.readOnly=!0),s.value=n?r.name:r.value,s.focus();var c=!1,l=[s],d=a.once(function(t){c||(c=!0,t&&s.value?o.debugService.renameWatchExpression(r.getId(),s.value):r.name===v.WatchExpression.UNNAMED&&o.debugService.clearWatchExpressions(r.getId()),e.clearHighlight(),e.DOMFocus(),i.disposeAll(l))});return l.push(u.addStandardDisposableListener(s.inputElement,"keydown",function(e){("Escape"===e.asString()||"Enter"===e.asString())&&d(n&&"Enter"===e.asString())})),l.push(u.addDisposableListener(s.inputElement,"blur",function(){d(n)})),d},t.BOOLEAN_REGEX=/^true|false$/i,t.STRING_REGEX=/^(['"]).*\1$/,t}(E);t.ExpressionsRenderer=A;var L=function(e){function t(t,n,i,o){e.call(this,t,n,i),this.selectableExpressions=o,r.isMacintosh?this.downKeyBindings.Enter=this.onRename.bind(this):this.downKeyBindings.F2=this.onRename.bind(this)}return __extends(t,e),t.prototype.onLeftClick=function(t,n,r){return(n instanceof v.WatchExpression||n instanceof v.Variable)&&2===r.detail?(this.triggerExpressionSelection(t,n),!0):e.prototype.onLeftClick.call(this,t,n,r)},t.prototype.triggerExpressionSelection=function(e,t){var n=this,r=t;0===r.reference&&(this.selectableExpressions[r.getId()]=!0,e.refresh(r,!1).then(function(){e.setHighlight(r);var t=e.addListener(d.EventType.HIGHLIGHT,function(i){i.highlight||(n.selectableExpressions[r.getId()]=!1,e.refresh(r).done(null,o.onUnexpectedError),t())})}).done(null,o.onUnexpectedError))},t.prototype.onRename=function(e){var t=e.getFocus();return t instanceof v.WatchExpression?(this.triggerExpressionSelection(e,t),!0):!1},t.prototype.onDelete=function(e){var t=e.getFocus();if(t instanceof v.WatchExpression){var n=t;return this.debugService.clearWatchExpressions(n.getId()),!0}return!1},t}(T);t.ExpressionsController=L;var I=function(e){function t(t){e.call(this),this.instantiationService=t}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof v.Breakpoint},t.prototype.hasSecondaryActions=function(e,t){return t instanceof v.Breakpoint||t instanceof v.ExceptionBreakpoint},t.prototype.getActions=function(e,t){return t instanceof v.Breakpoint?n.Promise.as([this.instantiationService.createInstance(_.RemoveBreakpointAction,t)]):n.Promise.as([])},t.prototype.getSecondaryActions=function(e,t){var r=[this.instantiationService.createInstance(_.ToggleEnablementAction,t)];return r.push(new p.Separator),r.push(this.instantiationService.createInstance(_.RemoveBreakpointAction,t)),r.push(this.instantiationService.createInstance(_.RemoveAllBreakpointsAction)),r.push(new p.Separator),r.push(this.instantiationService.createInstance(_.ToggleBreakpointsActivatedAction)),r.push(new p.Separator),r.push(this.instantiationService.createInstance(_.EnableAllBreakpointsAction)),r.push(this.instantiationService.createInstance(_.DisableAllBreakpointsAction)),r.push(new p.Separator),r.push(this.instantiationService.createInstance(_.ReapplyBreakpointsAction)),n.Promise.as(r)},t}(S);t.BreakpointsActionProvider=I;var N=function(){function e(){}return e.prototype.getId=function(e,t){return t.getId()},e.prototype.hasChildren=function(e,t){return t instanceof v.Model},e.prototype.getChildren=function(e,t){var r=t,i=r.getExceptionBreakpoints();return n.Promise.as(i.concat(r.getBreakpoints()))},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.BreakpointsDataSource=N;var P=function(e){function t(t,n,r,i){e.call(this,n,r,i),this.debugService=t,this.toDispose=[]}return __extends(t,e),t.prototype.renderContents=function(e,t,n){var r=b(n,"div","breakpoint");r.appendChild(this.createCheckbox(t));var i=b(r,"span","name");if(t instanceof v.Breakpoint){this.debugService.getModel().areBreakpointsActivated()?e.removeTraits("disabled",[t]):e.addTraits("disabled",[t]);var o=t,a=b(r,"span","line-number"),u=b(r,"span","file-path");i.textContent=l.getPathLabel(s.basename(o.source.uri.fsPath),this.contextService),a.textContent=o.desiredLineNumber!==o.lineNumber?o.desiredLineNumber+" → "+o.lineNumber:""+o.lineNumber,u.textContent=l.getPathLabel(s.dirname(o.source.uri.fsPath),this.contextService)}else{var d=t,p=d.name.charAt(0).toUpperCase()+d.name.slice(1);i.textContent=c.format("{0} exceptions",p)}return null},t.prototype.createCheckbox=function(e){var t=this,n=document.createElement("input");return n.type="checkbox",n.className="checkbox",n.checked=e.enabled,this.toDispose.push(u.addStandardDisposableListener(n,"change",function(){t.debugService.toggleEnablement(e)})),n},t.prototype.dispose=function(){this.debugService=null,this.toDispose=i.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(E);t.BreakpointsRenderer=P;var O=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.onLeftClick=function(t,n,r,i){return void 0===i&&(i="mouse"),n instanceof v.ExceptionBreakpoint?!1:e.prototype.onLeftClick.call(this,t,n,r,i)},t.prototype.onUp=function(t,n){return this.doNotFocusExceptionBreakpoint(t,e.prototype.onUp.call(this,t,n))},t.prototype.onPageUp=function(t,n){return this.doNotFocusExceptionBreakpoint(t,e.prototype.onPageUp.call(this,t,n))},t.prototype.doNotFocusExceptionBreakpoint=function(e,t){if(t){var n=e.getFocus();n instanceof v.ExceptionBreakpoint&&e.focusNth(2)}return t},t.prototype.onDelete=function(e){var t=e.getFocus();if(t instanceof v.Breakpoint){var n=t;return this.debugService.toggleBreakpoint(n.source.uri,n.lineNumber),!0}return!1},t}(T);t.BreakpointsController=O});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/debug/debugActionItems",["require","exports","vs/base/lifecycle","vs/base/dom/dom","vs/base/ui/widgets/actionbar","vs/platform/services","vs/workbench/contrib/debug/debug"],function(e,t,n,r,i,o,s){var a=function(e){function t(t,n){e.call(this,t,n),this.debugService=t.debugService,this.select=document.createElement("select"),this.select.className="debug-select action-bar-select",this.toDispose=[],this.registerListeners(t)}return __extends(t,e),t.prototype.registerListeners=function(e){var t=this;this.toDispose.push(r.addStandardDisposableListener(this.select,"change",function(e){t.actionRunner.run(t._action,e.target.value).done()})),this.toDispose.push(this.debugService.addListener2(s.ServiceEvents.STATE_CHANGED,function(){t.select.disabled=t.debugService.getState()!==s.State.Inactive})),this.toDispose.push(e.configurationService.addListener2(o.ConfigurationServiceEventTypes.UPDATED,function(){t.setOptions().done()}))},t.prototype.render=function(e){r.addClass(e,"select-container"),e.appendChild(this.select),this.setOptions().done()},t.prototype.setOptions=function(){var e=this,t=this.select.selectedIndex;return this.select.options.length=0,this.debugService.loadLaunchConfig().then(function(n){if(!n||!n.configurations)return e.select.options.add(e.createOption("<none>")),e.select.disabled=!0,void 0;var r=n.configurations;e.select.disabled=r.length<1;for(var i=!1,o=0;o<r.length;o++)e.select.options.add(e.createOption(r[o].name)),r[o].name===e.debugService.selectedConfigName&&(e.select.selectedIndex=o,i=!0);return!i&&r.length>0?((!t||0>t||t>=r.length)&&(t=0),e.select.selectedIndex=t,e.actionRunner.run(e._action,r[t].name)):void 0})},t.prototype.createOption=function(e){var t=document.createElement("option");return t.value=e,t.text=e,t},t.prototype.dispose=function(){this.debugService=null,this.toDispose=n.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(i.BaseActionItem);t.SelectConfigActionItem=a}),define("vs/css!vs/workbench/contrib/debug/media/debugViewlet",["vs/css!vs/workbench/contrib/debug/debugViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/debug/debugViewlet",["require","exports","vs/nls!vs/workbench/contrib/debug/debugViewlet","vs/base/dom/dom","vs/base/dom/builder","vs/base/lib/winjs.base","vs/base/lifecycle","vs/workbench/ui/actionBarRegistry","vs/base/ui/widgets/tree/treeImpl","vs/base/ui/widgets/splitview","vs/workbench/ui/parts/viewlet","vs/workbench/contrib/debug/debug","vs/workbench/contrib/debug/debugModel","vs/workbench/contrib/debug/debugViewer","vs/workbench/contrib/debug/debugActions","vs/workbench/contrib/debug/debugActionItems","vs/css!./media/debugViewlet"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f,m){function g(e){var t=document.createElement("div");return r.addClass(t,"debug-view-content"),e.appendChild(t),t}var v={indentPixels:8,twistiePixels:20},y=i.$,_=function(e){function t(t,n){e.call(this,t,n,"variablesView"),this.debugService=t.debugService,this.contextService=t.contextService,this.contextViewService=t.contextViewService,this.instantiationService=t.instantiationService,this.actionProvider=new h.SimpleActionProvider}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=y("div.title").appendTo(t);y("span").text(n.localize("vs_workbench_contrib_debug_debugViewlet",0)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.treeContainer=g(e),r.addClass(this.treeContainer,"debug-variables");var n={};this.tree=new c.Tree(this.treeContainer,{dataSource:new h.ExpressionsDataSource(this.debugService),renderer:new h.ExpressionsRenderer(this.debugService,this.contextViewService,this.contextService,this.actionProvider,this.actionRunner,n),controller:new h.ExpressionsController(this.debugService,this.contextMenuService,this.actionProvider,n)},v);var i=this.debugService.getViewModel();this.tree.setInput(i);var o=this.instantiationService.createInstance(l.CollapseAction,this.tree,!1,"explorer-action collapse-explorer");this.toolBar.setActions(a.prepareActions([o]))(),this.toDispose.push(i.addListener2(d.ViewModelEvents.FOCUSED_STACK_FRAME_UPDATED,function(){return t.onFocusedStackFrameUpdated()})),this.toDispose.push(this.debugService.addListener2(d.ServiceEvents.STATE_CHANGED,function(){o.enabled=t.debugService.getState()===d.State.Running||t.debugService.getState()===d.State.Stopped}))},t.prototype.onFocusedStackFrameUpdated=function(){var e=this;this.tree.refresh().done(function(){var t=e.debugService.getViewModel().getFocusedStackFrame();return t&&t.scopes.length>0?e.tree.expand(t.scopes[0]):void 0})},t}(l.CollapsibleViewletView),b=function(e){function t(t,n){e.call(this,t,n,"expressionsView"),this.debugService=t.debugService,this.instantiationService=t.instantiationService,this.contextService=t.contextService,this.contextViewService=t.contextViewService,this.actionProvider=new h.ExpressionsActionProvider(this.instantiationService)}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=y("div.title").appendTo(t);y("span").text(n.localize("vs_workbench_contrib_debug_debugViewlet",1)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.treeContainer=g(e),r.addClass(this.treeContainer,"debug-watch");var n={};this.tree=new c.Tree(this.treeContainer,{dataSource:new h.ExpressionsDataSource(this.debugService),renderer:new h.ExpressionsRenderer(this.debugService,this.contextViewService,this.contextService,this.actionProvider,this.actionRunner,n),controller:new h.ExpressionsController(this.debugService,this.contextMenuService,this.actionProvider,n)},v);var i=this.debugService.getModel();this.tree.setInput(i);var o=this.instantiationService.createInstance(f.AddWatchExpressionAction),s=this.instantiationService.createInstance(l.CollapseAction,this.tree,!1,"explorer-action collapse-explorer"),u=this.instantiationService.createInstance(f.RemoveAllWatchExpressionsAction);this.toolBar.setActions(a.prepareActions([o,s,u]))(),this.toDispose.push(this.debugService.getModel().addListener2(d.ModelEvents.WATCH_EXPRESSIONS_UPDATED,function(){return t.onWatchExpressionsUpdated()})),this.toDispose.push(this.debugService.addListener2(d.ServiceEvents.STATE_CHANGED,function(){s.enabled=t.debugService.getState()===d.State.Running||t.debugService.getState()===d.State.Stopped,t.debugService.getState()===d.State.Inactive&&t.onWatchExpressionsUpdated()}))},t.prototype.onWatchExpressionsUpdated=function(){this.tree.refresh().done()},t}(l.CollapsibleViewletView),E=function(e){function t(t,n){e.call(this,t,n,"callStackView"),this.debugService=t.debugService,this.contextService=t.contextService}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=y("div.title").appendTo(t);y("span").text(n.localize("vs_workbench_contrib_debug_debugViewlet",2)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.renderMessageBox(e),this.treeContainer=g(e),r.addClass(this.treeContainer,"debug-call-stack"),this.tree=new c.Tree(this.treeContainer,{dataSource:new h.CallStackDataSource,renderer:new h.CallStackRenderer(this.contextService,new h.SimpleActionProvider,this.actionRunner)},v);var i=this.debugService.getModel();this.tree.setInput(i),this.toDispose.push(this.tree.addListener2("selection",function(e){if(e.selection.length){var n=e.selection[0];if(n instanceof p.StackFrame){var r=n;t.debugService.setFocusedStackFrameAndEvaluate(r);var i="mouse"===e.payload.origin,o=e&&e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey);t.debugService.openOrRevealEditor(r.source,r.lineNumber,i,o)}}})),this.toDispose.push(i.addListener2(d.ModelEvents.THREADS_UPDATED,function(){t.tree.refresh()})),this.toDispose.push(this.debugService.addListener2(d.ServiceEvents.STATE_CHANGED,function(e){return t.debugService.getState()===d.State.Stopped&&"step"!==e?(t.messageBox.textContent=n.localize("vs_workbench_contrib_debug_debugViewlet",3,e),"exception"===e?t.messageBox.classList.add("exception"):t.messageBox.classList.remove("exception"),t.messageBox.hidden=!1,void 0):(t.messageBox.hidden=!0,void 0)})),this.toDispose.push(this.debugService.getViewModel().addListener2(d.ViewModelEvents.FOCUSED_STACK_FRAME_UPDATED,function(){var e=t.debugService.getViewModel().getFocusedStackFrame();if(e){var n=t.debugService.getModel().getThreads();for(var r in n)n[r].callStack.some(function(t){return t===e})&&t.tree.expand(n[r]);t.tree.setFocus(e)}}))},t.prototype.renderMessageBox=function(e){this.messageBox=document.createElement("div"),r.addClass(this.messageBox,"debug-message-box"),this.messageBox.hidden=!0,e.appendChild(this.messageBox)},t}(l.CollapsibleViewletView),S=function(e){function t(n,r){var i=this,o=n.debugService.getModel().getBreakpoints().length+n.debugService.getModel().getExceptionBreakpoints().length;e.call(this,n,r,t.getExpandedBodySize(o),!1,"breakpointsView"),this.debugService=n.debugService,this.contextService=n.contextService,this.instantiationService=n.instantiationService,this.actionProvider=new h.BreakpointsActionProvider(this.instantiationService),this.toDispose.push(this.debugService.getModel().addListener2(d.ModelEvents.BREAKPOINTS_UPDATED,function(){return i.onBreakpointsChange()}))}return __extends(t,e),t.prototype.renderHeader=function(t){e.prototype.renderHeader.call(this,t);var r=y("div.title").appendTo(t);y("span").text(n.localize("vs_workbench_contrib_debug_debugViewlet",4)).appendTo(r)},t.prototype.renderBody=function(e){var t=this;this.treeContainer=g(e),r.addClass(this.treeContainer,"debug-breakpoints"),this.tree=new c.Tree(this.treeContainer,{dataSource:new h.BreakpointsDataSource,renderer:new h.BreakpointsRenderer(this.debugService,this.contextService,this.actionProvider,this.actionRunner),controller:new h.BreakpointsController(this.debugService,this.contextMenuService,this.actionProvider),sorter:{compare:function(e,t,n){var r=t,i=n;return r instanceof p.ExceptionBreakpoint?-1:i instanceof p.ExceptionBreakpoint?1:r.source.uri.toString()!==i.source.uri.toString()?r.source.uri.toString().localeCompare(i.source.uri.toString()):r.desiredLineNumber-i.desiredLineNumber}}},v);var n=this.debugService.getModel();this.tree.setInput(n),this.toDispose.push(this.tree.addListener2("selection",function(e){if(e.selection.length){var n=e.selection[0];if(n instanceof p.Breakpoint){var r=n;if(!r.source.inMemory){var i="mouse"===e.payload.origin,o=e&&e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey);t.debugService.openOrRevealEditor(r.source,r.lineNumber,i,o)}}}})),this.tree.refresh()},t.prototype.getActions=function(){return[this.instantiationService.createInstance(f.ReapplyBreakpointsAction),this.instantiationService.createInstance(f.ToggleBreakpointsActivatedAction),this.instantiationService.createInstance(f.RemoveAllBreakpointsAction)]},t.prototype.onBreakpointsChange=function(){this.expandedBodySize=t.getExpandedBodySize(this.debugService.getModel().getBreakpoints().length+this.debugService.getModel().getExceptionBreakpoints().length),this.tree&&this.tree.refresh()},t.getExpandedBodySize=function(e){return Math.min(t.MAX_VISIBLE_FILES,e)*h.AbstractRenderer.ELEMENT_HEIGHT},t.MAX_VISIBLE_FILES=9,t}(l.AdaptiveCollapsibleViewletView),T=function(e){function t(t){var n=this;e.call(this,t,d.VIEWLET_ID),this.progressService=t.progressService,this.debugService=t.debugService,this.instantiationService=t.instantiationService,this.contextService=t.contextService,this.progressRunner=null,this.toDispose=[],this.toDispose.push(this.debugService.addListener2(d.ServiceEvents.STATE_CHANGED,function(){n.onDebugServiceStateChange()}))}return __extends(t,e),t.prototype.create=function(t){e.prototype.create.call(this,t),this.$el=t.div().addClass("debug-viewlet"),this.splitView=new u.SplitView(this.$el.getHTMLElement());var n=this.getActionRunner();return this.splitView.addView(this.instantiationService.createInstance(_,n)),this.splitView.addView(this.instantiationService.createInstance(b,n)),this.splitView.addView(this.instantiationService.createInstance(E,n)),this.splitView.addView(this.instantiationService.createInstance(S,n)),o.Promise.as(null)},t.prototype.layout=function(t){e.prototype.layout.call(this,t),this.splitView&&this.splitView.layout(t.height)},t.prototype.getActions=function(){var e=this;return this.actions||(this.actions=[this.instantiationService.createInstance(f.StartDebugAction),this.instantiationService.createInstance(f.SelectConfigAction),this.instantiationService.createInstance(f.ConfigureAction)],this.actions.forEach(function(t){e.toDispose.push(t)})),this.actions},t.prototype.getActionItem=function(e){return e.id===f.SelectConfigAction.ID?this.instantiationService.createInstance(m.SelectConfigActionItem,e):null},t.prototype.getSecondaryActions=function(){return[]},t.prototype.onDebugServiceStateChange=function(){this.progressRunner&&this.progressRunner.done(),this.progressRunner=this.debugService.getState()===d.State.Initializing?this.progressService.show(!0):null},t.prototype.dispose=function(){this.toDispose=s.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(l.Viewlet);t.DebugViewlet=T});