/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/gitActions",["require","exports","vs/base/lib/winjs.base","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/base/lifecycle","vs/base/strings","vs/base/types","vs/base/ui/actions","vs/workbench/contrib/git/git","vs/workbench/contrib/git/gitModel","vs/workbench/contrib/git/gitEditorInputs","vs/workbench/ui/parts/editor/editorOptions","vs/base/errors","vs/base/env"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h){function f(e,t){if(void 0===t&&(t=!1),e){if(Array.isArray(e)){if(e.some(function(e){return!(e instanceof u.FileStatus)}))throw new Error("Invalid context.");return e}if(e instanceof u.FileStatus)return[e];if(e instanceof u.StatusGroup)return e.all();if(e.tree){var n=e.tree.getSelection();return n.indexOf(e.fileStatus)>-1?n:[e.fileStatus]}if(e.selection)return!t&&e.selection.indexOf(e.focus)>-1?e.selection:[e.focus];throw new Error("Invalid context.")}return e}var m=function(e){function t(t,n,r,i){var o=this;this.gitService=t.gitService,e.call(this,n,r,i,!1),this.toDispose=[this.gitService.addBulkListener2(function(){return o.onGitServiceChange()})],this.onGitServiceChange()}return __extends(t,e),t.prototype.onGitServiceChange=function(){this.updateEnablement()},t.prototype.updateEnablement=function(){this.enabled=this.isEnabled()},t.prototype.isEnabled=function(){return!!this.gitService},t.prototype.run=function(){throw new Error("implement me")},t.prototype.dispose=function(){this.gitService=null,this.toDispose=i.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(a.Action);t.AbstractGitAction=m;var g=function(e){function t(n){this.editorService=n.editorService,e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",0),"git-action open-change")}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.editorService},t.prototype.run=function(e){var t=this,n=f(e,!0);return this.gitService.getInput(n[0]).then(function(e){var n=new d.TextDiffEditorOptions;return n.forceOpen=!0,t.editorService.openEditor(e,n)})},t.ID="workbench.git.action.openChange",t}(m);t.OpenChangeAction=g;var v=function(e){function t(n){this.fileService=n.fileService,this.editorService=n.editorService,e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",1),"git-action open-file")}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.editorService||!!this.fileService},t.prototype.getPath=function(e){if(e.getStatus()===c.Status.INDEX_RENAMED)return e.getRename();var t=this.gitService.getModel().getStatus().find(e.getPath(),c.StatusType.INDEX);return t&&t.getStatus()===c.Status.INDEX_RENAMED?e.getRename():e.getPath()},t.prototype.run=function(e){var r=this,i=f(e,!0),o=i[0];if(!(o instanceof u.FileStatus))return n.Promise.wrapError(new Error("Can't open file."));if(t.DELETED_STATES.indexOf(o.getStatus())>-1)return n.Promise.wrapError(new Error("Can't open file which is has been deleted."));var s=this.getPath(o);return this.fileService.resolveFileStat(s).then(function(e){return r.editorService.openEditor({resource:e.resource,mime:e.mime,options:{forceOpen:!0}})})},t.DELETED_STATES=[c.Status.BOTH_DELETED,c.Status.DELETED,c.Status.DELETED_BY_US,c.Status.INDEX_DELETED],t.ID="workbench.git.action.openFile",t}(m);t.OpenFileAction=v;var y=function(e){function t(n){e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",2),"git-action init")}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getState()===c.ServiceState.NotARepo},t.prototype.run=function(){return this.gitService.init()},t.ID="workbench.git.action.init",t}(m);t.InitAction=y;var _=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",3)),void 0===s&&(s="git-action run-clone"),this.terminalService=n.terminalService,e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.terminalService&&this.gitService.getState()===c.ServiceState.NotARepo},t.prototype.run=function(e){return this.terminalService.execute('git clone "'+e+'" .',!1,!0)},t.ID="workbench.git.action.runClone",t}(m);t.RunCloneAction=_;var b=function(e){function t(n){e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",4),"git-action refresh")}return __extends(t,e),t.prototype.run=function(){return this.gitService.status()},t.ID="workbench.git.action.refresh",t}(m);t.RefreshAction=b;var E=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",5)),void 0===s&&(s="git-action stage"),e.call(this,n,i,o,s),this.editorService=n.editorService}return __extends(t,e),t.prototype.run=function(e){var t=this,r=f(e);return this.gitService.add(f(e)).then(function(e){var i=t.findGitWorkingTreeEditor();if(!i)return n.Promise.as(e);var o=i.input,s=o.getFileStatus();if(r&&r.every(function(e){return e!==s}))return n.Promise.as(e);var a=o.getFileStatus().getPath(),u=e.getStatus().find(a,c.StatusType.INDEX);if(!u)return n.Promise.as(e);var l=i.getControl(),p=l?l.saveViewState():null;return t.gitService.getInput(u).then(function(n){var r=new d.TextDiffEditorOptions;return r.forceOpen=!0,t.editorService.openEditor(n,r,i.position).then(function(){return p&&l.restoreViewState(p),e})})})},t.prototype.findGitWorkingTreeEditor=function(){for(var e=this.editorService.getVisibleEditors(),t=0;t<e.length;t++){var n=e[t];if(l.isGitEditorInput(n.input))return n}return null},t.prototype.dispose=function(){this.editorService=null,e.prototype.dispose.call(this)},t.ID="workbench.git.action.stage",t}(m);t.StageAction=E;var S=function(e){function t(n){e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",6))}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getWorkingTreeStatus().all().length>0},t.prototype.run=function(){return e.prototype.run.call(this)},t.ID="workbench.git.action.stageAll",t}(E);t.GlobalStageAction=S;var T=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",7)),void 0===s&&(s="git-action undo"),this.eventService=n.eventService,this.editorService=n.editorService,this.messageService=n.messageService,this.fileService=n.fileService,e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.eventService&&!!this.editorService&&!!this.fileService},t.prototype.run=function(e){var t=this;if(!this.messageService.confirm(this.getConfirm(e)))return n.Promise.as(null);var r=[];if(e instanceof u.StatusGroup)r=[this.gitService.undo()];else{for(var i=f(e),o=[],s=[],a=0;a<i.length;a++){var l=i[a].clone();switch(l.getStatus()){case c.Status.UNTRACKED:case c.Status.IGNORED:o.push(l);break;default:s.push(l)}}o.length>0&&r.push(this.gitService.clean(o)),s.length>0&&r.push(this.gitService.checkout("",s))}return n.Promise.join(r).then(function(e){if(0===e.length)return n.Promise.as(null);var r=e[e.length-1],o=t.findWorkingTreeDiffEditor();if(!o)return n.Promise.as(r);var s=o.input,a=s.getFileStatus();if(i&&i.every(function(e){return e!==a}))return n.Promise.as(r);var c=s.getFileStatus().getPath(),u=o.getControl(),l=u?u.getModifiedEditor():null,d=l?l.saveViewState():null;return t.fileService.resolveFileStat(c).then(function(e){return t.editorService.openEditor({resource:e.resource,mime:e.mime,options:{forceOpen:!0}},o.position).then(function(){if(d){var e=o.getControl();e&&e.restoreViewState(d)}})})}).then(null,function(e){return console.error("One or more errors occured",e),n.Promise.wrapError(e[0])})},t.prototype.findWorkingTreeDiffEditor=function(){for(var e=this.editorService.getVisibleEditors(),t=0;t<e.length;t++){var n=e[t];if(n.input instanceof l.GitWorkingTreeDiffEditorInput)return n}return null},t.prototype.getConfirm=function(e){if(e instanceof u.StatusGroup){var t=e,n=t.all(),i=n.length;return{message:r.localize("vs_workbench_contrib_git_gitActions",8),detail:1===i?r.localize("vs_workbench_contrib_git_gitActions",9,i):r.localize("vs_workbench_contrib_git_gitActions",10,i),primaryButton:r.localize("vs_workbench_contrib_git_gitActions",11)}}var o=f(e)[0],s=o.getPathComponents().reverse()[0];return{message:r.localize("vs_workbench_contrib_git_gitActions",12,s),primaryButton:r.localize("vs_workbench_contrib_git_gitActions",13)}},t.prototype.dispose=function(){this.eventService=null,this.editorService=null,this.fileService=null,e.prototype.dispose.call(this)},t.ID="workbench.git.action.undo",t}(m);t.UndoAction=T;var k=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",14)),void 0===s&&(s="git-action unstage"),this.editorService=n.editorService,e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.editorService},t.prototype.run=function(e){var t=this,r=f(e);return this.gitService.reset("HEAD",r).then(function(e){var i=t.findGitIndexEditor();if(!i)return n.Promise.as(e);var o=i.input,s=o.getFileStatus();if(r&&r.every(function(e){return e!==s}))return n.Promise.as(e);var a=o.getFileStatus().getPath(),u=e.getStatus().find(a,c.StatusType.WORKING_TREE);if(!u)return n.Promise.as(e);var l=i.getControl(),p=l?l.saveViewState():null;return t.gitService.getInput(u).then(function(n){var r=new d.TextDiffEditorOptions;return r.forceOpen=!0,t.editorService.openEditor(n,r,i.position).then(function(){return p&&l.restoreViewState(p),e})})})},t.prototype.findGitIndexEditor=function(){for(var e=this.editorService.getVisibleEditors(),t=0;t<e.length;t++){var n=e[t];if(l.isGitEditorInput(n.input))return n}return null},t.prototype.dispose=function(){this.editorService=null,e.prototype.dispose.call(this)},t.ID="workbench.git.action.unstage",t}(m);t.UnstageAction=k;var w=function(e){function t(n){e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",15))}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getIndexStatus().all().length>0},t.prototype.run=function(){return e.prototype.run.call(this)},t.ID="workbench.git.action.unstageAll",t}(k);t.GlobalUnstageAction=w;var C=function(e){function t(n){e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",16))}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getWorkingTreeStatus().all().length>0},t.prototype.run=function(){return e.prototype.run.call(this,this.gitService.getModel().getStatus().getWorkingTreeStatus())},t.ID="workbench.git.action.undoAll",t}(T);t.GlobalUndoAction=C;var x;!function(e){e[e.Alive=0]="Alive",e[e.Disposing=1]="Disposing",e[e.Disposed=2]="Disposed"}(x||(x={}));var A=function(e){function t(n,r){this.editorService=n.editorService,this.branch=r,this.HEAD=null,this.state=x.Alive,this.runPromises=[],e.call(this,n,t.ID,r.name,"git-action checkout")}return __extends(t,e),t.prototype.onGitServiceChange=function(){this.gitService.getState()===c.ServiceState.OK&&(this.HEAD=this.gitService.getModel().getHEAD(),this.class=this.HEAD&&this.HEAD.name===this.branch.name?"git-action checkout HEAD":"git-action checkout"),e.prototype.onGitServiceChange.call(this)},t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.HEAD},t.prototype.run=function(){var e=this;if(this.state!==x.Alive)return n.Promise.wrapError("action disposed");if(this.HEAD&&this.HEAD.name===this.branch.name)return n.Promise.as(null);var t=this.gitService.checkout(this.branch.name).then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.DirtyWorkTree?n.Promise.wrapError(new Error(r.localize("vs_workbench_contrib_git_gitActions",17))):n.Promise.wrapError(e)});return this.runPromises.push(t),t.done(function(){return e.runPromises.splice(e.runPromises.indexOf(t),1)}),t},t.prototype.dispose=function(){var e=this;this.state===x.Alive&&(this.state=x.Disposing,n.Promise.join(this.runPromises).done(function(){return e.actuallyDispose()}))},t.prototype.actuallyDispose=function(){this.editorService=null,this.branch=null,this.HEAD=null,e.prototype.dispose.call(this),this.state=x.Disposed},t.ID="workbench.git.action.checkout",t}(m);t.CheckoutAction=A;var L=function(e){function t(n,i){void 0===i&&(i=!1),e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",18),"git-action checkout"),this.checkout=i}return __extends(t,e),t.prototype.run=function(e){return s.isString(e)?this.gitService.branch(e,this.checkout):n.Promise.as(!1)},t.ID="workbench.git.action.branch",t}(m);t.BranchAction=L;var I=function(e){function t(t,n,r,i){e.call(this,t,n,r,i)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getIndexStatus().all().length>0},t}(m);t.AbstractCommitAction=I;var N=function(e){function t(n){this.terminalService=n.terminalService,e.call(this,n,t.ID,r.localize("vs_workbench_contrib_git_gitActions",19),"git-action run-amend-commit")}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.terminalService},t.prototype.run=function(){return this.terminalService.execute("git commit --amend")},t.ID="workbench.git.action.runAmendCommit",t}(m);t.RunAmendCommitAction=N;var P=function(e){function t(n,i,o,s,a){var c=this;void 0===o&&(o=t.ID),void 0===s&&(s=r.localize("vs_workbench_contrib_git_gitActions",20)),void 0===a&&(a="git-action commit"),e.call(this,n,o,s,a),this.commitState=i,this.toDispose.push(i.addListener2("change/commitInputBox",function(){c.updateEnablement()}))}return __extends(t,e),t.prototype.run=function(){return this.commitState.getCommitMessage()?this.gitService.commit(this.commitState.getCommitMessage()):(this.commitState.onEmptyCommitMessage(),n.Promise.as(null))},t.ID="workbench.git.action.commit",t}(I);t.CommitAction=P;var O=function(e){function t(n,i){e.call(this,n,i,t.ID,r.localize("vs_workbench_contrib_git_gitActions",21),"git-action stage-and-commit")}return __extends(t,e),t.prototype.isEnabled=function(){if(!this.gitService)return!1;if(!this.gitService.isIdle())return!1;var e=this.gitService.getModel().getStatus();return e.getIndexStatus().all().length>0||e.getWorkingTreeStatus().all().length>0},t.prototype.run=function(){return this.commitState.getCommitMessage()?this.gitService.commit(this.commitState.getCommitMessage(),!1,!0):(this.commitState.onEmptyCommitMessage(),n.Promise.as(null))},t.ID="workbench.git.action.stageAndCommit",t}(P);t.StageAndCommitAction=O;var M=function(e){function t(n,r){this.terminalService=n.terminalService,this.messageService=n.messageService,e.call(this,n,r,t.ID,t.ALL,"git-action smart-commit")}return __extends(t,e),t.prototype.onGitServiceChange=function(){if(e.prototype.onGitServiceChange.call(this),!this.enabled)return this.label=t.ALL,void 0;var n=this.gitService.getModel().getStatus();this.label=n.getIndexStatus().all().length>0?t.STAGED:t.ALL,this.label+=" ("+(h.isMacintosh?"Cmd+Enter":"Ctrl+Enter")+")"},t.prototype.isEnabled=function(){if(!this.gitService)return!1;if(!this.gitService.isIdle())return!1;var e=this.gitService.getModel().getStatus();return e.getIndexStatus().all().length>0||e.getWorkingTreeStatus().all().length>0},t.prototype.run=function(){if(!this.commitState.getCommitMessage())return this.commitState.onEmptyCommitMessage(),n.Promise.as(null);var e=this.gitService.getModel().getStatus();return this.gitService.commit(this.commitState.getCommitMessage(),!1,0===e.getIndexStatus().all().length)},t.ID="workbench.git.action.commitAll",t.ALL=r.localize("vs_workbench_contrib_git_gitActions",22),t.STAGED=r.localize("vs_workbench_contrib_git_gitActions",23),t}(P);t.SmartCommitAction=M;var D=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",24)),void 0===s&&(s="git-action pull"),e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.isEnabled=function(){if(!e.prototype.isEnabled.call(this))return!1;if(!this.gitService.isIdle())return!1;var t=this.gitService.getModel(),n=t.getHEAD();return n&&n.name&&n.upstream?!0:!1},t.prototype.run=function(){return this.gitService.pull().then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.DirtyWorkTree?n.Promise.wrapError(new Error(r.localize("vs_workbench_contrib_git_gitActions",25))):e.gitErrorCode===c.GitErrorCodes.AuthenticationFailed?n.Promise.wrapError(p.error(r.localize("vs_workbench_contrib_git_gitActions",26))):n.Promise.wrapError(e)})},t.ID="workbench.git.action.pull",t}(m);t.PullAction=D;var R=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",27)),void 0===s&&(s="git-action push"),e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.isEnabled=function(){if(!e.prototype.isEnabled.call(this))return!1;if(!this.gitService.isIdle())return!1;var t=this.gitService.getModel(),n=t.getHEAD();return n&&n.name&&n.upstream?n.ahead?!0:!1:!1},t.prototype.run=function(){return this.gitService.push().then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.AuthenticationFailed?n.Promise.wrapError(p.error(r.localize("vs_workbench_contrib_git_gitActions",28))):n.Promise.wrapError(e)})},t.ID="workbench.git.action.push",t}(m);t.PushAction=R;var F=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",29)),void 0===s&&(s="git-action sync"),e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.isEnabled=function(){if(!e.prototype.isEnabled.call(this))return!1;if(!this.gitService.isIdle())return!1;var t=this.gitService.getModel(),n=t.getHEAD();return n&&n.name&&n.upstream?!0:!1},t.prototype.run=function(){return this.enabled?this.gitService.sync().then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.AuthenticationFailed?n.Promise.wrapError(p.error(r.localize("vs_workbench_contrib_git_gitActions",30))):n.Promise.wrapError(e)}):n.Promise.as(null)},t.ID="workbench.git.action.sync",t}(m);t.SyncAction=F;var V=function(e){function t(n,i,o,s){void 0===i&&(i=t.ID),void 0===o&&(o=r.localize("vs_workbench_contrib_git_gitActions",31)),void 0===s&&(s=t.CLASS_NAME),e.call(this,n,i,o,s)}return __extends(t,e),t.prototype.onGitServiceChange=function(){if(e.prototype.onGitServiceChange.call(this),this.gitService.getRunningOperations().some(function(e){return e.id===c.ServiceOperations.SYNC||e.id===c.ServiceOperations.PULL||e.id===c.ServiceOperations.PUSH}))this.label="",this.class=t.CLASS_NAME_LOADING,this.tooltip=r.localize("vs_workbench_contrib_git_gitActions",32);else{this.class=t.CLASS_NAME;var n=this.gitService.getModel(),i=n.getHEAD();i?i.name?i.upstream?i.ahead||i.behind?(this.label=o.format("{0}↓ {1}↑",i.behind,i.ahead),this.tooltip=n.getStatus().getGroups().some(function(e){return e.all().length>0})?r.localize("vs_workbench_contrib_git_gitActions",36):1===i.behind&&1===i.ahead?r.localize("vs_workbench_contrib_git_gitActions",37,i.name,i.behind,i.ahead,i.upstream):1===i.behind?r.localize("vs_workbench_contrib_git_gitActions",38,i.name,i.behind,i.ahead,i.upstream):1===i.ahead?r.localize("vs_workbench_contrib_git_gitActions",39,i.name,i.behind,i.ahead,i.upstream):r.localize("vs_workbench_contrib_git_gitActions",40,i.name,i.behind,i.ahead,i.upstream)):(this.label="",this.tooltip=r.localize("vs_workbench_contrib_git_gitActions",35,i.name)):(this.label="",this.tooltip=r.localize("vs_workbench_contrib_git_gitActions",34,i.name)):(this.label="",this.tooltip=r.localize("vs_workbench_contrib_git_gitActions",33)):(this.label="",this.tooltip="")}},t.ID="workbench.git.action.liveSync",t.CLASS_NAME="git-action live-sync",t.CLASS_NAME_LOADING="git-action live-sync loading",t}(F);t.LiveSyncAction=V;var B=function(e){function t(n){e.call(this,n,t.ID,t.ENABLE_LABEL,"git-action sync")}return __extends(t,e),Object.defineProperty(t.prototype,"label",{get:function(){return this.isAutoFetchActive()?t.DISABLE_LABEL:t.ENABLE_LABEL},enumerable:!0,configurable:!0}),t.prototype.run=function(){var e=this.gitService.getAutoFetcher();return this.isAutoFetchActive()?e.deactivate():e.activate(),n.Promise.as(null)},t.prototype.isAutoFetchActive=function(){return this.gitService.getAutoFetcher().state!==c.AutoFetcherState.Inactive},t.ID="workbench.git.action.toggleAutoFetch",t.ENABLE_LABEL=r.localize("vs_workbench_contrib_git_gitActions",41),t.DISABLE_LABEL=r.localize("vs_workbench_contrib_git_gitActions",42),t}(m);t.ToggleAutoFetchAction=B});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/views/changes/changesViewer",["require","exports","vs/base/lib/winjs.base","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/base/env","vs/base/severity","vs/base/dom/dom","vs/base/ui/comparers","vs/base/ui/widgets/actionbar","vs/base/ui/widgets/countBadge/countBadge","vs/base/ui/widgets/tree/tree","vs/base/ui/widgets/tree/treeDnd","vs/base/ui/widgets/tree/treeDefaults","vs/workbench/contrib/git/git","vs/workbench/contrib/git/gitModel","vs/workbench/contrib/git/gitActions"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f,m){function g(e){return i.isNative&&i.isWindows?e.replace(/\//g,"\\"):e}var v=s.emmet,y=function(){function e(e){this.cache={},this.instantiationService=e.instantiationService}return e.prototype.getAction=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=this.cache[e.ID];return r||(t.unshift(e),r=this.cache[e.ID]=this.instantiationService.createInstance.apply(this.instantiationService,t)),r},e.prototype.dispose=function(){var e=this;Object.keys(this.cache).forEach(function(t){e.cache[t].dispose()}),this.cache=null},e}();t.ActionContainer=y;var _=function(){function e(){}return e.prototype.getId=function(e,t){if(t instanceof f.StatusModel)return"root";if(t instanceof f.StatusGroup){var n=t;switch(n.getType()){case h.StatusType.INDEX:return"index";case h.StatusType.WORKING_TREE:return"workingTree";case h.StatusType.MERGE:return"merge";default:throw new Error("Invalid group type")}}var r=t;return r.getId()},e.prototype.hasChildren=function(e,t){if(t instanceof f.StatusModel)return!0;if(t instanceof f.StatusGroup){var n=t;return n.all().length>0}},e.prototype.getChildren=function(e,t){if(t instanceof f.StatusModel){var r=t;return n.Promise.as(r.getGroups())}if(t instanceof f.StatusGroup){var i=t;return n.Promise.as(i.all())}return n.Promise.as([])},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.DataSource=_;var b=function(e){function t(t){e.call(this,t),this.gitService=t.gitService}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof f.FileStatus?!0:t instanceof f.StatusGroup&&t.all().length>0?!0:!1},t.prototype.getActions=function(e,t){return t instanceof f.StatusGroup?n.Promise.as(this.getActionsForGroupStatusType(t.getType())):n.Promise.as(this.getActionsForFileStatusType(t.getType()))},t.prototype.getActionsForFileStatusType=function(e){switch(e){case h.StatusType.INDEX:return[this.getAction(m.UnstageAction)];case h.StatusType.WORKING_TREE:return[this.getAction(m.UndoAction),this.getAction(m.StageAction)];case h.StatusType.MERGE:return[this.getAction(m.StageAction)];default:return[]}},t.prototype.getActionsForGroupStatusType=function(e){switch(e){case h.StatusType.INDEX:return[this.getAction(m.GlobalUnstageAction)];case h.StatusType.WORKING_TREE:return[this.getAction(m.GlobalUndoAction),this.getAction(m.GlobalStageAction)];case h.StatusType.MERGE:return[this.getAction(m.StageAction)];default:return[]}},t.prototype.hasSecondaryActions=function(e,t){return this.hasActions(e,t)},t.prototype.getSecondaryActions=function(e,t){var n=this;return this.getActions(e,t).then(function(e){if(t instanceof f.FileStatus){var r=t,i=r.getStatus();e.push(new c.Separator),i!==h.Status.DELETED&&i!==h.Status.INDEX_DELETED&&e.push(n.getAction(m.OpenFileAction)),e.push(n.getAction(m.OpenChangeAction))}return e.reverse(),e})},t.prototype.getActionItem=function(){return null},t}(y);t.ActionProvider=b;var E=function(){function e(e,t,n){this.actionProvider=t,this.actionRunner=n,this.messageService=e.messageService}return e.prototype.getHeight=function(){return 24},e.prototype.getTemplateId=function(e,t){if(t instanceof f.StatusGroup)switch(t.getType()){case h.StatusType.INDEX:return"index";case h.StatusType.WORKING_TREE:return"workingTree";case h.StatusType.MERGE:return"merge"}if(t instanceof f.FileStatus)switch(t.getType()){case h.StatusType.INDEX:return"file:index";case h.StatusType.WORKING_TREE:return"file:workingTree";case h.StatusType.MERGE:return"file:merge"}return null},e.prototype.renderTemplate=function(t,n,r){return/^file:/.test(n)?this.renderFileStatusTemplate(e.templateIdToStatusType(n),r):this.renderStatusGroupTemplate(e.templateIdToStatusType(n),r)},e.prototype.renderStatusGroupTemplate=function(e,t){var n=this,i=Object.create(null);switch(i.actionBar=new c.ActionBar(t,{actionRunner:this.actionRunner}),i.actionBar.push(this.actionProvider.getActionsForGroupStatusType(e),{icon:!0,label:!1}),i.actionBar.addListener2("run",function(e){return e.error&&n.onError(e.error)}),i.count=new u.CountBadge(t),i.root=s.append(t,v(".status-group")),e){case h.StatusType.INDEX:i.root.textContent=r.localize("vs_workbench_contrib_git_views_changes_changesViewer",0);break;case h.StatusType.WORKING_TREE:i.root.textContent=r.localize("vs_workbench_contrib_git_views_changes_changesViewer",1);break;case h.StatusType.MERGE:i.root.textContent=r.localize("vs_workbench_contrib_git_views_changes_changesViewer",2)}return i},e.prototype.renderFileStatusTemplate=function(e,t){var n=this,r=Object.create(null);r.actionBar=new c.ActionBar(t,{actionRunner:this.actionRunner}),r.actionBar.push(this.actionProvider.getActionsForFileStatusType(e),{icon:!0,label:!1}),r.actionBar.addListener2("run",function(e){return e.error&&n.onError(e.error)}),r.root=s.append(t,v(".file-status")),r.status=s.append(r.root,v("span.status")),r.name=s.append(r.root,v("a.name.plain")),r.folder=s.append(r.root,v("span.folder"));var i=s.append(r.root,v("span.rename")),o=s.append(i,v("span.rename-arrow"));return o.textContent="←",r.renameName=s.append(i,v("span.rename-name")),r.renameFolder=s.append(i,v("span.rename-folder")),r},e.prototype.renderElement=function(t,n,r,i){/^file:/.test(r)?e.renderFileStatus(t,n,i):e.renderStatusGroup(n,i)},e.renderStatusGroup=function(e,t){t.actionBar.context=e,t.count.setCount(e.all().length)},e.renderFileStatus=function(t,n,r){r.actionBar.context={tree:t,fileStatus:n};var i=n.getStatus(),o=n.getRename(),s=n.getPath(),a=s.lastIndexOf("/"),c=-1===a?s:s.substr(a+1,s.length),u=-1===a?"":s.substr(0,a);if(r.root.className="file-status "+e.statusToClass(i),r.status.textContent=e.statusToChar(i),r.status.title=e.statusToTitle(i),o){var l=o.lastIndexOf("/"),d=-1===l?o:o.substr(l+1,o.length),p=-1===l?"":o.substr(0,l);r.renameName.textContent=c,r.renameFolder.textContent=u}r.name.textContent=d||c,r.folder.textContent=g(p||u)},e.prototype.disposeTemplate=function(t,n,r){/^file:/.test(n)&&e.disposeFileStatusTemplate(r)},e.disposeFileStatusTemplate=function(e){e.actionBar.dispose()},e.statusToChar=function(e){switch(e){case h.Status.INDEX_MODIFIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",3);case h.Status.MODIFIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",4);case h.Status.INDEX_ADDED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",5);case h.Status.INDEX_DELETED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",6);case h.Status.DELETED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",7);case h.Status.INDEX_RENAMED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",8);case h.Status.INDEX_COPIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",9);case h.Status.UNTRACKED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",10);case h.Status.IGNORED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",11);case h.Status.BOTH_DELETED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",12);case h.Status.ADDED_BY_US:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",13);case h.Status.DELETED_BY_THEM:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",14);case h.Status.ADDED_BY_THEM:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",15);case h.Status.DELETED_BY_US:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",16);case h.Status.BOTH_ADDED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",17);case h.Status.BOTH_MODIFIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",18);default:return""}},e.statusToTitle=function(e){switch(e){case h.Status.INDEX_MODIFIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",19);case h.Status.MODIFIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",20);case h.Status.INDEX_ADDED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",21);case h.Status.INDEX_DELETED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",22);case h.Status.DELETED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",23);case h.Status.INDEX_RENAMED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",24);case h.Status.INDEX_COPIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",25);case h.Status.UNTRACKED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",26);case h.Status.IGNORED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",27);case h.Status.BOTH_DELETED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",28);case h.Status.ADDED_BY_US:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",29);case h.Status.DELETED_BY_THEM:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",30);case h.Status.ADDED_BY_THEM:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",31);case h.Status.DELETED_BY_US:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",32);case h.Status.BOTH_ADDED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",33);case h.Status.BOTH_MODIFIED:return r.localize("vs_workbench_contrib_git_views_changes_changesViewer",34);default:return""}},e.statusToClass=function(e){switch(e){case h.Status.INDEX_MODIFIED:return"modified";case h.Status.MODIFIED:return"modified";case h.Status.INDEX_ADDED:return"added";case h.Status.INDEX_DELETED:return"deleted";case h.Status.DELETED:return"deleted";case h.Status.INDEX_RENAMED:return"renamed";case h.Status.INDEX_COPIED:return"copied";case h.Status.UNTRACKED:return"untracked";case h.Status.IGNORED:return"ignored";case h.Status.BOTH_DELETED:return"conflict both-deleted";case h.Status.ADDED_BY_US:return"conflict added-by-us";case h.Status.DELETED_BY_THEM:return"conflict deleted-by-them";case h.Status.ADDED_BY_THEM:return"conflict added-by-them";case h.Status.DELETED_BY_US:return"conflict deleted-by-us";case h.Status.BOTH_ADDED:return"conflict both-added";case h.Status.BOTH_MODIFIED:return"conflict both-modified";default:return""}},e.templateIdToStatusType=function(e){return/index$/.test(e)?h.StatusType.INDEX:/workingTree$/.test(e)?h.StatusType.WORKING_TREE:h.StatusType.MERGE},e.prototype.onError=function(e){this.messageService.show(o.Error,e)
},e}();t.Renderer=E;var S=function(){function e(){}return e.prototype.isVisible=function(e,t){if(t instanceof f.StatusGroup){var n=t;switch(n.getType()){case h.StatusType.INDEX:case h.StatusType.MERGE:return n.all().length>0;case h.StatusType.WORKING_TREE:return!0}}return!0},e}();t.Filter=S;var T=function(){function e(){}return e.prototype.compare=function(t,n,r){return n instanceof f.FileStatus&&r instanceof f.FileStatus?e.compareStatus(n,r):0},e.compareStatus=function(e,t){for(var n,r,i,o,s=e.getPathComponents(),c=t.getPathComponents(),u=s.length-1,l=c.length-1,d=0;;d++){if(n=u===d,r=l===d,n&&r)return a.compareFileNames(s[d],c[d]);if(n)return-1;if(r)return 1;if((i=s[d].toLowerCase())!==(o=c[d].toLowerCase()))return o>i?-1:1}},e}();t.Sorter=T;var k=function(e){function t(t){e.call(this,t),this.gitService=t.gitService,this.messageService=t.messageService}return __extends(t,e),t.prototype.getDragURI=function(e,t){if(t instanceof f.StatusGroup){var n=t;return"git:"+n.getType()}if(t instanceof f.FileStatus){var r=t;return"git:"+r.getType()+":"+r.getPath()}return null},t.prototype.onDragStart=function(){},t.prototype.onDragOver=function(e,t,n){if(!this.gitService.isIdle())return l.DRAG_OVER_REJECT;if(!(t instanceof d.ElementsDragAndDropData))return l.DRAG_OVER_REJECT;var r=t.getData(),i=r[0];if(i instanceof f.StatusGroup){var o=i;return this.onDrag(n,o.getType())}if(i instanceof f.FileStatus){var s=i;return this.onDrag(n,s.getType())}return l.DRAG_OVER_REJECT},t.prototype.onDrag=function(e,t){return t===h.StatusType.WORKING_TREE?this.onDragWorkingTree(e):t===h.StatusType.INDEX?this.onDragIndex(e):t===h.StatusType.MERGE?this.onDragMerge(e):l.DRAG_OVER_REJECT},t.prototype.onDragWorkingTree=function(e){if(e instanceof f.StatusGroup){var t=e;return t.getType()===h.StatusType.INDEX?l.DRAG_OVER_ACCEPT_BUBBLE_DOWN:l.DRAG_OVER_REJECT}if(e instanceof f.FileStatus){var n=e;return n.getType()===h.StatusType.INDEX?l.DRAG_OVER_ACCEPT_BUBBLE_UP:l.DRAG_OVER_REJECT}return l.DRAG_OVER_REJECT},t.prototype.onDragIndex=function(e){if(e instanceof f.StatusGroup){var t=e;return t.getType()===h.StatusType.WORKING_TREE?l.DRAG_OVER_ACCEPT_BUBBLE_DOWN:l.DRAG_OVER_REJECT}if(e instanceof f.FileStatus){var n=e;return n.getType()===h.StatusType.WORKING_TREE?l.DRAG_OVER_ACCEPT_BUBBLE_UP:l.DRAG_OVER_REJECT}return l.DRAG_OVER_REJECT},t.prototype.onDragMerge=function(e){if(e instanceof f.StatusGroup){var t=e;return t.getType()===h.StatusType.INDEX?l.DRAG_OVER_ACCEPT_BUBBLE_DOWN:l.DRAG_OVER_REJECT}if(e instanceof f.FileStatus){var n=e;return n.getType()===h.StatusType.INDEX?l.DRAG_OVER_ACCEPT_BUBBLE_UP:l.DRAG_OVER_REJECT}return l.DRAG_OVER_REJECT},t.prototype.drop=function(e,t,n){var r,i=this,o=t.getData(),s=o[0];r=s instanceof f.StatusGroup?s.all():o;var a=n;a.getType()===h.StatusType.INDEX&&this.getAction(m.StageAction).run(r).done(null,function(e){return i.onError(e)}),a.getType()===h.StatusType.WORKING_TREE&&this.getAction(m.UnstageAction).run(r).done(null,function(e){return i.onError(e)})},t.prototype.onError=function(e){this.messageService.show(o.Error,e)},t}(y);t.DragAndDrop=k;var w=function(e){function t(t,n){e.call(this,{clickBehavior:p.ClickBehavior.ON_MOUSE_UP}),this.actionProvider=n,this.contextMenuService=t.contextMenuService,this.downKeyBindings["Shift-UpArrow"]=this.onUp.bind(this),this.downKeyBindings["Shift-DownArrow"]=this.onDown.bind(this),this.downKeyBindings["Shift-PageUp"]=this.onPageUp.bind(this),this.downKeyBindings["Shift-PageDown"]=this.onPageDown.bind(this)}return __extends(t,e),t.prototype.onLeftClick=function(t,n,r){if(n instanceof f.StatusGroup)return r.preventDefault(),r.stopPropagation(),!0;if(r.shiftKey){var o=t.getFocus();if(!o||o instanceof f.StatusGroup)return;var s=o,a=n;if(s.getType()!==a.getType())return;return this.canSelect(t,n)&&(t.setFocus(n),t.isSelected(n)?t.deselectRange(s,a):t.selectRange(s,a)),void 0}return t.setFocus(n),(i.isMacintosh?r.metaKey:r.ctrlKey)?(this.canSelect(t,n)&&t.toggleSelection(n,{origin:"mouse",originalEvent:r}),void 0):e.prototype.onLeftClick.call(this,t,n,r)},t.prototype.onEnter=function(t,n){var r=t.getFocus();return r instanceof f.StatusGroup?(n.preventDefault(),n.stopPropagation(),!0):e.prototype.onEnter.call(this,t,n)},t.prototype.onSpace=function(e,t){var n=e.getFocus();return n?this.canSelect(e,n)?(e.toggleSelection(n,{origin:"keyboard",originalEvent:t}),t.preventDefault(),t.stopPropagation(),!0):!1:(t.preventDefault(),t.stopPropagation(),!0)},t.prototype.onContextMenu=function(e,t,n){var r=this;if(n.target&&n.target.tagName&&"input"===n.target.tagName.toLowerCase())return!1;if(n.preventDefault(),n.stopPropagation(),e.setFocus(t),this.actionProvider.hasSecondaryActions(e,t)){var i={x:n.posx+1,y:n.posy},o={selection:e.getSelection(),focus:t};return this.contextMenuService.showContextMenu({getAnchor:function(){return i},getActions:function(){return r.actionProvider.getSecondaryActions(e,t)},getActionItem:this.actionProvider.getActionItem.bind(this.actionProvider,e,t),getActionsContext:function(){return o},onHide:function(t){t&&e.DOMFocus()}}),!0}return!1},t.prototype.onLeft=function(){return!0},t.prototype.onRight=function(){return!0},t.prototype.onUp=function(t,n){var r=t.getFocus(),i=e.prototype.onUp.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.onPageUp=function(t,n){var r=t.getFocus(),i=e.prototype.onPageUp.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.onDown=function(t,n){var r=t.getFocus(),i=e.prototype.onDown.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.onPageDown=function(t,n){var r=t.getFocus(),i=e.prototype.onPageDown.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.canSelect=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return t.some(function(e){return e instanceof f.StatusGroup})?!1:t.every(function(t){var n=e.getSelection()[0],r=t;return!n||n.getType()===r.getType()})},t.prototype.shiftSelect=function(e,t,n){var r={origin:"keyboard",originalEvent:n},i=e.getFocus();if(i===t)return!1;var o=e.isSelected(t),s=e.isSelected(i);return o&&s?e.deselectRange(i,t,r):o||s?o?this.canSelect(e,i)&&e.selectRange(i,t,r):e.deselectRange(i,t,r):this.canSelect(e,t,i)&&e.selectRange(i,t,r),!0},t}(p.DefaultController);t.Controller=w}),define("vs/css!vs/workbench/contrib/git/views/changes/changesView",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/views/changes/changesView",["require","exports","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/platform/services","vs/base/env","vs/base/lifecycle","vs/base/eventEmitter","vs/base/strings","vs/base/errors","vs/base/lib/winjs.base","vs/base/dom/builder","vs/base/dom/keyboardEvent","vs/base/ui/actions","vs/base/ui/widgets/actionbar","vs/base/ui/widgets/tree/treeImpl","vs/workbench/events","vs/workbench/contrib/git/git","vs/workbench/contrib/git/gitActions","vs/workbench/contrib/git/gitModel","vs/workbench/contrib/git/views/changes/changesViewer","vs/workbench/contrib/git/gitEditorInputs","vs/workbench/contrib/files/files","vs/workbench/ui/parts/editor/editorOptions","vs/base/ui/widgets/inputBox","vs/base/severity","vs/css!./changesView"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f,m,g,v,y,_,b,E,S,T,k){var w=l.$,C=function(e){function t(t,n){var r=this;e.call(this),this.ID="changes",this.instantiationService=t.instantiationService,this.editorService=t.editorService,this.messageService=t.messageService,this.contextViewService=t.contextViewService,this.contextService=t.contextService,this.gitService=t.gitService,this.outputService=t.outputService,this.visible=!1,this.currentDimension=null,this.actionRunner=n,this.toDispose=[this.smartCommitAction=this.instantiationService.createInstance(v.SmartCommitAction,this),t.eventService.addListener2(m.EventType.EDITOR_INPUT_CHANGED,function(e){return r.onEditorInputChanged(e.editorInput).done(null,c.onUnexpectedError)}),this.gitService.addListener2(g.ServiceEvents.OPERATION_START,function(e){return r.onGitOperationStart(e)}),this.gitService.addListener2(g.ServiceEvents.OPERATION_END,function(e){return r.onGitOperationEnd(e)}),this.gitService.getModel().addListener2(g.ModelEvents.MODEL_UPDATED,this.onGitModelUpdate.bind(this))]}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this.render(),this.$el.getHTMLElement()},enumerable:!0,configurable:!0}),t.prototype.render=function(){var e=this;if(!this.$el){this.$el=w(".changes-view"),this.$commitView=w(".commit-view").appendTo(this.$el),this.commitInputBox=new T.InputBox(this.$commitView.getHTMLElement(),this.contextViewService,{placeholder:n.localize("vs_workbench_contrib_git_views_changes_changesView",0,t.COMMIT_KEYBINDING),validationOptions:{showMessage:!0,validation:function(){return null}},flexibleHeight:!0}),this.addEmitter2(this.commitInputBox,"commitInputBox"),w(this.commitInputBox.inputElement).on("keydown",function(n){var r=new d.KeyboardEvent(n),o=r.asString();(i.isMacintosh?["Meta-S","Meta-Enter"]:["Ctrl-S","Ctrl-Enter"]).indexOf(o)>-1&&(e.smartCommitAction.enabled?e.actionRunner.run(e.smartCommitAction).done():e.commitInputBox.showMessage({content:t.NOTHING_TO_COMMIT,formatContent:!0,type:T.MessageType.INFO}))}).on("blur",function(){e.commitInputBox.hideMessage()}),this.$statusView=w(".status-view").appendTo(this.$el);var r=this.instantiationService.createInstance(_.ActionProvider),o=this.instantiationService.createInstance(_.Renderer,r,this.actionRunner),s=this.instantiationService.createInstance(_.DragAndDrop),a=this.instantiationService.createInstance(_.Controller,r);this.tree=new f.Tree(this.$statusView.getHTMLElement(),{dataSource:new _.DataSource,renderer:o,filter:new _.Filter,sorter:new _.Sorter,dnd:s,controller:a},{indentPixels:0,twistiePixels:20}),this.tree.setInput(this.gitService.getModel().getStatus()),this.tree.expandAll(this.gitService.getModel().getStatus().getGroups()),this.toDispose.push(this.tree.addListener2("selection",function(t){return e.onSelection(t)})),this.toDispose.push(this.commitInputBox.addListener2("heightchange",function(){return e.layout()}))}},t.prototype.focus=function(){var e=this.tree.getSelection();e.length>0&&this.tree.reveal(e[0],.5),this.tree.DOMFocus()},t.prototype.layout=function(e){if(void 0===e&&(e=this.currentDimension),e){this.currentDimension=e;var t=e.height-(this.commitInputBox.height+10);this.$statusView.size(e.width,t),this.tree.layout(t),134===this.commitInputBox.height?this.$commitView.addClass("scroll"):this.$commitView.removeClass("scroll")}},t.prototype.setVisible=function(e){return this.visible=e,e?(this.tree.onVisible(),this.onEditorInputChanged(this.editorService.getActiveEditorInput())):(this.tree.onHidden(),u.Promise.as(null))},t.prototype.getSelection=function(){return new r.StructuredSelection(this.tree.getSelection())},t.prototype.getControl=function(){return this.tree},t.prototype.getActions=function(){var e=this;return this.actions||(this.actions=[this.smartCommitAction,this.instantiationService.createInstance(v.RefreshAction)],this.actions.forEach(function(t){return e.toDispose.push(t)})),this.actions},t.prototype.getSecondaryActions=function(){var e=this;return this.secondaryActions||(this.secondaryActions=[this.instantiationService.createInstance(v.SyncAction),this.instantiationService.createInstance(v.PullAction),this.instantiationService.createInstance(v.PushAction),this.instantiationService.createInstance(v.ToggleAutoFetchAction),new h.Separator,this.instantiationService.createInstance(v.CommitAction,this),this.instantiationService.createInstance(v.StageAndCommitAction,this)],i.isNative||this.secondaryActions.push(this.instantiationService.createInstance(v.RunAmendCommitAction)),this.secondaryActions.push(new h.Separator,this.instantiationService.createInstance(v.GlobalUnstageAction),this.instantiationService.createInstance(v.GlobalUndoAction)),i.isNative&&this.secondaryActions.push(new h.Separator,new p.Action("show.gitOutput",n.localize("vs_workbench_contrib_git_views_changes_changesView",1),null,!0,function(){return e.outputService.showOutput("Git")})),this.secondaryActions.forEach(function(t){return e.toDispose.push(t)})),this.secondaryActions},t.prototype.getCommitMessage=function(){return a.trim(this.commitInputBox.value)},t.prototype.onEmptyCommitMessage=function(){this.commitInputBox.focus(),this.commitInputBox.showMessage({content:t.NEED_MESSAGE,formatContent:!0,type:T.MessageType.INFO})},t.prototype.onGitModelUpdate=function(){var e=this;this.tree&&this.tree.refresh().done(function(){return e.tree.expandAll(e.gitService.getModel().getStatus().getGroups())})},t.prototype.onEditorInputChanged=function(e){var t=this;if(!this.tree)return u.Promise.as(null);var n=this.getStatusFromInput(e);return n||(this.tree.clearSelection(),this.tree.clearFocus()),this.visible&&-1===this.tree.getSelection().indexOf(n)?this.tree.reveal(n,.5).then(function(){t.tree.setSelection([n],{origin:"implicit"}),t.tree.setFocus(n)}):u.Promise.as(null)},t.prototype.onSelection=function(e){var t=this;if(!(e.payload&&e.payload&&"implicit"===e.payload.origin||1!==e.selection.length)){var n=e.selection[0];if(n instanceof y.FileStatus&&(!e.payload||"keyboard"!==e.payload.origin||"Enter"===e.payload.originalEvent.asString())){var r=e.payload&&"mouse"===e.payload.origin;if(!r||!e.payload.originalEvent.metaKey&&!e.payload.originalEvent.shiftKey){var i=n;this.gitService.getInput(i).done(function(n){var i=new S.TextDiffEditorOptions;r&&(i.preserveFocus=!0),i.forceOpen=!0;var o=e&&e.payload&&e.payload.originalEvent&&e.payload.originalEvent.altKey;return t.editorService.openEditor(n,i,o)},function(e){return e.gitErrorCode===g.GitErrorCodes.CantOpenResource?(t.messageService.show(k.Warning,e),void 0):(t.messageService.show(k.Error,e),void 0)})}}}},t.prototype.onGitOperationStart=function(e){e.id===g.ServiceOperations.COMMIT&&this.commitInputBox&&this.commitInputBox.disable()},t.prototype.onGitOperationEnd=function(e){e.operation.id===g.ServiceOperations.COMMIT&&this.commitInputBox&&(this.commitInputBox.enable(),e.error||(this.commitInputBox.value=""))},t.prototype.getStatusFromInput=function(e){if(!e)return null;if(e instanceof b.GitDiffEditorInput)return e.getFileStatus();if(e instanceof b.GitIndexEditorInput)return e.getFileStatus()||null;if(e instanceof b.NativeGitIndexStringEditorInput)return e.getFileStatus()||null;if(e instanceof E.FileEditorInput){var t=e,n=this.contextService.toWorkspaceRelativePath(t.getResource());if(!n)return null;var r=this.gitService.getModel().getStatus().getWorkingTreeStatus().find(n);if(r&&(r.getStatus()===g.Status.UNTRACKED||r.getStatus()===g.Status.IGNORED))return r;if(r=this.gitService.getModel().getStatus().getMergeStatus().find(n))return r}return null},t.prototype.dispose=function(){this.$el&&(this.$el.dispose(),this.$el=null),this.toDispose=o.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t.COMMIT_KEYBINDING=i.isMacintosh?"Cmd+Enter":"Ctrl+Enter",t.NEED_MESSAGE=n.localize("vs_workbench_contrib_git_views_changes_changesView",2,t.COMMIT_KEYBINDING),t.NOTHING_TO_COMMIT=n.localize("vs_workbench_contrib_git_views_changes_changesView",3,t.COMMIT_KEYBINDING),t}(s.EventEmitter);t.ChangesView=C}),define("vs/css!vs/base/ui/widgets/comboBox",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/base/ui/widgets/comboBox",["require","exports","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/base/types","vs/base/lib/winjs.base","vs/base/dom/builder","vs/base/eventEmitter","vs/css!./comboBox"],function(e,t,n,r,i,o,s){var a=o.$,c=function(e){function t(t){var n=this;e.call(this),this.isEnabled=!0,this.$el=a("select.combo-box").appendTo(t),this.options=[],this.optionsPromise=null,this.optionsPromiseError=null,this.$el.on("change",function(e){return n.onChange(e)}),this.render()}return __extends(t,e),t.prototype.setOptions=function(e){var t=this;return this.optionsPromise&&this.optionsPromise.cancel(),this.optionsPromise=null,this.optionsPromiseError=null,r.isArray(e)?(this.options=e,this.render(),e.length>0&&this.onChange(),i.Promise.as(this.options)):(this.optionsPromise=e.then(function(e){return t.optionsPromise=null,t.options=e,t.render(),e.length>0&&t.onChange(),e},function(e){return t.optionsPromise=null,t.optionsPromiseError=e,t.render(),i.Promise.wrapError(e)}),this.render(),this.optionsPromise)},Object.defineProperty(t.prototype,"enabled",{get:function(){return this.isEnabled},set:function(e){e?this.enable():this.disable(),this.isEnabled=e},enumerable:!0,configurable:!0}),t.prototype.getOptions=function(){return this.options?this.options.slice(0):null},t.prototype.getSelectedOption=function(){if(this.$el){var e=this.$el.getHTMLElement().selectedIndex;return this.options[e]}},t.prototype.onChange=function(){var e=this.getSelectedOption();e&&e.value&&this.emit("change",e)},t.prototype.render=function(){var e=this;this.$el&&(this.$el.empty().setClass("combo-box"),this.optionsPromiseError?(this.$el.addClass("error").append(a("option.combo-box-option").innerHtml(t.ERROR_LABEL)),this.disable()):this.optionsPromise?(this.$el.addClass("loading").append(a("option.combo-box-option").innerHtml(t.LOADING_LABEL)),this.disable()):0===this.options.length?(this.$el.addClass("empty").append(a("option.combo-box-option").innerHtml(t.EMPTY_LABEL)),this.disable()):(this.options.forEach(function(t){var n=a("option.combo-box-option").text(t.label).appendTo(e.$el);t.value?n.attr("value",t.value):n.addClass("label")}),this.isEnabled&&this.enable()))},t.prototype.enable=function(){this.$el.getHTMLElement().removeAttribute("disabled")},t.prototype.disable=function(){this.$el.attr("disabled","true")},t.prototype.dispose=function(){e.prototype.dispose.call(this),this.$el&&(this.$el.destroy(),this.$el=null)},t.EMPTY_LABEL=n.localize("vs_base_ui_widgets_comboBox",0),t.LOADING_LABEL=n.localize("vs_base_ui_widgets_comboBox",1),t.ERROR_LABEL=n.localize("vs_base_ui_widgets_comboBox",2),t}(s.EventEmitter);t.ComboBox=c}),define("vs/workbench/contrib/tfs/tfs",["require","exports"],function(e,t){!function(e){e[e.Unavailable=0]="Unavailable",e[e.Uninitialized=1]="Uninitialized",e[e.Initialized=2]="Initialized",e[e.Connected=3]="Connected",e[e.Disconnected=4]="Disconnected"}(t.ServiceState||(t.ServiceState={}));t.ServiceState;t.ServiceEvents={STATE_CHANGED:"state",ERROR:"error"},t.TFS_SERVICE_ID="tfsService"}),define("vs/css!vs/workbench/contrib/git/views/empty/emptyView",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/views/empty/emptyView",["require","exports","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/base/env","vs/platform/services","vs/base/lifecycle","vs/base/eventEmitter","vs/base/dom/dom","vs/base/errors","vs/base/dom/keyboardEvent","vs/base/lib/winjs.base","vs/base/dom/builder","vs/base/ui/actions","vs/base/ui/widgets/inputBox","vs/base/ui/widgets/comboBox","vs/workbench/contrib/git/git","vs/workbench/contrib/git/gitActions","vs/workbench/contrib/files/files","vs/workbench/contrib/tfs/tfs","vs/base/severity","vs/css!./emptyView"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f,m,g,v,y,_){var b=d.$,E=function(e){function t(t){var n=this;e.call(this),this.$el=b("a.button.clone").href("#").appendTo(t),this.$el.on("click",function(e){return n.enabled?(n.emit("click",e),void 0):(a.EventHelper.stop(e),void 0)})}return __extends(t,e),Object.defineProperty(t.prototype,"label",{set:function(e){this.$el.text(e)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"enabled",{get:function(){return!this.$el.hasClass("disabled")},set:function(e){e?this.$el.removeClass("disabled"):this.$el.addClass("disabled")},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.$el&&(this.$el.dispose(),this.$el=null),e.prototype.dispose.call(this)},t}(s.EventEmitter);t.Button=E;var S=function(e){function t(t,n,r){var i=this;e.call(this),this.ID="empty",this.gitService=t.gitService,this.instantiationService=t.instantiationService,this.messageService=t.messageService,this.fileService=t.fileService,this.terminalService=t.terminalService,this.viewletService=t.viewletService,this.contextViewService=t.contextViewService,this.tfsService=t.tfsService,this.tfsService&&(this.refreshAction=new p.Action("workbench.contrib.git.empty.refresh","Refresh","git-action refresh",!0,function(){return i.renderTFSSection(),null})),this.actionRunner=r,this.isVisible=!1,this.needsRender=!1,this.controller=n,this.toDispose=[],this.tfsService&&(this.toDispose.push(this.tfsService.addListener2(y.ServiceEvents.STATE_CHANGED,function(){return i.onTFSServiceStateChange()})),this.onTFSServiceStateChange())}return __extends(t,e),Object.defineProperty(t.prototype,"initAction",{get:function(){return this._initAction||(this._initAction=this.instantiationService.createInstance(g.InitAction)),this._initAction},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"cloneAction",{get:function(){return this._cloneAction||(this._cloneAction=this.instantiationService.createInstance(g.RunCloneAction)),this._cloneAction},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"element",{get:function(){return this.render(),this.$el.getHTMLElement()},enumerable:!0,configurable:!0}),t.prototype.render=function(){var e=this;if(!this.$el){if(this.$el=b(".empty-view"),b("p").appendTo(this.$el).text(t.EMPTY_MESSAGE),this.tfsSection=b(".section").appendTo(this.$el).getHTMLElement(),!r.isNative){var i=b(".section").appendTo(this.$el);this.urlInputBox=new h.InputBox(i.getHTMLElement(),this.contextViewService,{placeholder:n.localize("vs_workbench_contrib_git_views_empty_emptyView",0),validationOptions:{showMessage:!1,validation:function(t){var n=/^(http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/.test(t);return e.cloneButton.enabled=n,!t||n?null:{content:"",type:h.MessageType.ERROR}}}}),b(this.urlInputBox.inputElement).on("keyup",function(t){var n=new u.KeyboardEvent(t);"Enter"===n.asString()&&e.cloneButton.enabled&&(n.preventDefault(),n.stopPropagation(),e.disableUI(),e.clone(e.urlInputBox.value.trim()).then(null,function(t){e.messageService.show(_.Error,t)}).done(function(){e.enableUI()}))}),this.cloneButton=new E(i),this.cloneButton.enabled=!1,this.cloneButton.label=n.localize("vs_workbench_contrib_git_views_empty_emptyView",1),this.cloneButton.on("click",function(t){a.EventHelper.stop(t),e.disableUI(),e.clone(e.urlInputBox.value.trim()).then(null,function(t){e.messageService.show(_.Error,t)}).done(function(){e.enableUI()})})}var o=b(".section").appendTo(this.$el);this.initButton=new E(o),this.initButton.label=n.localize("vs_workbench_contrib_git_views_empty_emptyView",2),this.initButton.on("click",function(t){a.EventHelper.stop(t),e.disableUI(),e.actionRunner.run(e.initAction).done(function(){e.enableUI()})}),this.toDispose.push(this.gitService.addListener2(m.ServiceEvents.OPERATION,function(){return e.onGitOperation()}))}},t.prototype.disableUI=function(){this.tfsConnectButton&&(this.tfsConnectButton.enabled=!1),this.tfsGitRepositoresComboBox&&(this.tfsGitRepositoresComboBox.enabled=!1),this.tfsCloneButton&&(this.tfsCloneButton.enabled=!1),this.urlInputBox&&this.urlInputBox.disable(),this.cloneButton&&(this.cloneButton.enabled=!1),this.initButton.enabled=!1},t.prototype.enableUI=function(){this.gitService.getRunningOperations().length>0||(this.tfsConnectButton&&(this.tfsConnectButton.enabled=!0),this.tfsGitRepositoresComboBox&&(this.tfsGitRepositoresComboBox.enabled=!0),this.tfsCloneButton&&(this.tfsCloneButton.enabled=this.tfsGitRepositoresComboBox?this.tfsGitRepositoresComboBox.getOptions().length>0:!1),this.urlInputBox&&(this.urlInputBox.enable(),this.urlInputBox.validate()),this.initButton.enabled=!0)},t.prototype.clone=function(e){var t=this;return this.fileService.resolveFileStat("/").then(function(r){var i=r.children.length?r.children[0]:null,o=i&&!i.isDirectory&&"hostingstart.html"===i.name;if(r.children.length>1||1===r.children.length&&!o)return t.messageService.show(_.Warning,n.localize("vs_workbench_contrib_git_views_empty_emptyView",3)),void 0;if(e){var s=function(){return t.actionRunner.run(t.cloneAction,e).then(function(){return t.urlInputBox.value="",t.viewletService.openViewlet(v.VIEWLET_ID,!1)})};return o?t.fileService.deleteFile(i).then(s):s()}},function(e){return t.onError(e)})},t.prototype.onError=function(e){this.messageService.show(_.Error,e)},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(e){return this.isVisible=e,e&&this.needsRender&&(this.needsRender=!1,this.renderTFSSection()),l.Promise.as(null)},t.prototype.getSelection=function(){return i.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return this.refreshAction?[this.refreshAction]:[]},t.prototype.getSecondaryActions=function(){return[]},t.prototype.onTFSServiceStateChange=function(){this.isVisible?this.renderTFSSection():this.needsRender=!0},t.prototype.renderTFSSection=function(){var e=this;switch(this.disposeTFSSection(),this.tfsService.state){case y.ServiceState.Connected:this.tfsGitRepositoresComboBox=new f.ComboBox(this.tfsSection),this.tfsGitRepositoresComboBox.setOptions(this.tfsService.getRepositories().then(function(t){var r=t.length>0;return e.tfsCloneButton.enabled=r,e.tfsGitRepositoresComboBox.enabled=r,r?l.Promise.as(t.sort(function(e,t){return e.project.name!==t.project.name?e.project.name<t.project.name?-1:1:e.name<t.name?-1:1}).map(function(e){return{label:n.localize("vs_workbench_contrib_git_views_empty_emptyView",5,e.name,e.project.name),value:e.remoteUrl}})):l.Promise.as([{label:n.localize("vs_workbench_contrib_git_views_empty_emptyView",4)}])})).done(null,function(t){if(t instanceof c.ConnectionError){var r=t;if(401===r.status){var i=e.messageService.show(_.Warning,{message:r.responseText,actions:[new p.Action("workbench.contrib.git.empty.tfsReconnectClose",n.localize("vs_workbench_contrib_git_views_empty_emptyView",6),null,!0,function(){return i(),null}),new p.Action("workbench.contrib.git.empty.tfsReconnect",n.localize("vs_workbench_contrib_git_views_empty_emptyView",7),null,!0,function(){return window.location.href=e.tfsService.getConnectURL(),null})]});return}}e.onError(t)}),this.tfsCloneButton=new E(this.tfsSection),this.tfsCloneButton.enabled=!1,this.tfsCloneButton.label=n.localize("vs_workbench_contrib_git_views_empty_emptyView",8),this.tfsCloneButton.on("click",function(t){a.EventHelper.stop(t);var n=e.tfsGitRepositoresComboBox.getSelectedOption();n&&n.value&&(e.disableUI(),e.clone(n.value).then(null,function(t){e.messageService.show(_.Error,t)}).done(function(){e.enableUI()}))});break;case y.ServiceState.Disconnected:this.tfsConnectButton=new E(this.tfsSection),this.tfsConnectButton.label=n.localize("vs_workbench_contrib_git_views_empty_emptyView",9),this.tfsConnectButton.on("click",function(t){a.EventHelper.stop(t),window.location.href=e.tfsService.getConnectURL()})}},t.prototype.disposeTFSSection=function(){for(;this.tfsSection&&this.tfsSection.firstChild;)this.tfsSection.removeChild(this.tfsSection.firstChild);this.tfsConnectButton&&(this.tfsConnectButton.dispose(),this.tfsConnectButton=null),this.tfsGitRepositoresComboBox&&(this.tfsGitRepositoresComboBox.dispose(),this.tfsGitRepositoresComboBox=null),this.tfsCloneButton&&(this.tfsCloneButton.dispose(),this.tfsCloneButton=null)},t.prototype.onGitOperation=function(){this.gitService.getRunningOperations().length>0?this.disableUI():this.enableUI()},t.prototype.dispose=function(){this.$el&&(this.$el.dispose(),this.$el=null),this.disposeTFSSection(),this.toDispose=o.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t.EMPTY_MESSAGE=n.localize("vs_workbench_contrib_git_views_empty_emptyView",10),t}(s.EventEmitter);t.EmptyView=S}),define("vs/css!vs/workbench/contrib/git/views/gitless/gitlessView",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/views/gitless/gitlessView",["require","exports","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/base/env","vs/platform/services","vs/base/lib/winjs.base","vs/base/eventEmitter","vs/base/dom/builder","vs/css!./gitlessView"],function(e,t,n,r,i,o,s,a){var c=a.$,u=function(e){function t(){e.apply(this,arguments),this.ID="gitless"}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this._element||this.render(),this._element},enumerable:!0,configurable:!0}),t.prototype.render=function(){var e;e=r.isMacintosh?n.localize("vs_workbench_contrib_git_views_gitless_gitlessView",0,'<a href="http://brew.sh/" target="_blank">Homebrew</a>','<a href="http://git-scm.com/download/mac" target="_blank">git-scm.com</a>','<a href="https://developer.apple.com/xcode/" target="_blank">XCode</a>',"<code>git</code>"):r.isWindows?n.localize("vs_workbench_contrib_git_views_gitless_gitlessView",1,'<a href="https://chocolatey.org/packages/git" target="_blank">Chocolatey</a>','<a href="http://git-scm.com/download/win" target="_blank">git-scm.com</a>'):r.isLinux?n.localize("vs_workbench_contrib_git_views_gitless_gitlessView",2,'<a href="http://git-scm.com/download/linux" target="_blank">git-scm.com</a>'):n.localize("vs_workbench_contrib_git_views_gitless_gitlessView",3,'<a href="http://git-scm.com/download" target="_blank">git-scm.com</a>'),this._element=c(['<div class="gitless-view">',"<p>",n.localize("vs_workbench_contrib_git_views_gitless_gitlessView",4),"</p>","<p>",e,"</p>","<p>",n.localize("vs_workbench_contrib_git_views_gitless_gitlessView",5,r.applicationName),"</p>","</div>"].join("")).getHTMLElement()},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(){return o.Promise.as(null)},t.prototype.getSelection=function(){return i.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return[]},t.prototype.getSecondaryActions=function(){return[]},t}(s.EventEmitter);t.GitlessView=u}),define("vs/css!vs/workbench/contrib/git/views/notroot/notrootView",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/views/notroot/notrootView",["require","exports","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/platform/services","vs/base/lib/winjs.base","vs/base/eventEmitter","vs/base/dom/builder","vs/css!./notrootView"],function(e,t,n,r,i,o,s){var a=s.$,c=function(e){function t(){e.apply(this,arguments),this.ID="notroot"}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this._element||this.render(),this._element},enumerable:!0,configurable:!0}),t.prototype.render=function(){this._element=a(['<div class="notroot-view">',"<p>",n.localize("vs_workbench_contrib_git_views_notroot_notrootView",0),"</p>","<p>",n.localize("vs_workbench_contrib_git_views_notroot_notrootView",1),"</p>","</div>"].join("")).getHTMLElement()},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(){return i.Promise.as(null)},t.prototype.getSelection=function(){return r.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return[]},t.prototype.getSecondaryActions=function(){return[]
},t}(o.EventEmitter);t.NotRootView=c}),define("vs/css!vs/workbench/contrib/git/views/noworkspace/noworkspaceView",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/views/noworkspace/noworkspaceView",["require","exports","vs/nls!vs/workbench/contrib/git/gitViewlet","vs/platform/services","vs/base/lib/winjs.base","vs/base/eventEmitter","vs/base/dom/builder","vs/css!./noworkspaceView"],function(e,t,n,r,i,o,s){var a=s.$,c=function(e){function t(){e.apply(this,arguments),this.ID="noworkspace"}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this._element||this.render(),this._element},enumerable:!0,configurable:!0}),t.prototype.render=function(){this._element=a(['<div class="noworkspace-view">',"<p>",n.localize("vs_workbench_contrib_git_views_noworkspace_noworkspaceView",0),"</p>","<p>",n.localize("vs_workbench_contrib_git_views_noworkspace_noworkspaceView",1),"</p>","</div>"].join("")).getHTMLElement()},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(){return i.Promise.as(null)},t.prototype.getSelection=function(){return r.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return[]},t.prototype.getSecondaryActions=function(){return[]},t}(o.EventEmitter);t.NoWorkspaceView=c}),define("vs/css!vs/workbench/contrib/git/media/gitViewlet",["vs/css!vs/workbench/contrib/git/gitViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/git/gitViewlet",["require","exports","vs/base/lib/winjs.base","vs/platform/services","vs/base/lifecycle","vs/workbench/ui/parts/viewlet","vs/workbench/contrib/git/git","vs/workbench/contrib/git/git.contribution","vs/workbench/contrib/git/views/changes/changesView","vs/workbench/contrib/git/views/empty/emptyView","vs/workbench/contrib/git/views/gitless/gitlessView","vs/workbench/contrib/git/views/notroot/notrootView","vs/workbench/contrib/git/views/noworkspace/noworkspaceView","vs/css!./media/gitViewlet"],function(e,t,n,r,i,o,s,a,c,u,l,d,p){var h=function(e){function t(t){var n=this;e.call(this,t,a.VIEWLET_ID),this.progressService=t.progressService,this.instantiationService=t.instantiationService,this.gitService=t.gitService,this.progressRunner=null,this.views={},this.toDispose=[];var r=[this.instantiationService.createInstance(c.ChangesView,this.getActionRunner()),this.instantiationService.createInstance(u.EmptyView,this,this.getActionRunner()),new l.GitlessView,new d.NotRootView,new p.NoWorkspaceView];r.forEach(function(e){n.views[e.ID]=e,n.toDispose.push(e)}),this.toUnbind.push(this.gitService.addBulkListener(function(){return n.onGitServiceChanges()}))}return __extends(t,e),t.prototype.setView=function(e){if(!this.$el)return n.Promise.as(null);var t=this.views[e];if(!t)return n.Promise.wrapError(new Error("Could not find view."));if(this.currentView===t)return n.Promise.as(null);var r=n.Promise.as(null);this.currentView&&(r=this.currentView.setVisible(!1));var i=t.element;this.currentView=t,this.updateTitleArea();for(var o=this.$el.getHTMLElement();o.firstChild;)o.removeChild(o.firstChild);return o.appendChild(i),t.layout(this.currentDimension),r.then(function(){return t.setVisible(!0)})},t.prototype.create=function(t){return e.prototype.create.call(this,t),this.$el=t.div().addClass("git-viewlet"),n.Promise.as(null)},t.prototype.setVisible=function(t){var r=this;return t?(this.onGitServiceChanges(),this.gitService.status().done(),e.prototype.setVisible.call(this,t).then(function(){return r.currentView?r.currentView.setVisible(t):void 0})):(this.currentView?this.currentView.setVisible(t):n.Promise.as(null)).then(function(){e.prototype.setVisible.call(r,t)})},t.prototype.focus=function(){e.prototype.focus.call(this),this.currentView&&this.currentView.focus()},t.prototype.layout=function(t){void 0===t&&(t=this.currentDimension),e.prototype.layout.call(this,t),this.currentDimension=t,this.currentView&&this.currentView.layout(t)},t.prototype.getActions=function(){return this.currentView?this.currentView.getActions():[]},t.prototype.getSecondaryActions=function(){return this.currentView?this.currentView.getSecondaryActions():[]},t.prototype.getSelection=function(){return this.currentView?this.currentView.getSelection():r.Selection.EMPTY},t.prototype.getControl=function(){return this.currentView?this.currentView.getControl():null},t.prototype.onGitServiceChanges=function(){this.progressRunner&&this.progressRunner.done(),this.gitService.getState()===s.ServiceState.NoGit?(this.setView("gitless"),this.progressRunner=null):this.gitService.getState()===s.ServiceState.NotARepo?(this.setView("empty"),this.progressRunner=null):this.gitService.getState()===s.ServiceState.NotAWorkspace?(this.setView("noworkspace"),this.progressRunner=null):this.gitService.getState()===s.ServiceState.NotAtRepoRoot?(this.setView("notroot"),this.progressRunner=null):this.gitService.isIdle()?(this.setView("changes"),this.progressRunner=null):this.progressRunner=this.progressService.show(!0)},t.prototype.dispose=function(){this.toDispose=i.disposeAll(this.toDispose),this.views=null,e.prototype.dispose.call(this)},t}(o.Viewlet);t.GitViewlet=h});