/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/search/searchModel",["require","exports","vs/base/network","vs/base/time/schedulers","vs/base/strings","vs/base/paths","vs/base/lifecycle","vs/base/collections","vs/base/eventEmitter","vs/editor/editor","vs/editor/core/range","vs/editor/core/constants"],function(e,t,n,r,i,o,s,a,c,u,l,d){var p=function(){function e(e,t,n,r,i){this._parent=e,this._lineText=t,this._id=e.id()+">"+n+">"+r,this._range=new l.Range(1+n,1+r,1+n,1+r+i)}return e.prototype.id=function(){return this._id},e.prototype.parent=function(){return this._parent},e.prototype.text=function(){return this._lineText},e.prototype.range=function(){return this._range},e.prototype.preview=function(){var e=this._lineText.substring(0,this._range.startColumn-1),t=this._lineText.substring(this._range.startColumn-1,this._range.endColumn-1),n=this._lineText.substring(this._range.endColumn-1,Math.min(this._range.endColumn+150,this._lineText.length));return e=i.lcut(e,26),{before:e,inside:t,after:n}},e}();t.Match=p;var h=function(e){function t(t){e.call(this,t,null,Date.now(),Date.now(),Date.now())}return __extends(t,e),t}(p);t.EmptyMatch=h;var f=function(){function e(e,t){this._resource=t,this._parent=e,this._matches=Object.create(null)}return e.prototype.dispose=function(){},e.prototype.id=function(){return this.resource().toString()},e.prototype.parent=function(){return this._parent},e.prototype.add=function(e){this._matches[e.id()]=e},e.prototype.remove=function(e){delete this._matches[e.id()]},e.prototype.matches=function(){return a.values(this._matches)},e.prototype.count=function(){var e=0;for(var t in this._matches)this._matches[t]instanceof h||(e+=1);return e},e.prototype.resource=function(){return this._resource},e.prototype.name=function(){return o.basename(this.resource().fsPath)},e}();t.FileMatch=f;var m=function(e){function t(t,n,i,o,s){var a=this;e.call(this,t,n),this._modelDecorations=[],this._unbind=[],this._query=i,this._model=o,this._serverFileMatch=s,this._updateScheduler=new r.RunOnceScheduler(this._updateMatches.bind(this),250),this._unbind.push(this._model.addListener(d.EventType.ModelContentChanged,function(){return a._updateScheduler.schedule()})),this._updateMatches()}return __extends(t,e),t.prototype.dispose=function(){this._unbind=s.cAll(this._unbind),this._isTextModelDisposed()||this._model.deltaDecorations(this._modelDecorations,[])},t.prototype._updateMatches=function(){var e=this;if(!this._isTextModelDisposed()){this._matches=Object.create(null);var t=this._model.findMatches(this._query.pattern,this._model.getFullModelRange(),this._query.isRegExp,this._query.isCaseSensitive,this._query.isWordMatch);0===t.length?this.add(new h(this)):t.forEach(function(t){return e.add(new p(e,e._model.getLineContent(t.startLineNumber),t.startLineNumber-1,t.startColumn-1,t.endColumn-t.startColumn))}),this.parent().emit("changed",this),this.updateHighlights()}},t.prototype.updateHighlights=function(){this._model.isDisposed()||(this._modelDecorations=this.parent()._showHighlights?this._model.deltaDecorations(this._modelDecorations,this.matches().map(function(e){return{range:e.range(),options:t.DecorationOption}})):this._model.deltaDecorations(this._modelDecorations,[]))},t.prototype._isTextModelDisposed=function(){return!this._model||this._model.isDisposed()},t.DecorationOption={stickiness:u.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges,isOverlay:!1,className:"findMatch",overviewRuler:{color:"rgba(246, 185, 77, 0.7)",position:u.OverviewRulerLane.Center}},t}(f);t.LiveFileMatch=m;var g=function(e){function t(t,n){void 0===n&&(n=null),e.call(this),this._disposables=[],this._matches=Object.create(null),this._instantiationService=t.instantiationService,this._contextService=t.contextService,this._requestService=t.requestService,this._modelService=t.modelService,this._query=n,this._query&&(this._modelService.onModelAdded.add(this._onModelAdded,this,this._disposables),this._modelService.onModelRemoved.add(this._onModelRemoved,this,this._disposables))}return __extends(t,e),t.prototype._onModelAdded=function(e){var t=this._requestService.getPath("root",e.getAssociatedResource()),n=this._contextService.toResource(t);if(n){var r=this._matches[n.toString()];if(r){var i=new m(this,n,this._query,e,r);i.updateHighlights(),this._matches[n.toString()]=i,this.emit("changed",this)}}},t.prototype._onModelRemoved=function(e){var t=this,n=this._requestService.getPath("root",e.getAssociatedResource()),r=this._contextService.toResource(n);if(r){var i=this._matches[r.toString()];i instanceof m&&this.deferredEmit(function(){t.remove(i),t._matches[r.toString()]=i._serverFileMatch})}},t.prototype.append=function(e){var t=this;e.forEach(function(e){var n=t._getOrAdd(e);n instanceof m&&(n=n._serverFileMatch),e.lineMatches.forEach(function(e){e.offsetAndLengths.forEach(function(t){var r=new p(n,e.preview,e.lineNumber,t[0],t[1]);n.add(r)})})})},t.prototype._getOrAdd=function(e){var t=this;return a.lookupOrInsert(this._matches,e.resource.toString(),function(){var r,i,o=t._contextService.toWorkspaceRelativePath(e.resource);r=o?n.URL.fromValue(t._requestService.getRequestUrl("root",o,!0)):n.URL.fromValue(e.resource.toString()),i=t._modelService.getModel(r);var s=new f(t,e.resource);return i&&t._query&&(s=new m(t,e.resource,t._query,i,s)),s})},t.prototype.remove=function(e){delete this._matches[e.resource().toString()],e.dispose(),this.emit("changed",this)},t.prototype.matches=function(){return a.values(this._matches)},t.prototype.isEmpty=function(){return 0===this.fileCount()},t.prototype.fileCount=function(){return Object.keys(this._matches).length},t.prototype.count=function(){return this.matches().reduce(function(e,t){return e+t.count()},0)},t.prototype.toggleHighlights=function(e){if(this._showHighlights!==e){this._showHighlights=e;for(var t in this._matches){var n=this._matches[t];n instanceof m&&n.updateHighlights()}}},t.prototype.dispose=function(){this._disposables=s.disposeAll(this._disposables),s.disposeAll(this.matches()),e.prototype.dispose.call(this)},t}(c.EventEmitter);t.SearchResult=g}),define("vs/workbench/contrib/search/searchQuery",["require","exports","vs/base/assert","vs/base/types","vs/base/objects","vs/base/lib/winjs.base","vs/base/lifecycle","vs/platform/services"],function(e,t,n,r,i,o,s,a){function c(e){var t=e&&e.files&&e.files.exclude,n=e&&e.search&&e.search.exclude;if(!t&&!n)return null;if(!t||!n)return t||n;var r=Object.create(null);return r=i.mixin(r,t),r=i.mixin(r,n,!0)}t.getExcludes=c;var u=function(){function e(e){var t=this;this.configurationService=e.configurationService,this.callOnDispose=[],this.callOnDispose.push(this.configurationService.addListener(a.ConfigurationServiceEventTypes.UPDATED,function(e){t.configurationPromise=o.Promise.as(e.config)}))}return e.prototype.dispose=function(){s.cAll(this.callOnDispose)},e.prototype.text=function(e,t){return this._query(a.Search.QueryType.Text,e,t)},e.prototype.file=function(e){return this._query(a.Search.QueryType.File,null,e)},e.prototype._query=function(e,t,n){return void 0===n&&(n={}),this.loadConfiguration().then(function(r){var o=r&&r.files&&r.files.encoding;n.fileEncoding=o;var s=c(r);return n.excludePattern?i.mixin(n.excludePattern,s,!1):n.excludePattern=s,new l(e,t,n)})},e.prototype.loadConfiguration=function(){return this.configurationPromise?this.configurationPromise:(this.configurationPromise=this.configurationService.loadConfiguration(),this.configurationPromise)},e}();t.QueryBuilder=u;var l=function(){function e(e,t,i){void 0===i&&(i={}),n.ok(!r.isUndefinedOrNull(e)),n.ok(e!==a.Search.QueryType.Text||t&&t.pattern&&0!==t.pattern.length),this._type=e,this._contentPattern=t,this._filePatterns=i.filePatterns||[],this._excludePattern=i.excludePattern,this._includePattern=i.includePattern,this._maxResults=i.maxResults,this._rootResources=i.rootResources,this._fileEncoding=i.fileEncoding}return Object.defineProperty(e.prototype,"type",{get:function(){return this._type},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"contentPattern",{get:function(){return this._contentPattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filePatterns",{get:function(){return this._filePatterns},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"excludePattern",{get:function(){return this._excludePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"includePattern",{get:function(){return this._includePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"maxResults",{get:function(){return this._maxResults},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"rootResources",{get:function(){return this._rootResources},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fileEncoding",{get:function(){return this._fileEncoding},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){return{type:this.type,contentPattern:this.contentPattern,filePatterns:this.filePatterns,excludePattern:this._excludePattern,includePattern:this._includePattern,maxResults:this._maxResults,rootResources:this._rootResources,fileEncoding:this._fileEncoding}},e}()});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/search/openFileHandler",["require","exports","vs/base/lib/winjs.base","vs/nls!vs/workbench/contrib/search/openAnythingHandler","vs/base/async","vs/base/paths","vs/base/ui/labels","vs/base/strings","vs/base/filters","vs/base/ui/comparers","vs/workbench/ui/quickopen/quickOpen","vs/workbench/contrib/search/searchModel","vs/workbench/contrib/search/searchQuery"],function(e,t,n,r,i,o,s,a,c,u,l,d,p){var h=function(e){function t(t,n,r,i){e.call(this,t.editorService),this.instantiationService=t.instantiationService,this.resource=r,this.name=n,this.description=s.getPathLabel(o.dirname(this.resource.fsPath),t.contextService),this.setHighlights(i)}return __extends(t,e),t.prototype.getLabel=function(){return this.name},t.prototype.getDescription=function(){return this.description},t.prototype.getIcon=function(){return"file"},t.prototype.getResource=function(){return this.resource},t.prototype.setRange=function(e){this.range=e},t.prototype.getInput=function(){var e={resource:this.resource};return this.range&&(e.options={selection:this.range}),e},t}(l.EditorQuickOpenEntry);t.FileEntry=h;var f=function(e){function t(n,r){void 0===r&&(r=!0),e.call(this),this.editorService=n.editorService,this.messageService=n.messageService,this.configurationService=n.configurationService,this.searchService=n.searchService,this.contextService=n.contextService,this.textFileService=n.textFileService,this.instantiationService=n.instantiationService,this.queryBuilder=this.instantiationService.createInstance(p.QueryBuilder),this.delayer=r?new i.ThrottledDelayer(t.SEARCH_DELAY):null}return __extends(t,e),t.prototype.dispose=function(){this.queryBuilder.dispose()},t.prototype.getResults=function(e){var t=this;return e=e.trim(),e?this.delayer?this.delayer.trigger(function(){return t.doFindResults(e)}):this.doFindResults(e):n.Promise.as([])},t.prototype.doFindResults=function(e){var t=this;this.cancelPendingSearch();var n=this.textFileService.getWorkingFilesModel().getOutOfWorkspaceContextEntries().map(function(e){return e.resource});this.contextService.getWorkspace()&&n.push(this.contextService.getWorkspace().resource);var r={filePatterns:[{pattern:e}],rootResources:n};return this.queryBuilder.file(r).then(function(e){return t.pendingSearch=t.searchService.search(e),t.pendingSearch}).then(function(n){t.pendingSearch=null;var r=t.instantiationService.createInstance(d.SearchResult);r.append(n.results);for(var i=[],o=r.matches().sort(function(n,r){return t.sort(n,r,e.toLowerCase())}),s=0;s<o.length;s++){var a=o[s],u=c.CombinedMatcher.matches(e,a.name());i.push(t.instantiationService.createInstance(h,a.name(),a.resource(),u))}return i})},t.prototype.sort=function(e,t,n){var r=e.name().toLowerCase(),i=t.name().toLowerCase(),o=e.resource().fsPath.lastIndexOf("."),s=t.resource().fsPath.lastIndexOf(".");if(o>0&&s>0){var c=e.resource().fsPath.substring(0,o),l=t.resource().fsPath.substring(0,s),d=e.resource().fsPath.substring(o),p=t.resource().fsPath.substring(s);if(!(c!==l||".ts"!==d&&".ts"!==p||".js"!==d&&".js"!==p))return".ts"===d?-1:1}var h=0===r.indexOf(n),f=0===i.indexOf(n);if(h!==f)return h?-1:1;var m=u.compareFileNames(r,i);return 0!==m?m:a.localeCompare(e.resource().fsPath,t.resource().fsPath)},t.prototype.getGroupLabel=function(){return r.localize("vs_workbench_contrib_search_openFileHandler",0)},t.prototype.getAutoFocus=function(){return{autoFocusFirstEntry:!0}},t.prototype.cancelPendingSearch=function(){this.pendingSearch&&(this.pendingSearch.cancel(),this.pendingSearch=null)},t.prototype.onClose=function(){this.cancelPendingSearch()},t.SEARCH_DELAY=500,t}(l.QuickOpenHandler);t.OpenFileHandler=f});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/search/openSymbolHandler",["require","exports","vs/base/lib/winjs.base","vs/nls!vs/workbench/contrib/search/openAnythingHandler","vs/base/errors","vs/base/async","vs/base/strings","vs/base/network","vs/workbench/constants","vs/platform/platform","vs/workbench/ui/quickopen/quickOpen","vs/editor/modes/modesExtensions","vs/base/filters","vs/workbench/ui/parts/editor/baseEditor","vs/base/ui/labels"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f){var m=function(e){function t(t,n,r,i,o,s,a,c){e.call(this,c),this.name=t,this.parameters=n,this.description=r,this.resource=i,this.type=o,this.range=s,this.setHighlights(a)}return __extends(t,e),t.prototype.getLabel=function(){return this.name+this.parameters},t.prototype.getName=function(){return this.name},t.prototype.getParameters=function(){return this.parameters},t.prototype.getDescription=function(){return this.description},t.prototype.getType=function(){return this.type},t.prototype.getIcon=function(){return this.type},t.prototype.getInput=function(){var e={resource:this.resource};return this.range&&(e.options={selection:this.range}),e},t}(l.EditorQuickOpenEntry),g=function(e){function t(n,r){void 0===r&&(r=!0),e.call(this),this.editorService=n.editorService,this.requestService=n.requestService,this.instantiationService=n.instantiationService,this.contextService=n.contextService,this.delayer=r?new o.ThrottledDelayer(t.SEARCH_DELAY):null}return __extends(t,e),t.prototype.canRun=function(){var e=u.Registry.as(d.Extensions.EditorModes),n=t.MIMES.some(function(t){return e.isRegisteredMode(t)});return n?!0:r.localize("vs_workbench_contrib_search_openSymbolHandler",0)},t.prototype.getResults=function(e){var t=this;return e=e.trim(),e?this.delayer?this.delayer.trigger(function(){return t.doGetResults(e)}):this.doGetResults(e):n.Promise.as([])},t.prototype.doGetResults=function(e){var r=this,o=null,s=this.editorService.getActiveEditorInput();if(s){var c=h.asFileEditorInput(s);c&&c.getResource()&&(o=new a.URL(c.getResource()))}var l=u.Registry.as(d.Extensions.EditorModes),p=n.Promise.join(t.MIMES.map(function(e){return l.getOrCreateMode(e)}));return p.then(function(){var s=[];return n.Promise.join(t.MIMES.map(function(t){var a=l.getMode(t);return a&&a.navigateTypesSupport?new n.Promise(function(t){a.navigateTypesSupport.getNavigateToItems(e,o).done(function(n){s.push.apply(s,r.toQuickOpenEntries(n,e)),t(s)},function(e){i.onUnexpectedError(e),t(s)})}):n.Promise.as(s)})).then(function(){return s})})},t.prototype.toQuickOpenEntries=function(e,n){for(var r=[],i=0;i<e.length;i++){var o=e[i];if(t.SUPPORTED_OPEN_TYPES.some(function(e){return o.type===e})){var s=p.CombinedMatcher.matches(n,o.name);if(s){var a=o.resourceUri;if("file"===a.scheme){var u=f.getPathLabel(a,this.contextService),l=void 0;l=o.containerName===u?u:o.containerName===a.toString()&&o.containerName.indexOf(c.SLASH)>=0?o.containerName.substr(o.containerName.lastIndexOf(c.SLASH)+1):o.containerName&&o.containerName.indexOf(".")>=0?o.containerName.substr(o.containerName.lastIndexOf(".")+1):o.containerName||u,r.push(new m(o.name,o.parameters,l,a,o.type,o.range,s,this.editorService))}}}}return r.sort(this.sort.bind(this,n.toLowerCase()))},t.prototype.sort=function(e,n,r){var i=n.getName().toLowerCase(),o=r.getName().toLowerCase(),a=s.localeCompare(i,o);if(0!==a)return a;var c=n.getType(),u=r.getType();return c!==u?t.SUPPORTED_OPEN_TYPES.indexOf(c)<t.SUPPORTED_OPEN_TYPES.indexOf(u)?-1:1:0},t.prototype.getGroupLabel=function(){return r.localize("vs_workbench_contrib_search_openSymbolHandler",1)},t.prototype.getEmptyLabel=function(e){return e.length>0?r.localize("vs_workbench_contrib_search_openSymbolHandler",2):r.localize("vs_workbench_contrib_search_openSymbolHandler",3)},t.prototype.getAutoFocus=function(e){return{autoFocusFirstEntry:!0,autoFocusPrefixMatch:e.trim()}},t.MIMES=["text/typescript","csharp"],t.SUPPORTED_OPEN_TYPES=["class","interface","enum","function","method"],t.SEARCH_DELAY=500,t}(l.QuickOpenHandler);t.OpenSymbolHandler=g});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/search/openAnythingHandler",["require","exports","vs/base/lib/winjs.base","vs/nls!vs/workbench/contrib/search/openAnythingHandler","vs/base/async","vs/base/types","vs/base/env","vs/base/strings","vs/base/filters","vs/workbench/ui/quickopen/quickOpen","vs/workbench/contrib/search/openFileHandler","vs/workbench/contrib/search/openSymbolHandler","vs/base/severity"],function(e,t,n,r,i,o,s,a,c,u,l,d,p){t.OpenSymbolHandler=d.OpenSymbolHandler;var h=function(e){function u(n){e.call(this),this.messageService=n.messageService,this.openSymbolHandler=n.instantiationService.createInstance(t.OpenSymbolHandler,!1,[]),this.openFileHandler=n.instantiationService.createInstance(l.OpenFileHandler,!1),this.resultsToSearchCache={},this.delayer=new i.ThrottledDelayer(u.SEARCH_DELAY)}return __extends(u,e),u.prototype.getResults=function(e){var t=this;if(e=e.trim(),this.isClosed=!1,!e)return n.Promise.as([]);var r=this.findRange(e);if(r){var i=e.indexOf("#")>=0?e.indexOf("#"):e.indexOf(":");i>=0&&(e=e.substring(0,i))}var o=this.getResultsFromCache(e,r);if(o)return n.Promise.as(o);var s=function(){var i=!1,o=[];if(r)o.push(n.Promise.as([]));else{var s=function(e){return n.Promise.timeout(e).then(function(){return i?n.Promise.as([]):s(u.SYMBOL_SEARCH_SUBSEQUENT_TIMEOUT)})},a=t.openSymbolHandler.getResults(e),c=s(u.SYMBOL_SEARCH_INITIAL_TIMEOUT);o.push(n.Promise.any([a,c]).then(function(e){return e.value}))}return o.push(t.openFileHandler.getResults(e).then(function(e){return i=!0,e})),n.Promise.join(o).then(function(n){if(t.isClosed)return[];var i=n[0].concat(n[1]);return i.sort(function(n,r){return t.sort(n,r,e.toLowerCase())}),i.forEach(function(e){e instanceof l.FileEntry&&e.setRange(r)}),t.resultsToSearchCache[e]=i,i},function(e){t.messageService.show(p.Error,e)})};return this.delayer.trigger(s)},u.prototype.findRange=function(e){var t=null,n=u.HASH_LINE_PATTERN.exec(e)||u.COLON_LINE_PATTERN.exec(e);if(n&&n.length>1){var r=parseInt(n[1],10);if(o.isNumber(r)){if(t={startLineNumber:r,startColumn:1,endLineNumber:r,endColumn:1},n.length>3){var i=parseInt(n[3],10);o.isNumber(i)&&(t.startColumn=i,t.endColumn=i)}}else""===n[1]&&(t={startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1})}return t},u.prototype.getResultsFromCache=function(e,t){var n=this;void 0===t&&(t=null);var r;for(var i in this.resultsToSearchCache)if(this.resultsToSearchCache.hasOwnProperty(i)&&0===e.indexOf(i)){r=this.resultsToSearchCache[i];break}if(!r)return null;for(var o=[],s=0;s<r.length;s++){var a=r[s];if(!t||a instanceof l.FileEntry){var u=c.CombinedMatcher.matches(e,a.getLabel());u&&(a.setHighlights(u),o.push(a))}}return o.sort(function(t,r){return n.sort(t,r,e.toLowerCase())}),o.forEach(function(e){e instanceof l.FileEntry&&e.setRange(t)}),o},u.prototype.sort=function(e,t,n){var r=e.getLabel().toLowerCase(),i=t.getLabel().toLowerCase(),o=r.lastIndexOf("."),s=i.lastIndexOf(".");if(o>0&&s>0){var c=r.substring(0,o),u=i.substring(0,s),l=r.substring(o),d=i.substring(s);if(!(c!==u||".ts"!==l&&".ts"!==d||".js"!==l&&".js"!==d))return".ts"===l?-1:1}var p=0===r.indexOf(n),h=0===i.indexOf(n);return p!==h?p?-1:1:r.length<i.length?-1:r.length>i.length?1:a.localeCompare(r,i)},u.prototype.getGroupLabel=function(){return r.localize("vs_workbench_contrib_search_openAnythingHandler",0)},u.prototype.getAutoFocus=function(){return{autoFocusFirstEntry:!0}},u.prototype.onClose=function(e){this.isClosed=!0,this.resultsToSearchCache={},this.openSymbolHandler.onClose(e),this.openFileHandler.onClose(e)},u.HASH_LINE_PATTERN=/#(\d*)(:(\d*))?$/,u.COLON_LINE_PATTERN=/:(\d*)(:(\d*))?$/,u.SYMBOL_SEARCH_INITIAL_TIMEOUT=s.isNative?500:1e3,u.SYMBOL_SEARCH_SUBSEQUENT_TIMEOUT=100,u.SEARCH_DELAY=s.isNative?100:500,u}(u.QuickOpenHandler);t.OpenAnythingHandler=h});